This file describes changes in recent versions of Slurm. It primarily
documents those changes that are of interest to users and administrators.

* Changes in Slurm 24.11.5
==========================
 -- Return error to scontrol reboot on bad nodelists.
 -- slurmrestd - Report an error when QOS resolution fails for v0.0.40
    endpoints.
 -- slurmrestd - Report an error when QOS resolution fails for v0.0.41
    endpoints.
 -- slurmrestd - Report an error when QOS resolution fails for v0.0.42
    endpoints.
 -- data_parser/v0.0.42 - Added +inline_enums flag which modifies the
    output when generating OpenAPI specification. It causes enum arrays to not
    be defined in their own schema with references ($ref) to them. Instead they
    will be dumped inline.
 -- Fix binding error with tres-bind map/mask on partial node allocations.
 -- Fix stepmgr enabled steps being able to request features.
 -- Reject step creation if requested feature is not available in job.
 -- slurmd - Restrict listening for new incoming RPC requests further into
    startup.
 -- slurmd - Avoid auth/slurm related hangs of CLI commands during startup
    and shutdown.
 -- slurmctld - Restrict processing new incoming RPC requests further into
    startup. Stop processing requests sooner during shutdown.
 -- slurmcltd - Avoid auth/slurm related hangs of CLI commands during
    startup and shutdown.
 -- slurmctld: Avoid race condition during shutdown or reconfigure that
    could result in a crash due delayed processing of a connection while
    plugins are unloaded.
 -- Fix small memleak when getting the job list from the database.
 -- Fix incorrect printing of % escape characters when printing stdio
    fields for jobs.
 -- Fix padding parsing when printing stdio fields for jobs.
 -- Fix printing %A array job id when expanding patterns.
 -- Fix reservations causing jobs to be held for Bad Constraints
 -- switch/hpe_slingshot - Prevent potential segfault on failed curl
    request to the fabric manager.
 -- Fix printing incorrect array job id when expanding stdio file names.
    The %A will now be substituted by the correct value.
 -- Fix printing incorrect array job id when expanding stdio file names.
    The %A will now be substituted by the correct value.
 -- switch/hpe_slingshot - Fix vni range not updating on slurmctld restart
    or reconfigre.
 -- Fix steps not being created when using certain combinations of -c and
    -n inferior to the jobs requested resources, when using stepmgr and nodes
    are configured with CPUs == Sockets*CoresPerSocket.
 -- Permit configuring the number of retry attempts to destroy CXI service
    via the new destroy_retries SwitchParameter.
 -- Do not reset memory.high and memory.swap.max in slurmd startup or
    reconfigure as we are never really touching this in slurmd.
 -- Fix reconfigure failure of slurmd when it has been started manually and
    the CoreSpecLimits have been removed from slurm.conf.
 -- Set or reset CoreSpec limits when slurmd is reconfigured and it was
    started with systemd.
 -- switch/hpe-slingshot - Make sure the slurmctld can free step VNIs after
    the controller restarts or reconfigures while the job is running.
 -- Fix backup slurmctld failure on 2nd takeover.
 -- Testsuite - fix python test 130_2.
 -- Fix security issue where a coordinator could add a user with elevated
    privileges. CVE-2025-43904.

* Changes in Slurm 24.11.4
==========================
 -- slurmctld,slurmrestd - Avoid possible race condition that could have caused
    process to crash when listener socket was closed while accepting a new
    connection.
 -- slurmrestd - Avoid race condition that could have resulted in address
    logged for a UNIX socket to be incorrect.
 -- slurmrestd - Fix parameters in OpenAPI specification for the following
    endpoints to have "job_id" field:
    GET /slurm/v0.0.40/jobs/state/
    GET /slurm/v0.0.41/jobs/state/
    GET /slurm/v0.0.42/jobs/state/
    GET /slurm/v0.0.43/jobs/state/
 -- slurmd - Fix tracking of thread counts that could cause incoming
    connections to be ignored after burst of simultaneous incoming connections
    that trigger delayed response logic.
 -- Stepmgr - Avoid unnecessary SRUN_TIMEOUT forwarding to stepmgr.
 -- Fix jobs being scheduled on higher weighted powered down nodes.
 -- Fix how backfill scheduler filters nodes from the available nodes based on
    exclusive user and mcs_label requirements.
 -- acct_gather_energy/{gpu,ipmi} - Fix potential energy consumption adjustment
    calculation underflow.
 -- acct_gather_energy/ipmi - Fix regression introduced in 24.05.5 (which
    introduced the new way of preserving energy measurements through slurmd
    restarts) when EnergyIPMICalcAdjustment=yes.
 -- Prevent slurmctld deadlock in the assoc mgr.
 -- Fix memory leak when RestrictedCoresPerGPU is enabled.
 -- Fix preemptor jobs not entering execution due to wrong calculation of
    accounting policy limits.
 -- Fix certain job requests that were incorrectly denied with node
    configuration unavailable error.
 -- slurmd - Avoid crash due when slurmd has a communications failure with
    slurmstepd.
 -- Fix memory leak when parsing yaml input.
 -- Prevent slurmctld from showing error message about PreemptMode=GANG being a
    cluster-wide option for `scontrol update part` calls that don't attempt to
    modify partition PreemptMode.
 -- Fix setting GANG preemption on partition when updating PreemptMode with
    scontrol.
 -- Fix CoreSpec and MemSpec limits not being removed from previously
    configured slurmd.
 -- Avoid race condition that could lead to a deadlock when slurmd, slurmstepd,
    slurmctld, slurmrestd or sackd have a fatal event.
 -- Fix jobs using --ntasks-per-node and --mem keep pending forever when the
    requested mem divided by the number of cpus will surpass the configured
    MaxMemPerCPU.
 -- slurmd - Fix address logged upon new incoming RPC connection from "INVALID"
    to IP address.
 -- Fix memory leak when retrieving reservations. This affects scontrol, sinfo,
    sview, and the following slurmrestd endpoints:
    'GET /slurm/{any_data_parser}/reservation/{reservation_name}'
    'GET /slurm/{any_data_parser}/reservations'
 -- Log warning instead of debuflags=conmgr gated log when deferring new
    incoming connections when number of active connections exceed
    conmgr_max_connections.
 -- Avoid race condition that could result in worker thread pool not activating
    all threads at once after a reconfigure resulting in lower utilization of
    available CPU threads until enough internal activity wakes up all threads
    in the worker pool.
 -- Avoid theoretical race condition that could result in new incoming RPC
    socket connections being ignored after reconfigure.
 -- slurmd - Avoid race condition that could result in a state where new
    incoming RPC connections will always be ignored.
 -- Add ReconfigFlags=KeepNodeStateFuture to restore saved FUTURE node state on
    restart and reconfig instead of reverting to FUTURE state. This will be
    made the default in 25.05.
 -- Fix case where hetjob submit would cause slurmctld to crash.
 -- Fix jobs using --cpus-per-gpu and --mem keep pending forever when the
    requested mem divided by the number of cpus will surpass the configured
    MaxMemPerCPU.
 -- Enforce that jobs using --mem and several --*-per-* options do not violate
    the MaxMemPerCPU in place.
 -- slurmctld - Fix use-cases of jobs incorrectly pending held when --prefer
    features are not initially satisfied.
 -- slurmctld - Fix jobs incorrectly held when --prefer not satisfied in some
    use-cases.
 -- Ensure RestrictedCoresPerGPU and CoreSpecCount don't overlap.

* Changes in Slurm 24.11.3
==========================
 -- Fix race condition in slurmrestd that resulted in "Requested
    data_parser plugin does not support OpenAPI plugin" error being returned
    for valid endpoints.
 -- If multiple partitions are requested, set the SLURM_JOB_PARTITION
    output environment variable to the partition in which the job is running
    for salloc and srun in order to match the documentation and the behavior of
    sbatch.
 -- Fix regression where slurmd -G gives no output.
 -- Don't print misleading errors for stepmgr enabled steps.
 -- slurmrestd - Avoid connection to slurmdbd for the following
    endpoints:
    GET /slurm/v0.0.41/jobs
    GET /slurm/v0.0.41/job/{job_id}
 -- slurmrestd - Avoid connection to slurmdbd for the following
    endpoints:
    GET /slurm/v0.0.40/jobs
    GET /slurm/v0.0.40/job/{job_id}
 -- Significantly increase entropy of clusterid portion of the
    sluid by seeding the random number generator
 -- Avoid changing process name to "watch" from original daemon name.
    This could potentially breaking some monitoring scripts.
 -- Avoid slurmctld being killed by SIGALRM due to race condition
    at startup.
 -- Fix slurmctld crash when after updating a reservation with an empty
    nodelist. The crash could occur after restarting slurmctld, or if
    downing/draining a node in the reservation with the REPLACE or REPLACE_DOWN
    flag.
 -- Fix race between task/cgroup cpuset and jobacctgather/cgroup.
    The first was removing the pid from task_X cgroup directory causing
    memory limits to not be applied.
 -- srun - Fixed wrongly constructed SLURM_CPU_BIND env variable
    that could get propagated to downward srun calls in certain mpi
    environments, causing launch failures.
 -- slurmrestd - Fix possible memory leak when parsing arrays with
    data_parser/v0.0.40.
 -- slurmrestd - Fix possible memory leak when parsing arrays with
    data_parser/v0.0.41.
 -- slurmrestd - Fix possible memory leak when parsing arrays with
    data_parser/v0.0.42.

* Changes in Slurm 24.11.2
==========================
 -- Fix segfault when submitting --test-only jobs that can preempt.
 -- Fix regression introduced in 23.11 that prevented the following
    flags from being added to a reservation on an update:
    DAILY, HOURLY, WEEKLY, WEEKDAY, and WEEKEND.
 -- Fix crash and issues evaluating job's suitability for running in
    nodes with already suspended job(s) there.
 -- Slurmctld will ensure that healthy nodes are not reported as
    UnavailableNodes in job reason codes.
 -- Fix handling of jobs submitted to a current reservation with
    flags OVERLAP,FLEX or OVERLAP,ANY_NODES when it overlaps nodes with a
    future maintenance reservation. When a job submission had a time limit that
    overlapped with the future maintenance reservation, it was rejected. Now
    the job is accepted but stays pending with the reason "ReqNodeNotAvail,
    Reserved for maintenance".
 -- pam_slurm_adopt - avoid errors when explicitly setting
    some arguments to the default value.
 -- Fix qos preemption with PreemptMode=SUSPEND
 -- slurmdbd - When changing a user's name update lineage
    at the same time.
 -- Fix regression in 24.11 in which burst_buffer.lua does not
    inherit the SLURM_CONF environment variable from slurmctld and fails to run
    if slurm.conf is in a non-standard location.
 -- Fix memory leak in slurmctld if select/linear and the
    PreemptParameters=reclaim_licenses options are both set in slurm.conf.
    Regression in 24.11.1.
 -- Fix running jobs, that requested multiple partitions, from
    potentially being set to the wrong partition on restart.
 -- switch/hpe_slingshot - Fix compatibility with newer cxi
    drivers, specifically when specifying disable_rdzv_get.
 -- Add ABORT_ON_FATAL environment variable to capture a backtrace
    from any fatal() message.
 -- Fix printing invalid address in rate limiting log statement.
 -- sched/backfill - Fix node state PLANNED not being cleared from
    fully allocated nodes during a backfill cycle.
 -- select/cons_tres - Fix future planning of jobs with bf_licenses.
 -- Prevent redundant "on_data returned rc: Rate limit exceeded,
    please retry momentarily" error message from being printed in
    slurmctld logs.
 -- Fix loading non-default QOS on pending jobs from pre-24.11 state.
 -- Fix pending jobs displaying QOS=(null) when not explicitly
    requesting a QOS.
 -- Fix segfault issue from job record with no job_resrcs
 -- Fix failing sacctmgr delete/modify/show account operations
    with where clauses.
 -- Fix regression in 24.11 in which Slurm daemons started catching
    several SIGTSTP, SIGTTIN and SIGUSR1 signals and ignored them, while before
    they were not ignoring them. This also caused slurmctld to not being
    able to shutdown after a SIGTSTP because slurmscriptd caught the signal
    and stopped while slurmctld ignored it. Unify and fix these situations and
    get back to the previous behavior for these signals.
 -- Document that SIGQUIT is no longer ignored by slurmctld,
    slurmdbd, and slurmd in 24.11. As of 24.11.0rc1, SIGQUIT is identical to
    SIGINT and SIGTERM for these daemons, but this change was not documented.
 -- Fix not considering nodes marked for reboot without ASAP
    in the scheduler.
 -- Remove the boot^ state on unexpected node reboot after
    return to service.
 -- Do not allow new jobs to start on a node which is being rebooted
    with the flag nextstate=resume.
 -- Prevent lower priority job running after cancelling an ASAP reboot.
 -- Fix srun jobs starting on nextstate=resume rebooting nodes.

* Changes in Slurm 24.11.1
==========================
 -- With client commands MIN_MEMORY will show mem_per_tres if specified.
 -- Fix errno message about bad constraint
 -- slurmctld - Fix crash and possible split brain issue if the
    backup controller handles an scontrol reconfigure while in control
    before the primary resumes operation.
 -- Fix stepmgr not getting dynamic node addrs from the controller
 -- stepmgr - avoid "Unexpected missing socket" errors.
 -- Fix `scontrol show steps` with dynamic stepmgr
 -- Deny jobs using the "R:" option of --signal if PreemptMode=OFF
    globally.
 -- Force jobs using the "R:" option of --signal to be preemptable
    by requeue or cancel only. If PreemptMode on the partition or QOS is off
    or suspend, the job will default to using PreemptMode=cancel.
 -- If --mem-per-cpu exceeds MaxMemPerCPU, the number of cpus per
    task will always be increased even if --cpus-per-task was specified. This
    is needed to ensure each task gets the expected amount of memory.
 -- Fix compilation issue on OpenSUSE Leap 15
 -- Fix jobs using more nodes than needed when not using -N
 -- Fix issue with allocation being allocated less resources
    than needed when using --gres-flags=enforce-binding.
 -- select/cons_tres - Fix errors with MaxCpusPerSocket partition
    limit. Used cpus/cores weren't counted properly, nor limiting free ones
    to avail, when the socket was partially allocated, or the job request
    went beyond this limit.
 -- Fix issue when jobs were preempted for licenses even if there
    were enough licenses available.
 -- Fix srun ntasks calculation inside an allocation when nodes are
    requested using a min-max range.
 -- Print correct number of digits for TmpDisk in sdiag.
 -- Fix a regression in 24.11 which caused file transfers to a job
    with sbcast to not join the job container namespace.
 -- data_parser/v0.0.40 - Prevent a segfault in the slurmrestd when
    dumping data with v0.0.40+complex data parser.
 -- Remove logic to force lowercase GRES names.
 -- data_parser/v0.0.42 - Prevent the association id from always
    being dumped as NULL when parsing in complex mode. Instead it will now
    dump the id. This affects the following endpoints:
    GET slurmdb/v0.0.42/association
    GET slurmdb/v0.0.42/associations
    GET slurmdb/v0.0.42/config
 -- Fixed a job requeuing issue that merged job entries into the
    same SLUID when all nodes in a job failed simultaneously.
 -- When a job completes, try to give idle nodes to reservations with
    the REPLACE flag before allowing them to be allocated to jobs.
 -- Avoid expensive lookup of all associations when dumping or
    parsing for v0.0.42 endpoints.
 -- Avoid expensive lookup of all associations when dumping or
    parsing for v0.0.41 endpoints.
 -- Avoid expensive lookup of all associations when dumping or
    parsing for v0.0.40 endpoints.
 -- Fix segfault when testing jobs against nodes with invalid gres.
 -- Fix performance regression while packing larger RPCs.
 -- Document the new mcs/label plugin.
 -- job_container/tmpfs - Fix Xauthoirty file being created
    outside the container when EntireStepInNS is enabled.
 -- job_container/tmpfs - Fix spank_task_post_fork not always
    running in the container when EntireStepInNS is enabled.
 -- Fix a job potentially getting stuck in CG on permissions
    errors while setting up X11 forwarding.
 -- Fix error on X11 shutdown if Xauthority file was not created.
 -- slurmctld - Fix memory or fd leak if an RPC is recieved that
    is not registered for processing.
 -- Inject OMPI_MCA_orte_precondition_transports when using PMIx. This fixes
    mpi apps using Intel OPA, PSM2 and OMPI 5.x when ran through srun.
 -- Don't skip the first partition_job_depth jobs per partition.
 -- Fix gres allocation issue after controller restart.
 -- Fix issue where jobs requesting cpus-per-gpu hang in queue.
 -- switch/hpe_slingshot - Treat HTTP status forbidden the same as
    unauthorized, allowing for a graceful retry attempt.

* Changes in Slurm 24.11.0
==========================
 -- slurmctld - Reject arbitrary distribution jobs that do not specifying a task
    count.
 -- Fix backwards compatibility of the RESPONSE_JOB_INFO RPC (used by squeue,
    scontrol show job, etc.) with Slurm clients version 24.05 and below. This
    was a regression in 24.11.0rc1.
 -- Do not let slurmctld/slurmd to start if there are more nodes defined in
    slurm.conf than the maximum supported amount (64k nodes).
 -- slurmctld - Set job's exit code to 1 when a job fails with state
    JOB_NODE_FAIL. This fixes "sbatch --wait" not being able to exit with error
    code when a job fails for this reason in some cases.
 -- Fix certain reservation updates requested from 23.02 clients.
 -- slurmrestd - Fix populating non-required object fields of objects as '{}' in
    JSON/YAML instead of 'null' causing compiled OpenAPI clients to reject
    the response to 'GET /slurm/v0.0.40/jobs' due to validation failure of
    '.jobs[].job_resources'.
 -- Fix issue where older versions of Slurm talking to a 24.11 dbd could
    loose step accounting.
 -- Fix minor memory leaks.
 -- Fix bad memory reference when xstrchr fails to find char.
 -- Remove duplicate checks for a data structure.
 -- Fix race condition in stepmgr step completion handling.
 -- slurm.spec - add ability to specify patches to apply on the command line
 -- slurm.spec - add ability to supply extra version information
 -- Fix 24.11 HA issues.
 -- Fix requeued jobs keeping their priority until the decay thread happens.
 -- Fix potential memory corruption in select/cons_tres plugin.
 -- Avoid cache coherency issue on non-x86 platforms that could result in a
    POSIX signal being ignored or an abort().
 -- slurmctld - Remove assertion in development builds that would trigger if
    an outdated client attempted to connect.
 -- slurmd - Wait for PrologEpilogTimeout on reconfigure for prologs to finish.
    This avoids a situation where the slurmd never detects that the prolog
    completed.
 -- job_container/tmpfs - Setup x11 forwarding within the namespace.

* Changes in Slurm 24.11.0rc2
=============================
 -- slurmctld - fix memory leak when sending a DBD_JOB_START message.
 -- Fix issue with accounting rollup dealing with association tables.
 -- Fix minor memory leaks.
 -- Fix potential thread safety issues.
 -- Init mutex in burst_buffer plugins.
 -- slurmdbd - don't log errors when no changes occur from db requests.
 -- slurmcltd,slurmd - Avoid deadlock during reconfigure if too many POSIX
    signals are received.

* Changes in Slurm 24.11.0rc1
=============================
 -- Improve error type logged from partial or incomplete reading from socket or
    pipe to avoid potentially logging an error from a previous syscall.
 -- slurmrestd - Improve the handling of queries when unable to connect to
    slurmdbd by providing responses when possible.
 -- slurmrestd,sackd,scrun - Avoid rare hangs related to I/O.
 -- scrun - Add support '--all' argument for kill subcommand.
 -- Remove srun --cpu-bind=rank.
 -- Add resource_spec/cpus and resource_spec/memory entry points in data_parser
    to print the CpuSpecList and MemSpecLimit in sinfo --json.
 -- sinfo - Add '.sinfo[].resource_spec.cpus' and
    '.sinfo[].resource_spec.memory' fields to print the CpuSpecList and
    MemSpecLimit dumped by 'sinfo --{json|yaml}'.
 -- Increase efficency of sending logs to syslog.
 -- Switch to new official YAML mime type "application/yaml" in compliance with
    RFC9512 as primary mime type for YAML formatting.
 -- slurmrestd - Removed deprecated fields from the following endpoints:
	'.result' from 'POST /slurm/v0.0.42/job/submit'.
	'.job_id', '.step_id', '.job_submit_user_msg' from 'POST /slurm/v0.0.42/job/{job_id}'.
	'.job.exclusive', '.jobs[].exclusive' to 'POST /slurm/v0.0.42/job/submit'.
	'.jobs[].exclusive' from 'GET /slurm/v0.0.42/job/{job_id}'.
	'.jobs[].exclusive' from 'GET /slurm/v0.0.42/jobs'.
	'.job.oversubscribe', '.jobs[].oversubscribe' to 'POST /slurm/v0.0.42/job/submit'.
	'.jobs[].oversubscribe' from 'GET /slurm/v0.0.42/job/{job_id}'.
	'.jobs[].oversubscribe' from 'GET /slurm/v0.0.42/jobs'.
 -- scontrol - Removed deprecated fields '.jobs[].exclusive' and
    '.jobs[].oversubscribe' from 'scontrol show jobs --{json|yaml}'.
 -- squeue - Removed deprecated fields '.jobs[].exclusive' and
    '.jobs[].oversubscribe' from 'squeue --{json|yaml}'.
 -- Improve the way to run external commands and fork processes to avoid
    non-async-signal safe calls between a fork and an exec. We fork ourselves
    now and executes the commands in a safe environment. This includes spank
    prolog/epilog executions.
 -- Improve MaxMemPerCPU enforcement when exclusive jobs request per node memory
    and the partition has heterogeneous nodes.
 -- Remove a TOCTOU where multiple steps requesting an energy reading at the
    same time could cause too frequent accesses to the drivers.
 -- Limit SwitchName to HOST_NAME_MAX chars length.
 -- For scancel --ctld and the following rest api endpoints:
      'DELETE /slurm/v0.0.40/jobs'
      'DELETE /slurm/v0.0.41/jobs'
      'DELETE /slurm/v0.0.42/jobs'
    Support array expressions in the responses to the client.
 -- salloc - Always output node names to the user when an allocation is granted.
 -- slurmrestd - Removed all v0.0.39 endpoints.
 -- select/linear - Reject jobs asking for GRES per job|socket|task or
    cpus|mem per GRES.
 -- Add /nodes POST endpoint to REST API, supports multiple node update whereas
    previously only single nodes could be updated through /node/<nodename>
    endpoint:
      'POST /slurm/v0.0.42/nodes'
 -- Do not allow changing or setting PreemptMode=GANG to a partition as this is
    a cluster-wide option.
 -- Add "%b" as a file name pattern for the array task id modulo 10.
 -- Skip packing empty nodes when they are hidden during REQUEST_NODE_INFO RPC.
 -- accounting_storage/mysql - Avoid a fatal condition when the db server is
    not reachable.
 -- Always lay out steps cyclically on nodes in an allocation.
 -- squeue - add priority by partition ('.jobs[].priority_by_partition') to
    JSON and YAML output.
 -- slurmrestd - Add clarification to "failed to open slurmdbd connection" error
    if the error was the result of an authentication failure.
 -- Make it so slurmctld responds to RPCs that have authenticaiton errors with
    the SLURM_PROTOCOL_AUTHENTICATION_ERROR error code.
 -- openapi/slurmctld - Display the correct error code instead of
    "Unspecified error" if querying the following endpoints fails:
      'GET /slurm/v0.0.40/diag/'
      'GET /slurm/v0.0.41/diag/'
      'GET /slurm/v0.0.42/diag/'
      'GET /slurm/v0.0.40/licenses/'
      'GET /slurm/v0.0.41/licenses/'
      'GET /slurm/v0.0.42/licenses/'
      'GET /slurm/v0.0.40/reconfigure'
      'GET /slurm/v0.0.41/reconfigure'
      'GET /slurm/v0.0.42/reconfigure'
 -- Fix how used cpus are tracked in a job allocation to allow the max number of
    concurrent steps to run at a time if threads per core is greater than 1.
 -- In existing allocations SLURM_GPUS_PER_NODE environment variable will be
    ignored by srun if --gpus is specified.
 -- When using --get-user-env explicitly or implicitly, check if PID or mnt
    namespaces are disabled and fall back to old logic that does not rely on
    them when they are not available.
 -- Removed non-functional option SLURM_PROLOG_CPU_MASK from TaskProlog which
    was used to reset the affinity of a task based on the mask given.
 -- slurmrestd - Support passing of '-d latest' to load latest version of
    data_parser plugin.
 -- sacct,sacctmgr,scontrol,sdiag,sinfo,squeue,sshare - Change response to
    '--json=list' or '--yaml=list' to send list of plugins to stdout and
    descriptive header to stderr to allow for easier parsing.
 -- slurmrestd - Change response to '-d list', '-a list' or '-s list' to send
    list of plugins to stdout and descriptive header to stderr to allow for
    easier parsing.
 -- sacct,sacctmgr,scontrol,sdiag,sinfo,squeue,sshare,slurmrestd - Avoid crash
    when loading data_parser plugins fail due to NULL dereference.
 -- Add autodetected gpus to the output of slurmd -C
 -- Remove burst_buffer/lua call slurm.job_info_to_string().
 -- Add SchedulerParameters=bf_allow_magnetic_slot option. It allows jobs in
    magnetic reservations to be planned by backfill scheduler.
 -- slurmrestd - Refuse to run as root, SlurmUser, and nobody(99).
 -- openapi/slurmctld - Revert regression that caused signaling jobs to cancel
    entire job arrays instead of job array tasks:
      'DELETE /slurm/v0.0.40/{job_id}'
      'DELETE /slurm/v0.0.41/{job_id}'
      'DELETE /slurm/v0.0.42/{job_id}'
 -- openapi/slurmctld - Support more formats for {job_id} including job steps:
      'DELETE /slurm/v0.0.40/{job_id}'
      'DELETE /slurm/v0.0.41/{job_id}'
      'DELETE /slurm/v0.0.42/{job_id}'
 -- Alter scheduling of jobs at submission time to consider job submission time
    and job id. This makes it so that that interactive jobs aren't allocated
    resources before batch jobs when they have the same priority at submit time.
 -- Fix multi-cluster submissions with differing Switch plugins.
 -- slurmrestd - Change +prefer_refs flag to default in data_parser/v0.0.42
    plugin. Add +minimize_refs flag to inline single referenced schemas in the
    OpenAPI schema. This sets the default OpenAPI schema generation behavior of
    data_parser/v0.0.42 to match v0.0.41+prefer_refs and v0.0.40 (without
    flags).
 -- Fix LaunchParameters=batch_step_set_cpu_freq.
 -- Clearer seff warning message for running jobs.
 -- data_parser/v0.0.42 - Rename JOB_INFO field "minimum_switches" to
    "required_switches" to reflect the actual behavior.
 -- data_parser/v0.0.42 - Rename ACCOUNT_CONDITION field "assocation" to
    "association" to fix typo.
 -- cgroup/v2 - fix cgroup cleanup when running inside a container without write
    permissions to /sys/fs/cgroup.
 -- cgroup/v2 - fix accounting of swap events detection.
 -- Fix gathering MaxRSS for jobs that run shorter than two jobacctgather
    intevals. Get the metrics from cgroups memory.peak or
    memory.max_usage_in_bytes where available.
 -- openapi/slurmctld - Set complex number support for the following fields:
      .shares[][].fairshare.factor
      .shares[][].fairshare.level
    for endpoints:
      'GET /slurm/v0.0.42/shares'
    and for commands:
      sshare --json
      sshare --yaml
 -- data_parser/v0.0.42 - Avoid dumping "Infinity" for NO_VAL tagged "number"
    fields.
 -- Add TopologyParam=TopoMaxSizeUnroll=# to allow --nodes=<min>-<max> for
    topology/block.
 -- sacct - Respect --noheader for --batch-script and --env-vars.
 -- sacct - Remove extra newline in output from --batch-script and --env-vars.
 -- Add "sacctmgr ping" command to query status of slurmdbd.
 -- Generate an error message when a NodeSet name conflicts with a NodeName, and
    prevent the controller from starting if such a conflict exists.
 -- slurmd - properly detect slurmd restarts in the energy gathering logic
    which caused bad numbers in accounting.
 -- sackd - retry fetching slurm configs indefinately in configless mode.
 -- job_submit/lua - Add "assoc_qos" attribute to job_desc to display all
    potential QOS's for a job's association.
 -- job_submit/lua - Add slurm.get_qos_priority() function to retrieve the
    given QOS's priority.
 -- sbcast - Add --nodelist option to specify where files are transmitted to
 -- sbcast - Add --no-allocation option to transmit files to nodes outside of a
    job allocation
 -- Add DataParserParameters slurm.conf parameter to allow setting default
    value for CLI --json and --yaml arguments.
 -- seff - improve step's max memory consumption report by using TresUsageInTot
    and TresUsageInAve instead of overestimating the values.
 -- Enable RPC queueing for REQUEST_KILL_JOBS, which is used when scancel is
    executed with --ctld flag.
 -- slurmdbd - Add -u option. This is used to determine if restarting the DBD
    will result in database conversion.
 -- Fix srun inside an salloc in a federated cluster when using IPv6.
 -- Calculate the forwarding timeouts according to tree depth rather than
    node count / tree width for each level. Fixes race conditions with same
    timeouts between two consecutive node levels.
 -- Add ability to submit jobs with multiple QOS.
 -- Fix difference in behavior when swapping partition order in job submission.
 -- Improve PLANNED state detection for mixed nodes and updating state before
    yielding backfill locks.
 -- Always consider partition priority tiers when deciding to try scheduling
    jobs on submit.
 -- Prevent starting jobs without reservations on submit when there are pending
    jobs with reservations that have flags FLEX or ANY_NODES that can be
    scheduled on overlapping nodes.
 -- Prevent jobs that request both high and low priority tier partitions from
    starting on submit in lower priority tier partitions if it could delay
    pending jobs in higher priority tier partitions.
 -- scontrol - Wait for slurmctld to start reconfigure in foreground mode
    before returning.
 -- Improve reconfigure handling on Linux to only close open file descriptors
    to avoid long delays on systems with large RLIMIT_NOFILE settings.
 -- salloc - Removed --get-user-env option.
 -- Removed the instant on feature from switch/hpe_slingshot.
 -- Hardware collectives in switch/hpe_slingshot now requires enable_stepmgr.
 -- Allow backfill to plan jobs on nodes currently being used by exclusive user
    or mcs jobs.
 -- Avoid miscaching IPv6 address to hostname lookups that could have caused
    logs to have the incorrect hostname.
 -- scontrol - Add --json/--yaml support to listpids
 -- scontrol - Add liststeps
 -- scontrol - Add listjobs
 -- slurmrestd - Avoid connection to slurmdbd for the following endpoints:
      GET /slurm/v0.0.42/jobs
      GET /slurm/v0.0.42/job/{job_id}
 -- slurmctld - Changed incoming RPC handling to dedicated thread pool.
 -- job_container/tmpfs - Add EntireStepInNS option that will place the
    slurmstepd process within the constructed namespace directly.
 -- scontrol show topo - Show aggregated block sizes when using topology/block.
 -- slurmrestd - Add more descriptive HTTP status for authentication failure
    and connectivity errors with controller.
 -- slurmrestd - Improve reporting errors from slurmctld for job queries:
      'GET /slurm/v0.0.41/{job_id}'
      'GET /slurm/v0.0.41/jobs/'
 -- Avoid rejecting a step request that needs fewer gres than nodes in the
    job allocation.
 -- slurmrestd - Tag the never populated '.jobs[].pid' field as deprecated for
    the following endpoints:
      'GET /slurm/v0.0.42/{job_id}'
      'GET /slurm/v0.0.42/jobs/'
 -- scontrol,squeue - Tag the never populated '.jobs[].pid' field as deprecated
    for the following:
      'scontrol show jobs --json'
      'scontrol show jobs --yaml'
      'scontrol show job ${JOB_ID} --json'
      'scontrol show job ${JOB_ID} --yaml'
      'squeue --json'
      'squeue --yaml'
 -- data_parser v0.0.42 - fix timestamp parsing regression introduced in in
    v0.0.40 (eaf3b6631f), parsing of non iso 8601 style timestamps
 -- cgroup/v2 will detect some special container and namespaced setups and
    will work with it.
 -- Support IPv6 in configless mode.
 -- Add SlurmctldParamters=ignore_constraint_validation to ignore
    constraint/feature validation at submission.
 -- slurmrestd - Set '.pings[].mode' field as deprecated in the following
    endpoints:
      'GET /slurm/v0.0.42/ping'
 -- scontrol - Set '.pings[].mode' field as deprecated in the following
    commands:
      'scontrol ping --json'
      'scontrol ping --yaml'
 -- slurmrestd - Set '.pings[].pinged' field as deprecated in the following
    endpoints:
      'GET /slurm/v0.0.42/ping'
 -- scontrol - Set '.pings[].pinged' field as deprecated in the following
    commands:
      'scontrol ping --json'
      'scontrol ping --yaml'
 -- slurmrestd - Add '.pings[].primary' field to the following endpoints:
      'GET /slurm/v0.0.42/ping'
 -- scontrol - Add '.pings[].primary' field to the following commands:
      'scontrol ping --json'
      'scontrol ping --yaml'
 -- slurmrestd - Add '.pings[].responding' field to the following endpoints:
      'GET /slurm/v0.0.42/ping'
 -- scontrol - Add '.pings[].responding' field to the following commands:
      'scontrol ping --json'
      'scontrol ping --yaml'
 -- Prevent jobs without reservations from delaying jobs in reservations with
    flags FLEX or ANY_NODES in the main scheduler.
 -- Fix allowing to ask for multiple different types of TRES when one of
    them has a value of 0.
 -- slurmctld - Add a grace period to ensure the agent retry queue is properly
    flushed during shutdown.
 -- Removed src/slurmrestd/plugins/openapi/slurmdbd/openapi.json from source
    repository. slurmrest should always be used to generate a new OpenAPI
    schema (aka openapi.json or openapi.yaml) after compilation.
 -- mpi/pmix - Fix potential deadlock and races with het jobs, and fix potential
    memory and FDs leaks.
 -- Fix jobs with --gpus being rejected in some edge cases for partitions
    where not all nodes have the same amount of GPUs and CPUs configured.
 -- In an extra constraints expression in a job request, do not allow an empty
    string for a key or value.
 -- In an extra constraints expression in a job request, fix validation that
    requests are separated by boolean operators.
 -- Add TaskPluginParam=OOMKillStep to kill the step as a whole when one task
    OOMs.
 -- Fix scontrol show conf not showing all TaskPluginParam elements.
 -- slurmrestd - Add fields '.job.oom_kill_step' '.jobs[].oom_kill_step' to
    'POST /slurm/v0.0.42/job/submit' and 'POST /slurm/v0.0.42/job/allocate'.
 -- Improve performance for _will_run_test().
 -- Add SchedulerParameters=bf_topopt_enable option to enable experimental hook
    to control backfill.
 -- If a step fails to launch under certain conditions, set the step's state
    to NODE_FAIL.
 -- sched/backfill - Fix certain situations where a job would not get a
    planned time, which could lead to it being delayed by lower priority jobs.
 -- slurmrestd - Dump JSON "null" instead of "{}" (empty object) for
    non-required fields in objects to avoid client compatiblity issues for
    v0.0.42 version tagged endpoints.
 -- sacct,sacctmgr,scontrol,sdiag,sinfo,squeue,sshare - Dump "null" instead
    "{}" (empty object) for non-required fields in objects to avoid client
    compatiblity issues when run with --json or --yaml.

* Changes in Slurm 24.05.5
==========================
 -- Fix issue signaling cron jobs resulting in unintended requeues.
 -- Fix slurmctld memory leak in implementation of HealthCheckNodeState=CYCLE.
 -- job_container/tmpfs - Fix SLURM_CONF env variable not being properly set.
 -- sched/backfill - Fix job's time_limit being overwritten by time_min for job
    arrays in some situations.
 -- RoutePart - fix segfault from incorrect memory allocation when node doesn't
    exist in any partition.
 -- slurmctld - Fix crash when a job is evaluated for a reservation after
    removal of a dynamic node.
 -- gpu/nvml - Attempt loading libnvidia-ml.so.1 as a fallback for failure in
    loading libnvidia-ml.so.
 -- slurmrestd - Fix populating non-required object fields of objects as '{}' in
    JSON/YAML instead of 'null' causing compiled OpenAPI clients to reject
    the response to 'GET /slurm/v0.0.40/jobs' due to validation failure of
    '.jobs[].job_resources'.
 -- Fix sstat/sattach protocol errors for steps on higher version slurmd's
    (regressions since 20.11.0rc1 and 16.05.1rc1 respectively).
 -- slurmd - Avoid a crash when starting slurmd version 24.05 with
    SlurmdSpoolDir files that have been upgraded to a newer major version of
    Slurm. Log warnings instead.
 -- Fix race condition in stepmgr step completion handling.
 -- Fix slurmctld segfault with stepmgr and MpiParams when running a job array.
 -- Fix requeued jobs keeping their priority until the decay thread happens.

* Changes in Slurm 24.05.4
==========================
 -- Fix generic int sort functions.
 -- Fix user look up using possible unrealized uid in the dbd.
 -- Fix FreeBSD compile issue with tls/none plugin.
 -- slurmrestd - Fix regressions that allowed slurmrestd to be run as SlurmUser
    when SlurmUser was not root.
 -- mpi/pmix fix race conditions with het jobs at step start/end which could
    make srun to hang.
 -- Fix not showing some SelectTypeParameters in scontrol show config.
 -- Avoid assert when dumping removed certain fields in JSON/YAML.
 -- Improve how shards are scheduled with affinity in mind.
 -- Fix MaxJobsAccruePU not being respected when MaxJobsAccruePA is set
    in the same QOS.
 -- Prevent backfill from planning jobs that use overlapping resources for the
    same time slot if the job's time limit is less than bf_resolution.
 -- Fix memory leak when requesting typed gres and --[cpus|mem]-per-gpu.
 -- Prevent backfill from breaking out due to "system state changed" every 30
    seconds if reservations use REPLACE or REPLACE_DOWN flags.
 -- slurmrestd - Make sure that scheduler_unset parameter defaults to true even
    when the following flags are also set: show_duplicates, skip_steps,
    disable_truncate_usage_time, run_away_jobs, whole_hetjob,
    disable_whole_hetjob, disable_wait_for_result, usage_time_as_submit_time,
    show_batch_script, and or show_job_environment. Additionaly, always make
    sure show_duplicates and disable_truncate_usage_time default to true when
    the following flags are also set: scheduler_unset, scheduled_on_submit,
    scheduled_by_main, scheduled_by_backfill, and or job_started. This effects
    the following endpoints:
      'GET /slurmdb/v0.0.40/jobs'
      'GET /slurmdb/v0.0.41/jobs'
 -- Ignore --json and --yaml options for scontrol show config to prevent mixing
    output types.
 -- Fix not considering nodes in reservations with Maintenance or Overlap flags
    when creating new reservations with nodecnt or when they replace down nodes.
 -- Fix suspending/resuming steps running under a 23.02 slurmstepd process.
 -- Fix options like sprio --me and squeue --me for users with a uid greater
    than 2147483647.
 -- fatal() if BlockSizes=0. This value is invalid and would otherwise cause the
    slurmctld to crash.
 -- sacctmgr - Fix issue where clearing out a preemption list using
    preempt='' would cause the given qos to no longer be preempt-able until set
    again.
 -- Fix stepmgr creating job steps concurrently.
 -- data_parser/v0.0.40 - Avoid dumping "Infinity" for NO_VAL tagged "number"
    fields.
 -- data_parser/v0.0.41 - Avoid dumping "Infinity" for NO_VAL tagged "number"
    fields.
 -- slurmctld - Fix a potential leak while updating a reservation.
 -- slurmctld - Fix state save with reservation flags when a update fails.
 -- Fix reservation update issues with parameters Accounts and Users, when
    using +/- signs.
 -- slurmrestd - Don't dump warning on empty wckeys in:
      'GET /slurmdb/v0.0.40/config'
      'GET /slurmdb/v0.0.41/config'
 -- Fix slurmd possibly leaving zombie processes on start up in configless when
    the initial attempt to fetch the config fails.
 -- Fix crash when trying to drain a non-existing node (possibly deleted
    before).
 -- slurmctld - fix segfault when calculating limit decay for jobs with an
    invalid association.
 -- Fix IPMI energy gathering with multiple sensors.
 -- data_parser/v0.0.39 - Remove xassert requiring errors and warnings to have a
    source string.
 -- slurmrestd - Prevent potential segfault when there is an error parsing an
    array field which could lead to a double xfree. This applies to several
    endpoints in data_parser v0.0.39, v0.0.40 and v0.0.41.
 -- scancel - Fix a regression from 23.11.6 where using both the --ctld and
    --sibling options would cancel the federated job on all clusters instead of
    only the cluster(s) specified by --sibling.
 -- accounting_storage/mysql - Fix bug when removing an association
    specified with an empty partition.
 -- Fix setting multiple partition state restore on a job correctly.
 -- Fix difference in behavior when swapping partition order in job submission.
 -- Fix security issue in stepmgr that could permit an attacker to execute
    processes under other users' jobs. CVE-2024-48936.

* Changes in Slurm 24.05.3
==========================
 -- data_parser/v0.0.40 - Added field descriptions
 -- slurmrestd - Avoid creating new slurmdbd connection per request to
    '* /slurm/slurmctld/*/*' endpoints.
 -- Fix compilation issue with switch/hpe_slingshot plugin.
 -- Fix gres per task allocation with threads-per-core.
 -- data_parser/v0.0.41 - Added field descriptions
 -- slurmrestd - Change back generated OpenAPI schema for
    `DELETE /slurm/v0.0.40/jobs/` to RequestBody instead of using parameters
    for request. slurmrestd will continue accept endpoint requests via
    RequestBody or HTTP query.
 -- topology/tree - Fix issues with switch distance optimization.
 -- Fix potential segfault of secondary slurmctld when falling back to the
    primary when running with a JobComp plugin.
 -- Enable --json/--yaml=v0.0.39 options on client commands to dump data using
    data_parser/v0.0.39 instead or outputting nothing.
 -- switch/hpe_slingshot - Fix issue that could result in a 0 length state file.
 -- Fix unnecessary message protocol downgrade for unregistered nodes.
 -- Fix unnecessarily packing alias addrs when terminating jobs with a mix of
    non-cloud/dynamic nodes and powered down cloud/dynamic nodes.
 -- accounting_storage/mysql - Fix issue when deleting a qos that could remove
    too many commas from the qos and/or delta_qos fields of the assoc table.
 -- slurmctld - Fix memory leak when using RestrictedCoresPerGPU.
 -- Fix allowing access to reservations without MaxStartDelay set.
 -- Fix regression introduced in 24.05.0rc1 breaking srun --send-libs parsing.
 -- Fix slurmd vsize memory leak when using job submission/allocation commands
    that implicitly or explicitly use --get-user-env.
 -- slurmd - Fix node going into invalid state when using CPUSpecList and
    setting CPUs to the # of cores on a multithreaded node
 -- Fix reboot asap nodes being considered in backfill after a restart.
 -- Fix --clusters/-M queries for clusters outside of a federation when
    fed_display is configured.
 -- Fix scontrol allowing updating job with bad cpus-per-task value.
 -- sattach - Fix regression from 24.05.2 security fix leading to crash.
 -- mpi/pmix - Fix assertion when built under --enable-debug.

* Changes in Slurm 24.05.2
==========================
 -- Fix energy gathering rpc counter underflow in _rpc_acct_gather_energy when
    more than 10 threads try to get energy at the same time. This prevented
    the possibility to get energy from slurmd by any step until slurmd was
    restarted, so losing energy accounting metrics in the node.
 -- accounting_storage/mysql - Fix issue where new user with wckey did not
    have a default wckey sent to the slurmctld.
 -- slurmrestd - Prevent slurmrestd segfault when handling the following
    endpoints when none of the optional parameters are specified:
      'DELETE /slurm/v0.0.40/jobs'
      'DELETE /slurm/v0.0.41/jobs'
      'GET /slurm/v0.0.40/shares'
      'GET /slurm/v0.0.41/shares'
      'GET /slurmdb/v0.0.40/instance'
      'GET /slurmdb/v0.0.41/instance'
      'GET /slurmdb/v0.0.40/instances'
      'GET /slurmdb/v0.0.41/instances'
      'POST /slurm/v0.0.40/job/{job_id}'
      'POST /slurm/v0.0.41/job/{job_id}'
 -- Fix IPMI energy gathering when no IPMIPowerSensors are specified in
    acct_gather.conf. This situation resulted in an accounted energy of 0
    for job steps.
 -- Fix a minor memory leak in slurmctld when updating a job dependency.
 -- scontrol,squeue - Fix regression that caused incorrect values for
    multisocket nodes at '.jobs[].job_resources.nodes.allocation' for
    'scontrol show jobs --(json|yaml)' and 'squeue --(json|yaml)'.
 -- slurmrestd - Fix regression that caused incorrect values for
    multisocket nodes at '.jobs[].job_resources.nodes.allocation' to be dumped
    with endpoints:
      'GET /slurm/v0.0.41/job/{job_id}'
      'GET /slurm/v0.0.41/jobs'
 -- jobcomp/filetxt - Fix truncation of job record lines > 1024 characters.
 -- Fixed regression that prevented compilation on FreeBSD hosts.
 -- switch/hpe_slingshot - Drain node on failure to delete CXI services.
 -- Fix a performance regression from 23.11.0 in cpu frequency handling when no
    CpuFreqDef is defined.
 -- Fix one-task-per-sharing not working across multiple nodes.
 -- Fix inconsistent number of cpus when creating a reservation using the
    TRESPerNode option.
 -- data_parser/v0.0.40+ - Fix job state parsing which could break filtering.
 -- Prevent cpus-per-task to be modified in jobs where a -c value has been
    explicitly specified and the requested memory constraints implicitly
    increase the number of CPUs to allocate.
 -- slurmrestd - Fix regression where args '-s v0.0.39,dbv0.0.39' and
    '-d v0.0.39' would result in 'GET /openapi/v3' not registering as a valid
    possible query resulting in 404 errors.
 -- slurmrestd - Fix memory leak for dbv0.0.39 jobs query which occurred if the
    query parameters specified account, association, cluster, constraints,
    format, groups, job_name, partition, qos, reason, reservation, state, users,
    or wckey. This affects the following endpoints:
      'GET /slurmdb/v0.0.39/jobs'
 -- slurmrestd - In the case the slurmdbd does not respond to a persistent
    connection init message, prevent the closed fd from being used, and instead
    emit an error or warning depending on if the connection was required.
 -- Fix 24.05.0 regression that caused the slurmdbd not to send back an error
    message if there is an error initializing a persistent connection.
 -- Reduce latency of forwarded x11 packets.
 -- Add "curr_dependency" (representing the current dependency of the job)
    and "orig_dependency" (representing the original requested dependency of
    the job) fields to the job record in job_submit.lua (for job update) and
    jobcomp.lua.
 -- Fix potential segfault of slurmctld configured with
    SlurmctldParameters=enable_rpc_queue from happening on reconfigure.
 -- Fix potential segfault of slurmctld on its shutdown when rate limitting
    is enabled.
 -- slurmrestd - Fix missing job environment for SLURM_JOB_NAME,
    SLURM_OPEN_MODE, SLURM_JOB_DEPENDENCY, SLURM_PROFILE, SLURM_ACCTG_FREQ,
    SLURM_NETWORK and SLURM_CPU_FREQ_REQ to match sbatch.
 -- Add missing bash-completions dependency to slurm-smd-client debian package.
 -- Fix bash-completions installation in debian pacakges.
 -- Fix GRES environment variable indices being incorrect when only using a
    subset of all GPUs on a node and the --gres-flags=allow-task-sharing option
 -- Add missing mariadb/mysql client package dependency to debian package.
 -- Fail the debian package build early if mysql cannot be found.
 -- Prevent scontrol from segfaulting when requesting scontrol show reservation
    --json or --yaml if there is an error retrieving reservations from the
    slurmctld.
 -- switch/hpe_slingshot - Fix security issue around managing VNI access.
    CVE-2024-42511.
 -- switch/nvidia_imex - Fix security issue managing IMEX channel access.
    CVE-2024-42511.
 -- switch/nvidia_imex - Allow for compatibility with job_container/tmpfs.

* Changes in Slurm 24.05.1
==========================
 -- Fix slurmctld and slurmdbd potentially stopping instead of performing a
    logrotate when recieving SIGUSR2 when using auth/slurm.
 -- switch/hpe_slingshot - Fix slurmctld crash when upgrading from 23.02.
 -- Fix "Could not find group" errors from validate_group() when using
    AllowGroups with large /etc/group files.
 -- Prevent an assertion in debugging builds when triggering log rotation
    in a backup slurmctld.
 -- Add AccountingStoreFlags=no_stdio which allows to not record the stdio
    paths of the job when set.
 -- slurmrestd - Prevent a slurmrestd segfault when parsing the crontab field,
    which was never usable. Now it explicitly ignores the value and emits a
    warning if it is used for the following endpoints:
      'POST /slurm/v0.0.39/job/{job_id}'
      'POST /slurm/v0.0.39/job/submit'
      'POST /slurm/v0.0.40/job/{job_id}'
      'POST /slurm/v0.0.40/job/submit'
      'POST /slurm/v0.0.41/job/{job_id}'
      'POST /slurm/v0.0.41/job/submit'
      'POST /slurm/v0.0.41/job/allocate'
 -- mpi/pmi2 - Fix communication issue leading to task launch failure with
    "invalid kvs seq from node".
 -- Fix getting user environment when using sbatch with "--get-user-env" or
    "--export=" when there is a user profile script that reads /proc.
 -- Prevent slurmd from crashing if acct_gather_energy/gpu is configured but
    GresTypes is not configured.
 -- Do not log the following errors when AcctGatherEnergyType plugins are used
    but a node does not have or cannot find sensors:
    "error: _get_joules_task: can't get info from slurmd"
    "error: slurm_get_node_energy: Zero Bytes were transmitted or received"
    However, the following error will continue to be logged:
    "error: Can't get energy data. No power sensors are available. Try later"
 -- sbatch, srun - Set SLURM_NETWORK environment variable if --network is set.
 -- Fix cloud nodes not being able to forward to nodes that restarted with new
    IP addresses.
 -- Fix cwd not being set correctly when running a SPANK plugin with a
    spank_user_init() hook and the new "contain_spank" option set.
 -- slurmctld - Avoid deadlock during shutdown when auth/slurm is active.
 -- Fix segfault in slurmctld with topology/block.
 -- sacct - Fix printing of job group for job steps.
 -- scrun - Log when an invalid environment variable causes the job submission
    to be rejected.
 -- accounting_storage/mysql - Fix problem where listing or modifying an
    association when specifying a qos list could hang or take a very long time.
 -- gpu/nvml - Fix gpuutil/gpumem only tracking last GPU in step. Now,
    gpuutil/gpumem will record sums of all GPUS in the step.
 -- Fix error in scrontab jobs when using slurm.conf:PropagatePrioProcess=1.
 -- Fix slurmctld crash on a batch job submission with "--nodes 0,...".
 -- Fix dynamic IP address fanout forwarding when using auth/slurm.
 -- Restrict listening sockets in the mpi/pmix plugin and sattach to the
    SrunPortRange.
 -- slurmrestd - Limit mime types returned from query to 'GET /openapi/v3' to
    only return one mime type per serializer plugin to fix issues with OpenAPI
    client generators that are unable to handle multiple mime type aliases.
 -- Fix many commands possibly reporting an "Unexpected Message Received" when
    in reality the connection timed out.
 -- Prevent slurmctld from starting if there is not a json serializer present
    and the extra_constraints feature is enabled.
 -- Fix heterogeneous job components not being signaled with scancel --ctld and
    'DELETE slurm/v0.0.40/jobs' if the job ids are not explicitly given,
    the heterogeneous job components match the given filters, and the
    heterogeneous job leader does not match the given filters.
 -- Fix regression from 23.02 impeding job licenses from being cleared.
 -- Move error to log_flag which made _get_joules_task error to be logged to the
    user when too many rpcs were queued in slurmd for gathering energy.
 -- For scancel --ctld and the associated rest api endpoints:
      'DELETE /slurm/v0.0.40/jobs'
      'DELETE /slurm/v0.0.41/jobs'
    Fix canceling the final array task in a job array when the task is pending
    and all array tasks have been split into separate job records. Previously
    this task was not canceled.
 -- Fix power_save operation after recovering from a failed reconfigure.
 -- slurmctld - Skip removing the pidfile when running under systemd. In that
    situation it is never created in the first place.
 -- Fix issue where altering the flags on a Slurm account (UsersAreCoords)
    several limits on the account's association would be set to 0 in
    Slurm's internal cache.
 -- Fix memory leak in the controller when relaying stepmgr step accounting to
    the dbd.
 -- Fix segfault when submitting stepmgr jobs within an existing allocation.
 -- Added "disable_slurm_hydra_bootstrap" as a possible MpiParams parameter in
    slurm.conf. Using this will disable env variable injection to allocations
    for the following variables: I_MPI_HYDRA_BOOTSTRAP,
    I_MPI_HYDRA_BOOTSTRAP_EXEC_EXTRA_ARGS, HYDRA_BOOTSTRAP,
    HYDRA_LAUNCHER_EXTRA_ARGS.
 -- scrun - Delay shutdown until after start requested. This caused scrun
    to never start or shutdown and hung forever when using --tty.
 -- Fix backup slurmctld potentially not running the agent when taking over as
    the primary controller.
 -- Fix primary controller not running the agent when a reconfigure of the
    slurmctld fails.
 -- slurmd - fix premature timeout waiting for REQUEST_LAUNCH_PROLOG with large
    array jobs causing node to drain.
 -- jobcomp/{elasticsearch,kafka} - Avoid sending fields with invalid date/time.
 -- jobcomp/elasticsearch - Fix slurmctld memory leak from curl usage
 -- acct_gather_profile/influxdb - Fix slurmstepd memory leak from curl usage
 -- Fix 24.05.0 regression not deleting job hash dirs after MinJobAge.
 -- Fix filtering arguments being ignored when using squeue --json.
 -- switch/nvidia_imex - Move setup call after spank_init() to allow namespace
    manipulation within the SPANK plugin.
 -- switch/nvidia_imex - Skip plugin operation if nvidia-caps-imex-channels
    device is not present rather than preventing slurmd from starting.
 -- switch/nvidia_imex - Skip plugin operation if job_container/tmpfs
    is configured due to incompatibility.
 -- switch/nvidia_imex - Remove any pre-existing channels when slurmd starts.
 -- rpc_queue - Add support for an optional rpc_queue.yaml configuration file.
 -- slurmrestd - Add new +prefer_refs flag to data_parser/v0.0.41 plugin. This
    flag will avoid inlining single referenced schemas in the OpenAPI schema.

* Changes in Slurm 24.05.0
==========================
 -- Fix regresssion in rc1 causing power_save thread to spin continuously.
 -- Improve ctld_relay shutdown sequence.
 -- Fixed 'make distclean' behavior for contribs/perlapi.
 -- slurmrestd - Avoid ignoring numerical only endpoints during startup with
    older libjson-c due to type parsing mismatching.
 -- Reject non-stepmgr job allocations requesting --resv-ports from the ctld.
 -- slurmrestd - Add fields '.job.resv_ports' '.jobs[].resv_ports' to
    'POST /slurm/v0.0.41/job/submit' and 'POST /slurm/v0.0.41/job/allocate'.
 -- slurmstepd - Fix crash when cleaning up on shutdown with
    --enable-memory-leak-debug.
 -- Fix segfault in switch/hpe_slingshot plugin due to initialization squence.
 -- scrun - Fix regression in rc1 that caused scrun to crash.
 -- Prevent unnecessary log statement when free'ing ports.
 -- Fix regression in rc1 causing communication problems when sending large
    responses from slurmctld.
 -- sreport - fix parsing of 'format=Planned' to prevent it from being
    misinterpreted as 'PlannedDown'. 'PlannedDown' is now also known as
    'PLNDDown' to match what is printed as the column title.
 -- topology/block - Always return an error when the segment size does not
    match the system or job specification.
 -- Add previously missing timers for Prolog and Epilog scripts when RunInJob is
    set.
 -- Show an error when PrologFlags RunInJob and Serial are used together.
    PrologFlags=Serial is not compatible with how RunInJob operates.
 -- Fix memory leak on shutdown when using --enable-memory-leak-debug and
    freeing cons_tres node usage.
 -- Rename src/stepmgr/gres_ctld.[ch] to src/stepmgr/gres_stepmgr.[ch].
 -- Fix various cosmetic issues with states in sinfo.
 -- slurmrestd - Avoid crash due to associations query.
 -- Calculate a job's min_cpus with consideration to --cpus-per-gpu.
 -- Fix scancel request when specifying individual array tasks in combination
    with filtering options (in both regular and --interactive mode).
 -- Enable MaxStepCount in stepmgr.
 -- Enable AccountingStorageEnforce=nojobs,nosteps in stepmgr.
 -- Add AccountingStorageParameters=max_step_records to limit how many steps
    are recorded in the database for each job -- excluding batch, extern, and
    interactive steps.
 -- switch/hpe_slingshot - allocate VNIs on the controller for stepmgr jobs and
    pass to the stepmgr for steps to use.
 -- switch/hpe_slingshot - fix assertion when restarting the controller.
 -- switch/hpe_slingshot - fix calcuation of free vnis when restarting the
    controller with running jobs.
 -- Improve default job reserve MPI port allocations that use overcommit or do
    not specify a task count for stepmgr enabled jobs.
 -- Fix a regression in rc1 resulting in scrun occasionally deadlocking when
    the --enable-memory-leak-debug configure option was used.
 -- topology/default - Prevent segfault in slurmctld on 'scontrol show topo'.
 -- slurmrestd - Avoid creating or requring a connection to slurmdbd for the
    'GET /openapi/v3' endpoint, fixing a regression in rc1.
 -- scrun - Fix setting and getting environment via SPANK plugins.
 -- sview - Fix nodes tab if a node has RestrictedCoresPerGPU configured.
 -- slurmrestd - Add --generate-openapi-spec argument.
 -- sview - Prevent segfault when retrieving slurmdbd configuration.
 -- Avoid canceling rejected heterogeneous jobs without job write lock.
 -- Fix slurmctld crash when reconfiguring with a PrologSlurmctld is running.
 -- Fix slurmctld crash after a job has been resized.

* Changes in Slurm 24.05.0rc1
=============================
 -- Make slurmstepd retry REQUEST_COMPLETE_BATCH_SCRIPT indefinitely.
 -- Always load serializer/json when using any data_parser plugins.
 -- slurmrestd - Reject single http query with multiple path requests.
 -- slurmrestd - Add time/planned field to slurmdb/v0.0.41/job/{job_id}.
 -- Improve Power Save's Resume/Suspend rate limiting.
 -- slurmrestd - Improve reliablity under high memory pressure by closing
    connections instead of forcing a fatal exit due to lack of memory.
 -- data_parser/v0.0.41 - Avoid aborting when invoking a not implemented
    parser.
 -- data_parser/v0.0.41 - Fix how nice values are parsed for job submissions.
 -- data_parser/v0.0.41 - Fix regression where parsing error did not result in
    invalid request being rejected.
 -- Print an error message in 'scontrol reboot' when a node reboot request
    is ignored due to the current node state.
 -- squeue - Add "--notme" option.
 -- data_parser/v0.0.41 - change "association.id" to just include the int "id"
    rather than include redundant assoc info (cluster, user, partition, account)
    that's already included in the "association" object.
 -- data_parser/v0.0.41 - Improve parsing of numeric user id.
 -- data_parser/v0.0.41 - Improve parsing of numeric group id.
 -- slurmrestd - Generated openapi.json will only populate "deprecated" fields
    if true. False is the default value and does not require being present.
 -- slurmrestd - Populate missing "deprecated" fields in  openapi.json.
 -- slurmrestd - Corrected deprecated fields in generated openapi.json not
    getting populated.
 -- slurmrestd - Generated openapi.json will have reduced number of "$ref"
    fields. Where there was only 1 reference for the schema, the "$ref" schema
    will be directly populated in place.
 -- slurmrestd - Rename *_NO_VAL schemas in generated openapi.json to have
    _struct and to pass along correct integer sizing when possible.
 -- slurmrestd - Correct description fields in generated openapi.json where
    descriptions were not present or too generic.
 -- Remove support for Cray XC ("cray_aries") systems.
 -- Prevent backup slurmctld from taking over if the heartbeat file is
    still being updated.  Failure to ping may have been due to clock skew.
 -- serializer/yaml - Converted to new parsing interface in libyaml to improve
    parsing compatibility.
 -- Removed TopologyPlugin tree and dragonfly support from select/linear.
    If those topology plugins are desired please switch to select/cons_tres.
 -- Changed slurmrestd.service to only listen on TCP socket by default.
    Environments with existing drop-in units for the service may need
    further adjustments to work after upgrading.
 -- Fix how gres are allocated per job when using multiple gres types.
 -- Log an error when UnkillableStepTimeout is less than five times
    MessageTimeout.
 -- Avoid step gres dealloc count underflow errors after reconfiguring or
    restarting slurmctld.
 -- Fix controller not validating periodic dynamic future registrations.
 -- Fix dynamic future nodes registering as new node when specifying -N<name>.
 -- Fix sbcast (or srun --bcast) --send-libs when it is used multiple times in
    the same job. Previously, subsequent calls to sbcast --send-libs would
    overwrite the libraries for the first executable.
 -- Add support for sbcast --preserve when job_container/tmpfs configured
    (previously documented as unsupported).
 -- Changed the default value for UnkillableStepTimeout to 60 seconds or five
    times the value of MessageTimeout, whichever is greater.
 -- slurmctld - Check if --deadline has been reached and not satisfied on held
    jobs, otherwise they could remain without automatic cancellation until after
    the job is released.
 -- scrun/slurmrestd/sackd - Avoid closing all listening sockets when
    interrupted from signal such as SIGALRM. Normal shutdown remains unaffected.
 -- Remove systemd AbandonScope() logic for scope units as it is not needed.
 -- Fix GresUsed output from `scontrol show nodes --details` showing  GRES types
    that are not configured on a node.
 -- slurmrestd - Fatal during start up when loading content plugin fails.
 -- slurmrestd - Reduce complexity in URL path matching.
 -- data_parser/v0.0.41 - Emit a warning instead of an error if a disabled
    parser is invoked.
 -- Federation - allow client command operation when slurmdbd is unavailable.
 -- Enforce mutual exclusivity of --systemd and -D when launching daemons
 -- slurmctld - remove -d option
 -- burst_buffer/lua - Trigger a burst_buffer event for strigger when the
    real_size function fails.
 -- burst_buffer/lua - Added two new hooks: slurm_bb_test_data_in and
    slurm_bb_test_data_out. The syntax and use of the new hooks are documented
    in etc/burst_buffer.lua.example. These are required to exist. slurmctld now
    checks on startup if the burst_buffer.lua script loads and contains all
    required hooks; slurmctld will exit with a fatal error if this is not
    successful. Added PollInterval to burst_buffer.conf. Removed the arbitrary
    limit of 512 copies of the script running simultaneously.
 -- sackd/slurmrestd/scrun - Avoid using empty string while logging unix socket
    connections from a listening connection.
 -- Fix 20 character username limit from 'sacctmgr show events'
 -- Log an error if UsePss or NoShare are configured with a plugin other than
    jobacct_gather/linux. In such case these parameters are ignored.
 -- helpers.conf - Added Flags=rebootless parameter allowing feature changes
    without rebooting compute nodes.
 -- scontrol - Add new subcommand 'power' for node power control.
 -- data_parser/v0.0.41 - Implement parser of distribution for
    /slurm/v0.0.41/job/submit.
 -- data_parser/v0.0.41 - Change distribution_plane_size field type from UINT16
    to UINT16_NO_VAL for /slurm/v0.0.41/job/submit.
 -- topology/block - Replaced the BlockLevels with BlockSizes in topology.conf.
 -- Fix slurmd cgroup/v2 startup race with systemd and cgroupfs.
 -- Add SystemdTimeout= parameter in cgroup.conf.
 -- Add QOS limit MaxTRESRunMinsPerAccount.
 -- Add QOS limit MaxTRESRunMinsPerUser.
 -- jobcomp/{elasticsearch,kafka} - Send priority alongside the rest of fields.
 -- Add contain_spank option to SlurmdParameters. When set, spank_user_init(),
    spank_task_post_fork(), and spank_task_exit() will execute within the
    job_container/tmpfs plugin namespace.
 -- Update job reason appropriately when bf_licenses is used.
 -- slurmrestd - Tagged `script` field as deprecated in
    'POST /slurm/v0.0.41/job/submit' in anticipation of removal in future
    OpenAPI plugin versions.
 -- Fix salloc/sbatch/srun crashing with certain invalid nodelist requests.
 -- Optimize jobacctgather by not iterating every time over pids that have
    already finished.
 -- Remote SPANK callbacks invoked by srun get called once instead of twice.
 -- auth/slurm - Support multiple keys through slurm.jwks.
 -- sched/backfill - Fix issue with bf_continue where a job partition request
    could be incorrectly reset back to a partition that is no longer specified
    after a job partition update processed during a lock yield time window.
 -- slurmrestd - Explicitly set process as dumpable (and ptrace-able) at
    startup for systems where suid_dumpable is not 2.
 -- slurmrestd - Tag all /slurm/v0.0.39/ and /slurmdb/v0.0.39/ endpoints as
    deprecated in anticipation of removal in Slurm 24.11.
 -- Add ELIGIBLE environment variable to jobcomp/script plugin.
 -- slurmrestd,sackd,scrun - Improve outgoing data efficiency using
    non-contiguous write support in kernel.
 -- sackd - Add support for SACKD_DEBUG, SACKD_STDERR_DEBUG, and
    SACKD_SYSLOG_DEBUG environment variables to control logging.
 -- mpi/pmi2 - PMI_process_mapping values have been adapted for executions
    where arbitrary distribution/SLURM_HOSTFILE is used. Now it can take into
    account multiple instances of the same node inside SLURM_HOSTFILE.
 -- Avoid wrong limit oriented (i.e. QosMaxGresPer*) job pending reason for jobs
    actually pending on Resources when GPUs are requested per job.
 -- Fix --ntasks-per-node not being treated as a max count of tasks per node
    when used in combination with --ntasks. --ntasks option will now take
    precedence as it is documented.
 -- Accept X11 cookies that do not have a display number associated with it.
 -- Always use the QOS name for SLURM_JOB_QOS environment variables.
    Previously the batch environment would use the description field,
    which was usually equivalent to the name.
 -- slurmrestd - Add "CRON_JOBS" as possible flag value to the following:
      'DELETE /slurm/v0.0.40/jobs' flags field.
      'DELETE /slurm/v0.0.41/jobs' flags field.
      'DELETE /slurm/v0.0.40/job/{job_id}?flags=' flags query parameter.
      'DELETE /slurm/v0.0.41/job/{job_id}?flags=' flags query parameter.
 -- Fix ScronParameters=explicit_scancel when using the rest api DELETE jobs
    query: if the CRON_JOBS flag is not used then cron jobs will not be
    cancelled. The NO_CRON_JOBS flag is ignored in v0.0.40 and removed in
    v0.0.41.
 -- Pass multi-partition job priorities to job for squeue to display.
 -- cgroup/v2 - Require dbus-1 version >= 1.11.16.
 -- Add RestrictedCoresPerGPU configuration option.
 -- Fix how ntasks is inferred from --cpus-per-task when using --nodes,
    --threads-per-core, or --hint=nomultithread.
 -- For PreemptMode=CANCEL and PreemptMode=REQUEUE assume that job signalled
    for GraceTime was preempted.
 -- slurmd - Retry fetching configs indefinitely during startup.
 -- Fix SPANK options not bing sent to remote context when --export was used.
 -- slurmrestd - Attempt to automatically convert enumerated string arrays with
    incoming non-string values into strings. Add warning when incoming value for
    enumerated string arrays can not be converted to string and silently ignore
    instead of rejecting entire request.
 -- slurmrestd - Require `user` and `association_condition` fields to be
    populated for requests to 'POST /slurmdb/v0.0.41/users_association'.
 -- Allow NodeSet names to be used in SuspendExcNodes.
 -- SuspendExcNodes=<nodes>:N now counts allocated nodes in N. The first N
    powered up nodes in <nodes> are protected from being suspended.
 -- Add SlurmctldParameters=max_powered_nodes=N, which prevents powering up
    nodes after the max is reached.
 -- Store output, error and input paths in the database and make them available
    in accounting tools.
 -- slurmrestd - Add 'POST /slurm/v0.0.41/job/allocate' endpoint.
 -- Fix issues related to the extern step getting killed before other steps.
    This includes the job_containter/tmpfs plugin not cleaning up.
 -- Add USER_DELETE reservation flag to allow users with access to a reservation
    to delete it.
 -- Add CgroupPlugin=disabled to disable any interaction with Cgroups.
 -- slurmrestd - Add "STEPMGR_ENABLED" as possible flag value to the following:
      'GET /slurm/v0.0.41/jobs' flags field.
      'GET /slurm/v0.0.41/job/{job_id}' flags query parameter.
 -- scontrol,squeue - Added possible flags "STEPMGR_ENABLED" to '.jobs[].flags' for
    'scontrol show jobs --{json|yaml}' and 'squeue --{json|yaml}' responses.
 -- Add SlurmctldParameters=enable_stepmgr to enable step management through
    the slurmstepd instead of the controller.
 -- Avoid slurmstepd infinite loop waiting for tasks termination.
 -- Fix logging of JSON/YAML values in some messages where nothing would be
    printed as the value instead of the actual JSONified version of the parsed
    string.
 -- slurmrestd,sackd,scrun - Improve logic around handling kernel provided
    buffer size of incoming data in files/sockets/pipes to avoid crashes.
 -- Add --segment to job allocation to be used in topology/block.
 -- Add --exclusive=topo for use with topology/block.
 -- Add ExclusiveTopo to a partition definition in slurm.conf.
 -- Add new 'BLOCKED' state to a node.
 -- Account coordinators may not increase association job limits above
    parent ones
 -- Account coordinators can now suspend/resume jobs owned by member users.
 -- Add DisableCoordDBD slurmdbd configuration parameter to disable the
    coordinator status in all slurmdbd interactions.
 -- slurmrestd - Added possible flags "WithAssociations" and "WithCoordinators"
    to `.accounts[].flags` for "GET /slurmdb/v0.0.41/accounts/" and
    "POST /slurmdb/v0.0.41/accounts/" endpoints.
 -- sacctmgr - Added possible flags "WithAssociations" and "WithCoordinators"
    to `.accounts[].flags` for `sacctmgr show accounts --{json|yaml}` response.
 -- slurmrestd - Rename URL query parameter "with_assocs" to "WithAssociations"
    for "GET /slurmdb/v0.0.41/accounts?WithAssociations".
 -- slurmrestd - Rename URL query parameter "with_coords" to "WithCoordinators"
    for "GET /slurmdb/v0.0.41/accounts?WithCoordinators".
 -- slurmrestd - Rename URL query parameter "with_deleted" to "deleted"
    for "GET /slurmdb/v0.0.41/accounts?deleted".
 -- slurmrestd - Added possible flags "RemoveUsersAreCoords" and
    "UsersAreCoords" to `.accounts[].flags` for "GET /slurmdb/v0.0.41/accounts/"
    and "POST /slurmdb/v0.0.41/accounts/" endpoints.
 -- sacctmgr - Added possible flags "RemoveUsersAreCoords" and "UsersAreCoords"
    to `.accounts[].flags` for `sacctmgr show accounts --{json|yaml}` response.
 -- slurmrestd - Add URL query parameter "UsersAreCoords" and
    "RemoveUsersAreCoords" for
    "GET /slurmdb/v0.0.41/accounts?UsersAreCoords&RemoveUsersAreCoords".
 -- sacctmgr - Add new possible new flags "NoUpdate" and "Exact" to
    '.associations[].flags' response from 'sacctmgr show assocs --{json|yaml}'.
 -- slurmrestd - Added possible flags "NoUpdate" and "Exact" to
    `.associations[].flags` for "GET /slurmdb/v0.0.41/associations/"
    and "POST /slurmdb/v0.0.41/associations/" endpoints.
 -- Fix false success of REQUEST_FORWARD_DATA RPC that made pmix to get out
    of sync during initialization.
 -- slurmrestd - Allow startup when slurmdbd is not configured and avoid loading
    slurmdbd specific plugins.
 -- Added PrologFlags=RunInJob to make prolog and epilog run inside the job
    extern step to include it in the job's cgroup.
 -- Return '*' for the password field for nss_slurm instead of "x".
 -- slurmrestd - Add "topo" as possible value to the following:
      'GET /slurm/v0.0.41/jobs' in '.jobs[].shared' field
      'GET /slurm/v0.0.41/job/{job_id}' in '.jobs[].shared' field
      'POST /slurm/v0.0.41/job/submit' in '.job.shared' and '.jobs[].shared'
      'POST /slurm/v0.0.41/job/allocate' in '.job.shared' and '.jobs[].shared'
 -- sacctmgr - Added possible flags "NoUsersAreCoords" and "UsersAreCoords"
    to `.accounts[].flags` for `sacctmgr show accounts --{json|yaml}` response.
 -- sacct - Add "topo" as possible value to output of 'sacct --{json|yaml}' to
    '.jobs[].shared' field.
 -- squeue - Add "topo" as possible value to output of 'squeue --{json|yaml}' to
    '.jobs[].shared' field.
 -- scontrol - Add "topo" as possible value to output of
    'scontrol show jobs --{json|yaml}' to '.jobs[].shared' field.
 -- slurmrestd - Add "topo" as possible value to the following:
      'GET /slurm/v0.0.41/jobs' in '.jobs[].exclusive' field
      'GET /slurm/v0.0.41/job/{job_id}' in '.jobs[].exclusive' field
      'POST /slurm/v0.0.41/job/submit' in '.job.exclusive' and
        '.jobs[].exclusive'
      'POST /slurm/v0.0.41/job/allocate' in '.job.exclusive' and
        '.jobs[].exclusive'
 -- sacctmgr - Added possible flags "RemoveUsersAreCoords" and "UsersAreCoords"
    to `.accounts[].flags` for `sacctmgr show accounts --{json|yaml}` response.
 -- sacct - Add "topo" as possible value to output of 'sacct --{json|yaml}' to
    '.jobs[].exclusive' field.
 -- squeue - Add "topo" as possible value to output of 'squeue --{json|yaml}' to
    '.jobs[].exclusive' field.
 -- scontrol - Add "topo" as possible value to output of
    'scontrol show jobs --{json|yaml}' to '.jobs[].exclusive' field.
 -- slurmrestd - Add fields '.job.segment_size' and '.jobs[].segment_size' to
    'POST /slurm/v0.0.41/job/submit' and 'POST /slurm/v0.0.41/job/allocate'.
 -- sacctmgr - Added possible flags "NoUsersAreCoords" and "UsersAreCoords"
    to `.associations[].flags` for `sacctmgr show assocs --{json|yaml}`
    response.
 -- slurmrestd - Added possible flags "NoUsersAreCoords" and "UsersAreCoords" to
    `.associations[].flags` for "GET /slurmdb/v0.0.41/associations/"
    and "POST /slurmdb/v0.0.41/associations/" endpoints.
 -- Add ability to reserve MPI ports at the job level for stepmgr jobs and
    subdivide them at the step level.
 -- slurmrestd - Fix possible memory leak from failed job submissions to
    'POST /slurm/v0.0.{39,40,41}/job/submit'.
 -- slurmrestd - Fix possible memory leak from failed job allocation requests to
    'POST /slurm/v0.0.{39,40,41}/job/allocate'.

* Changes in Slurm 23.11.11
===========================

* Changes in Slurm 23.11.10
===========================
 -- switch/hpe_slingshot - Fix issue that could result in a 0 length state file.
 -- Fix unnecessary message protocol downgrade for unregistered nodes.
 -- Fix unnecessarily packing alias addrs when terminating jobs with a mix of
    non-cloud/dynamic nodes and powered down cloud/dynamic nodes.
 -- Fix allowing access to reservations without MaxStartDelay set.
 -- Fix scontrol allowing updating job with bad cpus-per-task value.
 -- sattach - Fix regression from 23.11.9 security fix leading to crash.

* Changes in Slurm 23.11.9
==========================
 -- Fix many commands possibly reporting an "Unexpected Message Received" when
    in reality the connection timed out.
 -- Fix heterogeneous job components not being signaled with scancel --ctld and
    'DELETE slurm/v0.0.40/jobs' if the job ids are not explicitly given,
    the heterogeneous job components match the given filters, and the
    heterogeneous job leader does not match the given filters.
 -- Fix regression from 23.02 impeding job licenses from being cleared.
 -- Move error to log_flag which made _get_joules_task error to be logged to the
    user when too many rpcs were queued in slurmd for gathering energy.
 -- slurmrestd - Prevent a slurmrestd segfault when modifying an association
    without specifying max TRES limits in the request if those TRES
    limits are currently defined in the association. This affects the following
    fields of endpoint 'POST /slurmdb/v0.0.38/associations/':
      'associations/max/tres/per/job'
      'associations/max/tres/per/node'
      'associations/max/tres/total'
      'associations/max/tres/minutes/per/job'
      'associations/max/tres/minutes/total'
 -- Fix power_save operation after recovering from a failed reconfigure.
 -- scrun - Delay shutdown until after start requested. This caused scrun
    to never start or shutdown and hung forever when using --tty.
 -- Fix backup slurmctld potentially not running the agent when taking over as
    the primary controller.
 -- Fix primary controller not running the agent when a reconfigure of the
    slurmctld fails.
 -- jobcomp/{elasticsearch,kafka} - Avoid sending fields with invalid date/time.
 -- Fix energy gathering rpc counter underflow in _rpc_acct_gather_energy when
    more than 10 threads try to get energy at the same time. This prevented
    the possibility to get energy from slurmd by any step until slurmd was
    restarted, so losing energy accounting metrics in the node.
 -- slurmrestd - Fix memory leak for dbv0.0.39 jobs query which occurred if the
    query parameters specified account, association, cluster, constraints,
    format, groups, job_name, partition, qos, reason, reservation, state, users,
    or wckey. This affects the following endpoints:
      'GET /slurmdb/v0.0.39/jobs'
 -- switch/hpe_slingshot - Fix security issue around managing VNI access.
    CVE-2024-42511.

* Changes in Slurm 23.11.8
==========================
 -- Fix slurmctld crash when reconfiguring with a PrologSlurmctld is running.
 -- Fix slurmctld crash after a job has been resized.
 -- Fix slurmctld and slurmdbd potentially stopping instead of performing a
    logrotate when recieving SIGUSR2 when using auth/slurm.
 -- Fix not having a disabled value for keepalive CommunicationParameters in
    slurm.conf when these parameters are not set. This can log an error when
    setting a socket, for example during slurmdbd registration with ctld.
 -- switch/hpe_slingshot - Fix slurmctld crash when upgrading from 23.02.
 -- Fix "Could not find group" errors from validate_group() when using
    AllowGroups with large /etc/group files.
 -- slurmrestd - Prevent a slurmrestd segfault when parsing the crontab field,
    which was never usable. Now it explicitly ignores the value and emits a
    warning if it is used for the following endpoints:
      'POST /slurm/v0.0.39/job/{job_id}'
      'POST /slurm/v0.0.39/job/submit'
      'POST /slurm/v0.0.40/job/{job_id}'
      'POST /slurm/v0.0.40/job/submit'
 -- Fix getting user environment when using sbatch with "--get-user-env" or
    "--export=" when there is a user profile script that reads /proc.
 -- Prevent slurmd from crashing if acct_gather_energy/gpu is configured but
    GresTypes is not configured.
 -- Do not log the following errors when AcctGatherEnergyType plugins are used
    but a node does not have or cannot find sensors:
    "error: _get_joules_task: can't get info from slurmd"
    "error: slurm_get_node_energy: Zero Bytes were transmitted or received"
    However, the following error will continue to be logged:
    "error: Can't get energy data. No power sensors are available. Try later"
 -- Fix cloud nodes not being able to forward to nodes that restarted with new
    IP addresses.
 -- sacct - Fix printing of job group for job steps.
 -- Fix error in scrontab jobs when using slurm.conf:PropagatePrioProcess=1.
 -- Fix slurmctld crash on a batch job submission with "--nodes 0,...".
 -- Fix dynamic IP address fanout forwarding when using auth/slurm.

* Changes in Slurm 23.11.7
==========================
 -- slurmrestd - Correct OpenAPI specification for
    'GET /slurm/v0.0.40/jobs/state' having response as null.
 -- Allow running jobs on overlapping partitions if jobs don't specify -s.
 -- Fix segfault when requesting a shared gres along with an exclusive
    allocation.
 -- Fix regression in 23.02 where afternotok and afterok dependencies were
    rejected for federated jobs not running on the origin cluster of the
    submitting job.
 -- slurmctld - Disable job table locking while job state cache is active when
    replying to `squeue --only-job-state` or `GET /slurm/v0.0.40/jobs/state`.
 -- Fix sanity check when setting tres-per-task on the job allocation as well as
    the step.
 -- slurmrestd - Fix compatiblity with auth/slurm.
 -- Fix issue where TRESRunMins gets off correct value if using
    QOS UsageFactor != 1.
 -- slurmrestd - Require `user` and `association_condition` fields to be
    populated for requests to 'POST /slurmdb/v0.0.40/users_association'.
 -- Avoid a slurmctld crash with extra_constraints enabled when a job requests
    certain invalid --extra values.
 -- `scancel --ctld` and `DELETE /slurm/v0.0/40/jobs` - Fix support for job
    array expressions (e.g. 1_[3-5]). Also fix signaling a single pending array
    task (e.g. 1_10), which previously signaled the whole array job instead.
 -- Fix a possible slurmctld segfault when at some point we failed to create an
    external launcher step.
 -- Allow the slurmctld to open a connection to the slurmdbd if the first
    attempt fails due to a protocol error.
 -- mpi/cray_shasta - Fix launch for non-het-steps within a hetjob.
 -- sacct - Fix "gpuutil" TRES usage output being incorrect when using --units.
 -- Fix a rare deadlock on slurmctld shutdown or reconfigure.
 -- Fix issue that only left one thread on each core available when "CPUs=" is
    configured to total thread count on multi-threaded hardware and no other
    topology info ("Sockets=", "CoresPerSocket", etc.) is configured.
 -- Fix the external launcher step not being allocated a VNI when requested.
 -- jobcomp/kafka - Fix payload length when producing and sending a message.
 -- scrun - Avoid a crash if RunTimeDelete is called before the container
    finishes.
 -- Save the slurmd's cred_state while reconfiguring to prevent the loss job
    credentials.

* Changes in Slurm 23.11.6
==========================
 -- Avoid limiting sockets per node to one when using gres enforce-binding.
 -- slurmrestd - Avoid permission denied errors when attempting to listen on
    the same port multiple times.
 -- Fix GRES reservations where the GRES has no topology
    (no cores= in gres.conf).
 -- Ensure that thread_id_rpc is gone before priority_g_fini().
 -- Fix scontrol reboot timeout removing drain state from nodes.
 -- squeue - Print header on empty reponse to `--only-job-state`.
 -- Fix slurmrestd not ending job properly when xauth is not present and a x11
    job is sent.
 -- Add experimental job state caching with
    SchedulerParameters=enable_job_state_cache to speed up querying job states
    with squeue --only-job-state.
 -- slurmrestd - Correct dumping of invalid ArrayJobIds returned from
    'GET /slurm/v0.0.40/jobs/state'.
 -- squeue - Correct dumping of invalid ArrayJobIds returned from
    `squeue --only-job-state --{json|yaml}`.
 -- If scancel --ctld is not used with --interactive, --sibling, or specific
    step ids, then this option issues a single request to the slurmctld to
    signal all jobs matching the specified filters. This greatly improves
    the performance of slurmctld and scancel. The updated --ctld option also
    fixes issues with the --partition or --reservation scancel options for jobs
    that requested multiple partitions or reservations.
 -- slurmrestd - Give EINVAL error when failing to parse signal name to numeric
    signal.
 -- slurmrestd - Allow ContentBody for all methods per RFC7230 even if ignored.
 -- slurmrestd - Add 'DELETE /slurm/v0.0.40/jobs' endpoint to allow bulk job
    signaling via slurmctld.
 -- Fix combination of --nodelist and --exclude not always respecting the
    excluded node list.
 -- Fix jobs incorrectly allocating nodes exclusively when started on a
    partition that doesn't enforce it. This could happen if a multi-partition
    job doesn't specify --exclusive and is evaluated first on a partition
    configured with OverSubscribe=EXCLUSIVE but ends up starting in a partition
    configured with OverSubscribe!=EXCLUSIVE evaluated afterwards.
 -- Setting GLOB_SILENCE flag no longer exposes old bugged behavior.
 -- Fix associations AssocGrpCPURunMinutes being incorrectly computed for
    running jobs after a controller reconfiguration/restart.
 -- Fix scheduling jobs that request --gpus and nodes have different node
    weights and different numbers of gpus.
 -- slurmrestd - Add "NO_CRON_JOBS" as possible flag value to the following:
      'DELETE /slurm/v0.0.40/jobs' flags field.
      'DELETE /slurm/v0.0.40/job/{job_id}?flags=' flags query parameter.
 -- Fix scontrol segfault/assert failure if the TRESPerNode parameter is used
    when creating reservations.
 -- Avoid checking for wsrep_on when restoring streaming replication settings.
 -- Clarify in the logs that error "1193 Unknown system variable 'wsrep_on'" is
    innocuous.
 -- accounting_storage/mysql - Fix problem when loading reservations from an
    archive dump.
 -- slurmdbd - Fix minor race condition when sending updates to a shutdown
    slurmctld.
 -- slurmctld - Fix invalid refusal of a reservation update.
 -- openapi - Fix memory leak of /meta/slurm/cluster response field.
 -- Fix memory leak when using auth/slurm and AuthInfo=use_client_ids.

* Changes in Slurm 23.11.5
==========================
 -- Fix Debian package build on systems that are not able to query the systemd
    package.
 -- data_parser/v0.0.40 - Emit a warning instead of an error if a disabled
    parser is invoked.
 -- slurmrestd - Improve handling when content plugins rely on parsers
    that haven't been loaded.
 -- Fix old pending jobs dying (Slurm version 21.08.x and older) when upgrading
    Slurm due to "Invalid message version" errors.
 -- Have client commands sleep for progressively longer periods when backed off
    by the RPC rate limiting system.
 -- slurmctld - Ensure agent queue is flushed correctly at shutdown time.
 -- slurmdbd - correct lineage construction during assoc table conversion for
    partition based associations.
 -- Add new RPCs and API call for faster querying of job states from slurmctld.
 -- slurmrestd - Add endpoint '/slurm/{data_parser}/jobs/state'.
 -- squeue - Add `--only-job-state` argument to use faster query of job states.
 -- Make a job requesting --no-requeue, or JobRequeue=0 in the slurm.conf,
    supersede RequeueExit[Hold].
 -- Add sackd man page to the Debian package.
 -- Fix issues with tasks when a job was shrinked more than once.
 -- Fix reservation update validation that resulted in reject of correct
    updates of reservation when the reservation was running jobs.
 -- Fix possible segfault when the backup slurmctld is asserting control.
 -- Fix regression introduced in 23.02.4 where slurmctld was not properly
    tracking the total GRES selected for exclusive multi-node jobs, potentially
    and incorrectly bypassing limits.
 -- Fix tracking of jobs typeless GRES count when multiple typed GRES with the
    same name are also present in the job allocation. Otherwise, the job could
    bypass limits configured for the typeless GRES.
 -- Fix tracking of jobs typeless GRES count when request specification has a
    typeless GRES name first and then typed GRES of different names (i.e.
    --gres=gpu:1,tmpfs:foo:2,tmpfs:bar:7). Otherwise, the job could bypass
    limits configured for the generic of the typed one (tmpfs in the example).
 -- Fix batch step not having SLURM_CLUSTER_NAME filled in.
 -- slurmstepd - Avoid error during `--container` job cleanup about
    RunTimeQuery never being configured. Results in cleanup where job steps not
    fully started.
 -- Fix nodes not being rebooted when using salloc/sbatch/srun "--reboot" flag.
 -- Send scrun.lua in configless mode.
 -- Fix rejecting an interactive job whose extra constraint request cannot
    immediately be satisfied.
 -- Fix regression in 23.11.0 when parsing LogTimeFormat=iso8601_ms that
    prevented milliseconds from being printed.
 -- Fix issue where you could have a gpu allocated as well as a shard on that
    gpu allocated at the same time.
 -- Fix slurmctld crashes when using extra constraints with job arrays.
 -- sackd/slurmrestd/scrun - Avoid memory leak on new unix socket connection.
 -- The failed node field is filled when a node fails but does not time out.
 -- topology/block - Implement topology_p_generate_node_ranking().
 -- slurmrestd - Remove requiring job script field and job component script
    fields to both be populated in the `POST /slurm/v0.0.40/job/submit`
    endpoint as there can only be one batch step script for a job.
 -- slurmrestd - When job script is provided in '.jobs[].script' and '.script'
    fields, the '.script' field's value will be used in the
    `POST /slurm/v0.0.40/job/submit` endpoint.
 -- slurmrestd - Reject HetJob submission missing or empty batch script for
    first Het component in the `POST /slurm/v0.0.40/job/submit` endpoint.
 -- slurmrestd - Reject job when empty batch script submitted to the
    POST /slurm/v0.0.40/job/submit` endpoint.
 -- Fix pam_slurm and pam_slurm_adopt when using auth/slurm.
 -- slurmrestd - Add 'cores_per_socket' field to
    `POST /slurm/v0.0.40/job/submit` endpoint.
 -- Fix srun and other Slurm commands running within a "configless" salloc when
    salloc itself fetched the config.
 -- Enforce binding with shared gres selection if requested.
 -- Fix job allocation failures when the requested tres type or name ends in
    "gres" or "license".
 -- accounting_storage/mysql - Fix lineage string construction when adding a
    user association with a partition.
 -- Fix sattach command.
 -- Fix ReconfigFlags. Due how reconfig was changed in 23.11, they will also
    be used to influence the slurmctld startup as well.
 -- Fix starting slurmd in configless mode if MUNGE support was disabled.

* Changes in Slurm 23.11.4
==========================
 -- Fix a memory leak when updating partition nodes.
 -- Don't leave a partition around if it fails to create with scontrol.
 -- Fix segfault when creating partition with bad node list from scontrol.
 -- Fix preserving partition nodes on bad node list update from scontrol.
 -- Fix assertion in developer mode on a failed message unpack.
 -- Fix repeat POWER_DOWN requests making the nodes available for ping.
 -- Fix rebuilding job alias_list on restart when nodes are still powering up.
 -- Fix INVALID nodes running health check.
 -- Fix cloud/future nodes not setting addresses on invalid registration.
 -- scrun - Remove the requirement to set the SCRUN_WORKING_DIR environment
    variable. This was a regression in 23.11.
 -- Add warning for using select/linear with topology/tree.
    This combination will not be supported in the next major version.
 -- Fix health check program not being run after first pass of all nodes when
    using MaxNodeCount.
 -- sacct - Set process exit code to one for all errors.
 -- Add SlurmctldParameters=disable_triggers option.
 -- Fix issue running steps when the allocation requested an exclusive
    allocation shards along with shards.
 -- Fix cleaning up the sleep process and the cgroup of the extern step if
    slurm_spank_task_post_fork returns an error.
 -- slurm_completion - Add missing --gres-flags= options
    multiple-tasks-per-sharing and one-task-per-sharing.
 -- scrun - Avoid race condition that could cause outbound network
    communications to incorrectly rejected with an incomplete packet error.
 -- scrun - Gracefully handle kernel giving invalid expected number of incoming
    bytes for a connection causing incoming packet corruption resulting in
    connection getting closed.
 -- srun - return 1 when a step lauch fails
 -- scrun - Avoid race condition that could cause deadlock during shutdown.
 -- Fix scontrol listpids to work under dynamic node scenarios.
 -- Add --tres-bind to --help and --usage output.
 -- Add --gres-flags=allow-task-sharing to allow GPUs to still be accessible
    among all tasks when binding GPUs to specific tasks.
 -- Fix issue with CUDA_VISIBLE_DEVICES showing the same MIG device for all
    tasks when using MIGs with --tres-per-task or --gpus-per-task.
 -- slurmctld - Prevent a potential hang during shutdown/reconfigure if the
    association cache thread was previously shut down.
 -- scrun - Avoid race condition that could cause scrun to hang during
    shutdown when connections have pending events.
 -- scrun - Avoid excessive polling of connections during shutdown that could
    needlessly cause 100% CPU usage on a thread.
 -- sbcast - Use user identity from broadcast credential instead of looking it
    up locally on the node.
 -- scontrol - Remove "abort" option handling.
 -- Fix an error message referring to the wrong RPC.
 -- Fix memory leak on error when creating dynamic nodes.
 -- Fix a slurmctld segfault when a cloud/dynamic node changes hostname on
    registration.
 -- Prevent a slurmctld deadlock if the gpu plugin fails to load when
    creating a node.
 -- Change a slurmctld fatal() to an error() when attempting to create a
    dynamic node with a global autodetect set in gres.conf.
 -- Fix leaving node records on error when creating nodes with scontrol.
 -- scrun/sackd - Avoid race condition where shutdown could deadlock.
 -- Fix a regression in 23.02.5 that caused pam_slurm_adopt to fail when
    the user has multiple jobs on a node.
 -- Add GLOB_SILENCE flag that silences the error message which will display if
    an include directive attempts to use the "*" wildcard.
 -- Fix jobs getting rejected when submitting with --gpus option from older
    versions of job submission commands (23.02 and older).
 -- cgroup/v2 - Return 0 for VSZ. Kernel cgroups do not provide this metric.
 -- scrun - Avoid race condition where outbound RPCs could be corrupted.
 -- scrun - Avoid race condition that could cause a crash while compiled in
    debug mode.
 -- gpu/rsmi - Disable gpu usage statistics when not using ROCM 6.0.0+
 -- Fix stuck processes and incorrect environment when using --get-user-env.
 -- Avoid segfault in the slurmdbd when TrackWCKey=no but you are still using
    use WCKeys.
 -- Fix ctld segfault with TopologyParam=RoutePart and no partition defined.
 -- slurmctld - Fix missing --deadline handling for jobs not evaluated by the
    schedulers (i.e. non-runnable, skipped for other reasons, etc.).
 -- Demote some eio related logs from error to verbose in user commands.  These
    are not generally actionable by the user and are easilly generated by port
    scanning a machine running srun.
 -- Make sprio correctly print array tasks that have not yet been split out.
 -- topology/block - Restrict the number of last-level blocks in any allocation.
 -- slurmrestd - Treat multiple repeat URL query values as list.
 -- slurmrestd - Treat all URL query values as string by default to avoid
    parser warnings.

* Changes in Slurm 23.11.3
==========================
 -- Fix debian/changelog file to reflect the correct version so the packages
    are generated correctly.

* Changes in Slurm 23.11.2
==========================
 -- slurmrestd - Reject single http query with multiple path requests.
 -- Fix launching Singularity v4.x containers with srun --container by setting
    .process.terminal to true in generated config.json when step has
    pseudoterminal (--pty) requested.
 -- Fix loading in dyanmic/cloud node jobs after net_cred expired.
 -- Fix cgroup null path error on slurmd/slurmstepd tear down.
 -- data_parser/v0.0.40 - Prevent failure if accounting is disabled, instead
    issue a warning if needed data from the database can not be retrieved.
 -- openapi/slurmctld - Prevent failure if accounting is disabled.
 -- Prevent slurmscriptd processing delays from blocking other threads in
    slurmctld while trying to launch various scripts. This is additional work
    for a fix in 23.02.6.
 -- Fix memory leak when receiving alias addrs from controller.
 -- scontrol - Accept `scontrol token lifespan=infinite` to create tokens that
    effectively do not expire.
 -- Avoid errors when Slurmdb accounting disabled when '--json' or '--yaml' is
    invoked with CLI commands and slurmrestd. Add warnings when query would
    have populated data from Slurmdb instead of errors.
 -- Fix slurmctld memory leak when running job with --tres-per-task=gres:shard:#
 -- Fix backfill trying to start jobs outside of backfill window.
 -- Fix oversubscription on partitions with PreemptMode=OFF.
 -- Preserve node reason on power up if the node is downed or drained.
 -- data_parser/v0.0.40 - Avoid aborting when invoking a not implemented
    parser.
 -- data_parser/v0.0.40 - Fix how nice values are parsed for job submissions.
 -- data_parser/v0.0.40 - Fix regression where parsing error did not result in
    invalid request being rejected.
 -- Fix segfault in front-end node registration.
 -- Prevent jobs using none typed gpus from being killed by the controller after
    a reconfig or restart.
 -- Fix deadlock situation in the dbd when adding associations.
 -- Update default values of text/blob columns when updating from old mysql
    versions in more situations.  This improves a previous fix to handle an
    uncommon case when upgrading mysql/mariadb.
 -- Fix rpmbuild in openSUSE/SLES due to incorrect mariadb dependency.
 -- Fix compilation on RHEL 7.
 -- When upgrading the slurmdbd to 23.11, avoid generating a query to update
    the association table that is larger than max_allowed_packet which would
    result in an upgrade failure.
 -- Fix rare deadlock when a dynamic node registers at the same time that a
    once per minute background task occurs.
 -- Fix build issue on 32-bit systems.
 -- data_parser/v0.0.40 - Fix enumerated strings in OpenAPI specification not
    have type field specified.
 -- Improve scontrol show job -d information of used shared gres (shard/mps)
    topology.
 -- Allow Slurm to compile without MUNGE if --without-munge is used as an
    argument to configure.
 -- accounting_storage/mysql - Fix usage query to use new lineage column
    instead of lft/rgt.
 -- slurmrestd - Improve handling of missing parsers when content plugins
    expect parsers not loaded.
 -- slurmrestd - Correct parsing of StepIds when querying jobs.
 -- slurmrestd - Improve error from parsing failures of lists.
 -- slurmrestd - Improve parsing of singular values for lists.
 -- accounting_storage/mysql - Fix PrivateData=User when listing associations.
 -- Disable sorting of dynamic nodes to avoid issues when restarting with
    heterogenous jobs that cause jobs to abort on restart.
 -- Don't allow deletion of non-dynamic nodes.
 -- accounting_storage/mysql - Fix issue adding partition based associations.
 -- Respect non-"slurm" settings for I_MPI_HYDRA_BOOTSTRAP and HYDRA_BOOTSTRAP
    and avoid injecting the --external-launcher option which will cause
    mpirun/mpiexec to fail with an unexpected argument error.
 -- Fix bug where scontrol hold would change node count for jobs with
    implicitly defined node counts.
 -- data_parser/v0.0.40 - Fix regression of support for "hold" in
    job description.
 -- Avoid sending KILL RPCs to unresolvable POWERING_UP and POWERED_DOWN nodes.
 -- data_parser/v0.0.38 - Fix several potential NULL dereferences that could
    cause slurmrestd to crash.
 -- Add --gres-flags=one-task-per-sharing. Do not allow different tasks in to be
    allocated shared gres from the same sharing gres.
 -- Add SelectTypeParameters=ENFORCE_BINDING_GRES and ONE_TASK_PER_SHARING_GRES.
    This gives default behavior for a job's --gres-flags.
 -- Alter the networking code to try connecting to the backup controllers
    if the DNS lookup for the primary SlurmctldHost fails.
 -- Alter the name resolution to only log at verbose() in client commands
    on failures. This allows for HA setups where the DNS entries are withdrawn
    for some SlurmctldHost entries without flooding the user with errors.
 -- Prevent slurmscriptd PID leaks when running slurmctld in foreground mode.
 -- Open all slurmctld listening ports at startup, and persist throughout.
    This also changes the backup slurmctld process to open the SlurmctldPort
    range, instead of only the first.
 -- Fix backup slurmctld shutting down instead of resuming standby duty if it
    took control.
 -- Fix race condition that delayed the primary slurmctld resuming when taking
    control from a backup controller.
 -- srun - Ensure processed messages are meant for this job in case of a
    rapidly-reused TCP port.
 -- srun - Prevent step launch failure while waiting for step allocation if
    a stray message is received.
 -- Fix backup slurmctld to be able to respond to configless config file
    requests correctly.
 -- Fix slurmctld crashing when recovering from a failed reconfigure.
 -- Fix slurmscriptd operation after recovering from a failed reconfigure.

* Changes in Slurm 23.11.1
==========================
 -- Fix scontrol update job=... TimeLimit+=/-= when used with a raw JobId of job
    array element.
 -- Reject TimeLimit increment/decrement when called on job with
    TimeLimit=UNLIMITED.
 -- Fix slurmctld segfault when reconfiguring after a job resize.
 -- Fix compilation on FreeBSD.
 -- Fix issue with requesting a job with --licenses as well as
    --tres-per-task=license.
 -- slurmctld - Prevent segfault in getopt_long() with an invalid long option.
 -- Switch to man2html-base in Build-Depends for Debian package.
 -- slurmrestd - Added /meta/slurm/cluster field to responses.
 -- Adjust systemd service files to start daemons after remote-fs.target.
 -- Add "--with selinux" option to slurm.spec.
 -- Fix task/cgroup indexing tasks in cgroup plugins, which caused
    jobacct/gather to match the gathered stats with the wrong task id.
 -- select/linear - Fix regression in 23.11 in which jobs that requested
    --cpus-per-task were rejected.
 -- Fix crash in slurmstepd that can occur when launching tasks via mpi using
    the pmi2 plugin and using the route/topology plugin.
 -- Fix sgather not gathering from all nodes when using CR_PACK_NODES/--m pack.
 -- Fix mysql query syntax error when getting jobs with private data.
 -- Fix sanity check to prevent deleting default account of users.
 -- data_parser/v0.0.40 - Fix the parsing for /slurmdb/v0.0.40/jobs exit_code
    query parameter.
 -- Fix issue where TRES for energy wasn't always set before sending it to the
    jobcomp plugin.
 -- jobcomp/[kafka|elastisearch] Print raw TRES values along with the
    formatted versions as tres_[req|alloc]_raw.
 -- Fix inconsistencies with --cpu-bind/SLURM_CPU_BIND and --hint/SLURM_HINT.
 -- Fix ignoring invalid json in various subsystems.
 -- Remove shebang from bash completion script.
 -- Fix elapsed time in JobComp being set from invalid start and end times.
 -- Update service files to start slurmd, slurmctld, and slurmdbd after sssd.
 -- data_parser/v0.0.40 - Fix output of DefMemPerCpu, MaxMemPerCpu, and
    max_shares.
 -- When determining a jobs index in the database don't wait if there are more
    jobs waiting.
 -- If a job requests more shards which would allocate more than one sharing
    GRES (gpu) per node refuse it unless SelectTypeparameters has
    MULTIPLE_SHARING_GRES_PJ.
 -- Avoid refreshing the hwloc xml file when slurmd is reconfigured. This fixes
    an issue seen with CoreSpecCount used on nodes with Intel E-cores.
 -- Trigger fatal exit when Slurm API function is called before slurm_init() is
    called.
 -- slurmd - Fix issue with 'scontrol reconfigure' when started with '-c'.
 -- data_parser/v0.0.40 - Fix handling of negative job nice values.
 -- data_parser/v0.0.40 - Fill the "id" object for associations with the
    cluster, account, partition, and user in addition to the assoc id.
 -- data_parser/v0.0.40 - Remove unusable cpu_binding_flags enums from
    v00.0.40_job_desc_msg.
 -- Improve performance and resiliency of slurmscriptd shutdown on
    'scontrol reconfigure'.
 -- slurmrestd - Job submissions that result in the following error codes
    will be considered as successfully submitted (with a warning), instead
    of returning an HTTP 500 error back:
    ESLURM_NODES_BUSY, ESLURM_RESERVATION_BUSY, ESLURM_JOB_HELD,
    ESLURM_NODE_NOT_AVAIL, ESLURM_QOS_THRES, ESLURM_ACCOUNTING_POLICY,
    ESLURM_RESERVATION_NOT_USABLE, ESLURM_REQUESTED_PART_CONFIG_UNAVAILABLE,
    ESLURM_BURST_BUFFER_WAIT, ESLURM_PARTITION_DOWN,
    ESLURM_LICENSES_UNAVAILABLE.
 -- Fix issue with node appearing to reboot on every "scontrol reconfigure"
    when slurmd was started with the '-b' flag.
 -- Fix a slurmctld fatal error when upgrading to 23.11 and changing from
    select/cons_res to select/cons_tres at the same time.
 -- slurmctld - Fix subsequent reconfigure hanging after a failed reconfigure.
 -- slurmctld - Reject arbitrary distribution jobs that have a minimum node
    count that differs from the number of unique nodes in the hostlist.
 -- Prevent slurmdbd errors when updating reservations with names containing
    apostrophes.
 -- Prevent message extension attacks that could bypass the message hash.
    CVE-2023-49933.
 -- Prevent SQL injection attacks in slurmdbd. CVE-2023-49934.
 -- Prevent message hash bypass in slurmd which can allow an attacker to reuse
    root-level MUNGE tokens and escalate permissions. CVE-2023-49935.
 -- Prevent NULL pointer dereference on size_valp overflow. CVE-2023-49936.
 -- Prevent double-xfree() on error in _unpack_node_reg_resp().
    CVE-2023-49937.

* Changes in Slurm 23.11.0
==========================
 -- For jobs that request --cpus-per-gpu, ensure that the --cpus-per-gpu request
    is honored on every node in the and not just for the job as a whole.
 -- Fix "srun -Z" for cred/munge and cred/none.
 -- Fix listing available data_parser plugins for json and yaml when giving no
    commands to scontrol or sacctmgr.
 -- data_parser/v0.0.40 - Fixed how deleted QOS and associations for jobs are
    dumped.
 -- data_parser/v0.0.40 - Fix how errors and warnings are dumped.
 -- Print consistent errors when serializer plugin fails to load.
 -- data_parser/v0.0.40 - Fix parsing of flag arrays to allow muliple flags to
    be set.
 -- slurmctld - Rework 'scontrol reconfigure' to avoid race conditions that
    can result in stray jobs.
 -- slurmctld - Shave ~1 second off average reconfigure time by terminating
    internal processing threads faster.
 -- Skip running slurmdbd -R if the connected cluster is 23.11 or newer.
    This operation is nolonger relevant for 23.11.
 -- Fix segfault when updating node instance id/type without accounting enabled.
 -- Ensure slurmscriptd shuts down before slurmctld is stopped / reconfigured.
 -- Improve error handling and error messages in slurmctld to slurmscriptd
    communications. This includes avoiding potential deadlock in slurmctld if
    slurmscript dies unexpectedly.
 -- Do not hold batch jobs whose extra constraints cannot be immediately
    satisfied, and set the state reason to "Constraints" instead of
    "BadConstraints".
 -- Fix verbose log message printing a hex number instead of a job id.
 -- Upgrade rate limit parameters message from debug to info.
 -- Fix missing symbols for those linking to libslurm.
 -- Fix memory leak when getting and forwarding addrs from client.
 -- Fix xassert when forwarding to non-addressable nodes.
 -- Fix regression in 23.11.0rc1 where assocs were created with an incorrect
    hierarchy for non-23.11 clusters.
 -- For SchedulerParameters=extra_constraints, prevent slurmctld segfault when
    starting a slurmd with --extra for a node that did not previously set this.
    This also ensures the extra constraints model works off the current node
    state, not the prior state.
 -- Fix regression in 23.11.0rc1 where data_t would not decode negative float
    values correctly, instead the absolute value was always returned.
 -- Fix issue where 'scontrol reconfigure' right as the controller was started
    or reconfigured could lead to it shutting down completely.
 -- Fix --tres-per-task assertion.
 -- Fix a few issues when creating reservations.
 -- Fix slurmctld segfault when packing a job step loaded from a < 23.11 state.
 -- Fix a 32-bit compile issue.
 -- Add SchedulerParameters=time_min_as_soft_limit option.

* Changes in Slurm 23.11.0rc1
=============================
 -- task/affinity - remove Power7 cpu-specific workarounds.
 -- Remove SLURM_WORKING_CLUSTER env from batch and srun environments.
 -- cli_filter/lua - return nil for unset time options rather than the string
    "2982616-04:14:00" (which is the internal macro "NO_VAL" represented as
    time string).
 -- Remove 'none' plugins for all but auth and cred. scontrol show config
    will report (null) now.
 -- Removed select/cons_res. Please update your configuration to
    select/cons_tres.
 -- mpi/pmix - When aborted with status 0, avoid marking job/step as failed.
 -- Fixed typo on "initialized" for the description of ESLURM_PLUGIN_NOT_LOADED.
 -- Added max_submit_line_size to SchedulerParameters.
 -- Change TreeWidth default from 50 to 16.
 -- cgroup.conf - Removed deprecated parameters AllowedKmemSpace,
    ConstrainKmemSpace, MaxKmemPercent, and MinKmemSpace.
 -- proctrack/cgroup - Add "SignalChildrenProcesses=<yes|no>" option to
    cgroup.conf. This allows signals for cancelling, suspending, resuming, etc.
    to be sent to children processes in a step/job rather than just the parent.
 -- Add PreemptParameters=suspend_grace_time parameter to control amount of
    time between SIGTSTP and SIGSTOP signals when suspending jobs.
 -- job_submit/throttle - improve reset of submitted job counts per user in
    order to better honor SchedulerParameters=jobs_per_user_per_hour=#.
 -- Load the user environment into a private pid namespace to avoid user scripts
    leaving background processes on a node.
 -- scontrol show assoc_mgr will display Lineage instead of Lft for
    associations.
 -- Add SlurmctldParameters=no_quick_restart to avoid a new slurmctld taking
    over the old slurmctld on accedent.
 -- Fix --cpus-per-gpu for step allocations, which was previously ignored for
    job steps. --cpus-per-gpu implies --exact.
 -- Fix mutual exclusivity of --cpus-per-gpu and --cpus-per-task: fatal if both
    options are requested in the commandline or both are requested in the
    environment. If one option is requested in the command line, it will
    override the other option in the environment.
 -- slurmrestd - openapi/dbv0.0.37 and openapi/v0.0.37 plugins have been
    removed.
 -- slurmrestd - openapi/dbv0.0.38 and openapi/v0.0.38 plugins have been tagged
    as deprecated.
 -- openapi/slurmctld - forked from openapi/v0.0.38.
 -- openapi/slurmdbd - forked from openapi/dbv0.0.38.
 -- data_parser/v0.0.40 - forked from data_parser/v0.0.39 plugin.
 -- data_parser/v0.0.40 - added OpenAPI schema generation of path parameters
    and OperationIds.
 -- slurmrestd - added auto population of info/version field.
 -- openapi/slurmctld - convert to using data_parser plugins for all input and
    output formatting.
 -- openapi/slurmdbd - convert to using data_parser plugins for all input and
    output formatting.
 -- data_parser/v0.0.39 - skip empty string when parsing QOS ids.
 -- data_parser/v0.0.40 - skip empty string when parsing QOS ids.
 -- data_parser/v0.0.40 - log errors on every level of parsing on failure.
 -- sdiag - add --yaml and --json arg support to specify data_parser plugin.
 -- sacct - add --yaml and --json arg support to specify data_parser plugin.
 -- scontrol - add --yaml and --json arg support to specify data_parser plugin.
 -- sinfo - add --yaml and --json arg support to specify data_parser plugin.
 -- squeue - add --yaml and --json arg support to specify data_parser plugin.
 -- data_parser/v0.0.40 - add warnings for unknown fields during parsing.
 -- data_parser/v0.0.40 - add FAST parameter to allow requestor to skip more
    time intensive warning checks.
 -- Changed the default SelectType to select/cons_tres (from select/linear).
 -- Allow SlurmUser/root to use reservations without specific permissions.
 -- Fix sending step signals to nodes not allocated by the step.
 -- Remove CgroupAutomount= option from cgroup.conf.
 -- Add TopologyRoute=RoutePart to route communications based on partition node
    lists.
 -- SPANK - added new spank_prepend_task_argv() function.
 -- slurmd - improve error logging at job startup during transition from slurmd
    to slurmstepd.
 -- Added ability for configless to push Prolog and Epilog scripts to slurmds.
 -- Prolog and Epilog do not have to be fully qualified pathnames.
 -- Changed default value of PriorityType from priority/basic to
    priority/multifactor.
 -- torque/mpiexec - Propogate exit code from launched process.
 -- slurmrestd - Add new rlimits fields for job submission.
 -- data_parser/v0.0.40 - convert job state field to flag array to provide
    enumeration of values.
 -- sbatch - removed --export-file option (used with defunct Moab integration).
 -- Define SPANK options environment variables when --export=[NIL|NONE] is
    specified.
 -- slurmrestd - Numeric input fields provided with a null formatted value will
    now convert to zero (0) where it can be a valid value. This is expected to
    be only be notable with job submission against v0.0.38 versioned endpoints
    with job requests with fields provided with null values. These fields were
    already rejected by v0.0.39+ endpoints, unless +complex parser value is
    provided to v0.0.40+ endpoints.
 -- slurmrestd - Improve parsing of integers and floating point numbers when
    handling incoming user provided numeric fields. Fields that would have not
    rejected a number for a numeric field followed by other non-numeric
    characters will now get rejected. This is expected to be only be notable
    with job submission against v0.0.38 versioned endpoints with malformed job
    requests.
 -- Reject reservation update if it will result in previously submitted
    jobs losing access to the reservation.
 -- data_parser/v0.0.40 - output partition state when dumping partitions.
 -- Allow for a shared suffix to be used with the hostlist format. E.g.,
    "node[0001-0010]-int".
 -- Fix perlapi build when using non-default libdir.
 -- Replace SRUN_CPUS_PER_TASK with SLURM_CPUS_PER_TASK and get back the
    previous behavior before Slurm 22.05 since now we have the new external
    launcher step.
 -- data_parser/v0.0.40 - Change v0.0.40_job_info response to tag exit_code
    field as verbose job exit code object.
 -- data_parser/v0.0.40 - Change v0.0.40_job_info response to tag
    derived_exit_code field as verbose job exit code object.
 -- Avoid database upgrade failures with galera by enabling streaming
    replication for Galera 4 clusters during the upgrade process.
 -- job_container/tmpfs - disable plugin for nodes that are not listed in
    job_container.conf when there is no global BasePath set.
 -- job_container/tmpfs - Add "BasePath=none" option to disable plugin on node
    subsets when there is a global setting.
 -- Remove cloud_reg_addrs and make it default behavior.
 -- Remove NoAddrCache CommunicationParameter.
 -- Add QOS flag 'Relative'. If set the QOS limits will be treated as
    percentages of a cluster/partition instead of absolutes.
 -- Remove FIRST_CORES flag from reservations.
 -- scontrol/sview - Remove comma separated CoreCnt option from reservations.
 -- scontrol/sview - Remove comma separated NodeCnt option from reservations.
 -- Add cloud instance id and instance type to node records. Can be viewed/
    updated with scontrol.
 -- slurmd - add "instance-id", "instance-type", and "extra" options to allow
    them to be set on startup.
 -- Add cloud instance accounting to database that can be viewed with 'sacctmgr
    show instance'.
 -- openapi/v0.0.40 - add /instance and /instances endpoints.
 -- SelectTypeParameters=cr_cpu - Fix a log error "CPU underflow" at step
    completion for steps that request --threads-per-core or
    --hint=nomultithread.
 -- select/linear - fix task launch failure that sometimes occurred when
    requesting --threads-per-core or --hint=nomultithread. This also fixes
    memory calculation with one of these options and --mem-per-cpu:
    Previously, memory = mem-per-cpu * all cpus including unusable threads.
    Now, memory = mem-per-cpu * only usuable threads. This behavior matches
    the documentation and select/cons_tres.
 -- gpu/nvml - Reduce chances of NVML_ERROR_INSUFFICIENT_SIZE error when getting
    gpu memory information.
 -- slurmrestd - Convert to generating OperationIDs based on path for all
    v0.0.40 tagged paths.
 -- slurmrestd - Reduce memory used while dumping a job's stdio paths.
 -- slurmrestd - Jobs queried from data_parser/v0.0.40 from slurmdb will have
    'step/id' field given as a string to match CLI formatting instead of an
    object.
 -- sacct - Output in JSON or YAML output will will have the 'step/id' field
    given as a string instead of an object.
 -- scontrol/squeue - Step output in JSON or YAML output will will have the
    'id' field given as a string instead of an object.
 -- slurmrestd - For 'GET /slurmdb/v0.0.40/jobs' mimick default behavior for
    handling of job start and end times as sacct when one or both fields are
    not provided as a query parameter.
 -- openapi/slurmctld - Add 'GET /slurm/v0.0.40/shares' endpoint to dump same
    output as sshare.
 -- sshare - add JSON/YAML support.
 -- data_parser/v0.0.40 - Remove "required/memory" output in json. It is
    replaced by "required/memory_per_cpu" and "required/memory_per_node".
 -- slurmrestd - Add numeric id to all association identifiers to allow unique
    identification where association has been deleted but is still referenced by
    accounting record.
 -- slurmrestd - Add accounting, id, and comment fields to association dumps.
 -- slurmrestd - Removed usage field from association dumps which was never
    populated. See accounting field for accounting usage records.
 -- slurmrestd - Default to not query assocations or coordinators with
    'GET /slurmdb/v0.0.40/accounts'.
 -- slurmrestd - Default to not query assocations, wckeys or coordinators with
    'GET /slurmdb/v0.0.40/user'.
 -- slurmrestd - Enforce user's default wckey on supplied list of user wckeys in
    'POST /slurmdb/v0.0.40/user' queries to avoid conflicting or changed default
    wckey from being ignored.
 -- slurmrestd - Enforce user's default wckey on supplied list of user wckeys in
    'POST /slurmdb/v0.0.40/user' queries to avoid conflicting or changed default
    wckey from being ignored.
 -- slurmrestd - 'POST /slurm/v0.0.40/job/submit' will return "step_id" as
    string to provide descriptive step names (batch, extern, interactive, TBD)
    for non-numeric steps.
 -- slurmrestd - Tagged "result" field from 'POST /slurm/v0.0.40/job/submit'
    as deprecated.
 -- slurmrestd - Warning will be added for rejected job submissions with
    submissions to 'POST /slurm/v0.0.40/job/submit'.
 -- slurmrestd - Tagged "job_id", "step_id", and "job_submit_user_msg" fields
    from 'POST /slurm/v0.0.40/job/{job_id}' response as deprecated due their
    only being valid for the first entry in the "result" field array.
 -- slurmrestd - Warning will be added for rejected job updates with
    queries to 'POST /slurm/v0.0.40/job/{job_id}'.
 -- slurmrestd - Add SLURMRESTD_JSON and SLURMRESTD_YAML input environment
    variables.
 -- slurmrestd - Correct issue where field and $ref description fields were not
    getting populated for OpenAPI specification generation for queries to
    'GET /openapi/v3' for v0.0.40 endpoints.
 -- slurmdbd - Check for innodb_redo_log_capacity instead of
    innodb_log_file_size in MySQL 8.0.30+.
 -- slurmrestd - Fix log level requests SLURMRESTD_DEBUG and -v applying on top
    of each other and the default logging level (info). -v now applies on top
    of the default log level, and SLURMRESTD_DEBUG sets the log level if -v is
    not given.
 -- slurmrestd - Allow SLURMRESTD_DEBUG=quiet or 0, which was previously denied.
    Also deny negative values for SLURMRESTD_DEBUG, which previously set the
    debug level to debug5.
 -- The backup slurmctld now checks that the heartbeat file exists in
    StateSaveLocation before starting and attempting to assert control.
    This avoids issues with misconfiguration, or the shared filesystem being
    unavailable, that could previously have lead to all jobs being cancelled.
 -- The warning printed when using configure --without-PACKAGE has been changed
    to a notice.
 -- Fix --cpu-freq with userspace governor and frequency ranges behavior.
 -- Fix --cpu-freq parsing with incorrect frequencies.
 -- PMIx support is nolonger built by default.  Passing --with-pmix option is
    now required to build with PMIx.
 -- Use memory.current in cgroup/v2 instead of manually calculating RSS. This
    makes accounting consistent with OOM Killer.
 -- Update slurmstepd processes with current SlurmctldHost settings, allowing
    for controller changes without draining all compute jobs.
 -- Add format_stderr to LogTimeFormat of slurm.conf and slurmdbd.conf.
 -- slurmrestd - add `GET /slurm/v0.0.40/reconfigure` endpoint to allow
    equivalent requests of `scontrol reconfigure`.
 -- sreport - cluster Utilization PlannedDown field now includes the time that
    all nodes were in the POWERED_DOWN state instead of just cloud nodes.
 -- scontrol update partition now allows Nodes+=<node-list> and
    Nodes-=<node-list> to add/delete nodes from the existing partition node
    list. Nodes=+host1,-host2 is also allowed.
 -- sacctmgr - add --yaml and --json arg support to specify data_parser plugin.
 -- slurmrestd - Add last_update and last_backfill fields to response to
    `GET /slurm/v0.0.40/job` and `GET /slurm/v0.0.40/jobs` queries.
 -- slurmrestd - Add last_update fields to response to
    `GET /slurm/v0.0.40/node` and `GET /slurm/v0.0.40/nodes` queries.
 -- slurmrestd - Add last_update fields to response to
    `GET /slurm/v0.0.40/partition` and `GET /slurm/v0.0.40/partitions` queries.
 -- slurmrestd - Add last_update fields to response to
    `GET /slurm/v0.0.40/licenses` query.
 -- auth/jwt - fatal when jwt or jwks key files are writable by other.
 -- sacctmgr can now modify QOS's RawUsage to zero or a positive value.
 -- sdiag - Added statistics on why the main and backfill schedulers have
    stopped evaluation on each scheduling cycle.
 -- openapi/v0.0.40 - add /{accounts,users}_association endpoints.
 -- slurm.spec - Add `--with yaml` argument to require YAML support.
 -- Add new rl_log_freq option to SlurmctldParameters to allow sites to limit
    the number of 'RPC limit exceeded...' messages that are logged.
 -- Rename sbcast --fanout to --treewidth.
 -- Remove SLURM_NODE_ALIASES env variable.
 -- Enable fanout for dynamic and unaddresable cloud nodes.
 -- Fix how steps are dealloced in an allocation if the last step of an srun
    never completes due to a node failure.
 -- Remove redundant database indexes.
 -- Add database index to suspend table to speed up archive/purges.
 -- When requesting --tres-per-task alter incorrect request for TRES,
    it should be TRESType/TRESName not TRESType:TRESName.
 -- Make it so reservations can reserve GRES.
 -- switch/hpe_slingshot - Add disable_rdzv_get flag to disable rendezvous gets.
 -- slurmrestd - Avoid matching query URLs based on partial matches to an
    existing endpoint, e.g. POST request to /slurm/v0.0.40/job was routed
    to the handler of POST /slurm/v0.0.40/job/submit.
 -- Don't display old job_arrays/het_jobs in sacct if Job ID was reused.
 -- sbcast - use the specified --fanout value on all hops in message
    forwarding; previously the specified fanout was only used on the first hop,
    and additional hops used TreeWidth in slurm.conf.
 -- slurmrestd - remove logger prefix from '-s/-a list' options outputs.
 -- Fix fd socket name resolution which could flood log files at debug level.
 -- The rpmbuild "--with mysql" option has been removed. The rpm has long
    required sql development libraries to build and the existence of this option
    was confusing. The default behavior now is to always require one of the sql
    development libraries.
 -- Add support for Debian packaging.
 -- switch/hpe_slingshot - Add support for collectives.
 -- Nodes with suspended jobs can now be displayed as MIXED.
 -- sview - Fix search by node state returning incorrect node list.
 -- Fix inconsistent handling of using cli and/or environment options for
    tres_per_task=cpu:# and cpus_per_gpu.
 -- Requesting --cpus-per-task will now set SLURM_TRES_PER_TASK=cpu:# in the
    environment.
 -- For some tres related environment variables such as SLURM_TRES_PER_TASK,
    when srun requests a different value for that option, set these environment
    variables to the value requested by srun. Previously these environment
    variables were unchanged from the job allocation. This bug only affected the
    output environment variables, not the actual step resource allocation.
 -- RoutePlugin=route/topology has been replaced with TopologyParam=RouteTree.
 -- If ThreadsPerCore in slurm.conf is configured with less
    than the number of hardware threads, fix a bug where the task plugins used
    fewer cores instead of using fewer threads per core.
 -- Fix arbitrary distribution allowing it to be used with salloc and sbatch and
    fix how cpus are allocated to nodes.
 -- Allow nodes to reboot while node is drained or in a maintenance state.
 -- Allow scontrol reboot to use nodesets to filter nodes to reboot.
 -- Fix how the topology of typed gres gets updated.
 -- Changes to the Type option in gres.conf now can be applied with scontrol
    reconfig.
 -- Allow for jobs that request a newly configured gres type to be queued
    even when the needed slurmds have not yet registered.
 -- Kill recovered jobs that require unconfigured gres types.
 -- If keepalives are configured, enable them on all persistent connections.
 -- data_parser/v0.0.40 - add parsers for main/backfill cycle exit reasons.
 -- Configless - Also send Includes from configuration files not parsed by the
    controller (i.e. from plugstack.conf).
 -- Add gpu/nrt plugin for nodes using Trainium/Inferentia devices.
 -- data_parser/v0.0.40 - Add START_RECEIVED to job flags in dumped output.
 -- SPANK - Failures from most spank functions (not epilog or exit) will now
    cause the step to be marked as failed and the command (srun, salloc,
    sbatch --wait) to return 1.
 -- data_parser/v0.0.40 - Fix how the "INVALID" nodes state is dumped.
 -- Add SchedulerParameters=extra_constraints. This enables various node
    filtering options in the --extra flag of salloc, sbatch, and srun.
 -- Improve scontrol show node -d information of used shared gres (shard/mps)
    topology.

* Changes in Slurm 23.02.9
==========================
 -- sattach - Fix regression from 23.02.8 security fix leading to crash.

* Changes in Slurm 23.02.8
==========================
 -- Fix rare deadlock when a dynamic node registers at the same time that a
    once per minute background task occurs.
 -- Fix assertion in developer mode on a failed message unpack.
 -- switch/hpe_slingshot - Fix security issue around managing VNI access.
    CVE-2024-42511.

* Changes in Slurm 23.02.7
==========================
 -- libslurm_nss - Avoid causing glibc to assert due to an unexpected return
    from slurm_nss due to an error during lookup.
 -- Fix job requests with --tres-per-task sometimes resulting in bad allocations
    that cannot run subsequent job steps.
 -- Fix issue with slurmd where srun fails to be warned when a node prolog
    script runs beyond MsgTimeout set in slurm.conf.
 -- gres/shard - Fix plugin functions to have matching parameter orders.
 -- gpu/nvml - Fix issue that resulted in the wrong MIG devices being
    constrained to a job
 -- gpu/nvml - Fix linking issue with MIGs that prevented multiple MIGs being
    used in a single job for certain MIG configurations
 -- Add JobAcctGatherParams=DisableGPUAcct to disable gpu accounting.
 -- Fix file descriptor leak in slurmd when using acct_gather_energy/ipmi with
    DCMI devices.
 -- sview - avoid crash when job has a node list string > 49 characters.
 -- Prevent slurmctld crash during reconfigure when packing job start messages.
 -- Preserve reason uid on reconfig.
 -- Update node reason with updated INVAL state reason if different from last
    registration.
 -- acct_gather_energy/ipmi - Improve logging of DCMI issues.
 -- conmgr - Avoid NULL dereference when using auth/none.
 -- data_parser/v0.0.39 - Fixed how deleted QOS and associations for jobs are
    dumped.
 -- burst_buffer/lua - fix stage in counter not decrementing when a job is
    cancelled during stage in. This counter is used to enforce the limit of 128
    scripts per stage.
 -- gpu/oneapi - Add support for new env vars ZE_FLAT_DEVICE_HIERARCHY and
    ZE_ENABLE_PCI_ID_DEVICE_ORDER.
 -- data_parser/v0.0.39 - Fix how the "INVALID" nodes state is dumped.
 -- data_parser/v0.0.39 - Fix parsing of flag arrays to allow muliple flags to
    be set.
 -- Avoid leaking sockets when an x11 application is closed in an allocation.
 -- Fix missing mutex unlock in group cache code which could cause slurmctld to
    freeze.
 -- Fix scrontab monthly jobs possibly skipping a month if added near the end of
    the month.
 -- Fix loading of the gpu account gather energy plugin.
 -- Fix slurmctld segfault when reconfiguring after a job resize.
 -- Fix crash in slurmstepd that can occur when launching tasks via mpi using
    the pmi2 plugin and using the route/topology plugin.
 -- data_parser/v0.0.39 - skip empty string when parsing QOS ids.
 -- Fix "qos <id> doesn't exist" error message in assoc_mgr_update_assocs to
    print the attempted new default qos, rather than the current default qos.
 -- Remove error message from assoc_mgr_update_assocs when purposefully
    resetting the default qos.
 -- data_parser/v0.0.39 - Fix segfault when POSTing data with association usage.
 -- Prevent message extension attacks that could bypass the message hash.
    CVE-2023-49933.
 -- Prevent message hash bypass in slurmd which can allow an attacker to reuse
    root-level MUNGE tokens and escalate permissions. CVE-2023-49935.
 -- Prevent NULL pointer dereference on size_valp overflow. CVE-2023-49936.
 -- Prevent double-xfree() on error in _unpack_node_reg_resp(). CVE-2023-49937.
 -- Prevent modified sbcast RPCs from opening a file with the wrong group
    permissions. CVE-2023-49938.

* Changes in Slurm 23.02.6
==========================
 -- Fix CpusPerTres= not upgreadable with scontrol update
 -- Fix unintentional gres removal when validating the gres job state.
 -- Fix --without-hpe-slingshot configure option.
 -- Fix cgroup v2 memory calculations when transparent huge pages are used.
 -- Fix parsing of sgather --timeout option.
 -- Fix regression from 22.05.0 that caused srun --cpu-bind "=verbose" and "=v"
    options give different CPU bind masks.
 -- Fix "_find_node_record: lookup failure for node" error message appearing
    for all dynamic nodes during reconfigure.
 -- Avoid segfault if loading serializer plugin fails.
 -- slurmrestd - Correct OpenAPI format for 'GET /slurm/v0.0.39/licenses'.
 -- slurmrestd - Correct OpenAPI format for 'GET /slurm/v0.0.39/job/{job_id}'.
 -- slurmrestd - Change format to multiple fields in 'GET
    /slurmdb/v0.0.39/assocations' and 'GET /slurmdb/v0.0.39/qos' to handle
    infinite and unset states.
 -- When a node fails in a job with --no-kill, preserve the extern step on the
    remaining nodes to avoid breaking features that rely on the extern step
    such as pam_slurm_adopt, x11, and job_container/tmpfs.
 -- auth/jwt - Ignore 'x5c' field in JWKS files.
 -- auth/jwt - Treat 'alg' field as optional in JWKS files.
 -- Allow job_desc.selinux_context to be read from the job_submit.lua script.
 -- Skip check in slurmstepd that causes a large number of errors in the munge
    log: "Unauthorized credential for client UID=0 GID=0".  This error will
    still appear on slurmd/slurmctld/slurmdbd start up and is not a cause for
    concern.
 -- slurmctld - Allow startup with zero partitions.
 -- Fix some mig profile names in slurm not matching nvidia mig profiles.
 -- Prevent slurmscriptd processing delays from blocking other threads in
    slurmctld while trying to launch {Prolog|Epilog}Slurmctld.
 -- Fix sacct printing ReqMem field when memory doesn't exist in requested TRES.
 -- Fix how heterogenous steps in an allocation with CR_PACK_NODE or -mpack are
    created.
 -- Fix slurmctld crash from race condition within job_submit_throttle plugin.
 -- Fix --with-systemdsystemunitdir when requesting a default location.
 -- Fix not being able to cancel an array task by the jobid (i.e. not
    <jobid>_<taskid>) through scancel, job launch failure or prolog failure.
 -- Fix cancelling the whole array job when the array task is the meta job and
    it fails job or prolog launch and is not requeable. Cancel only the
    specific task instead.
 -- Fix regression in 21.08.2 where MailProg did not run for mail-type=end for
    jobs with non-zero exit codes.
 -- Fix incorrect setting of memory.swap.max in cgroup/v2.
 -- Fix jobacctgather/cgroup collection of disk/io, gpumem, gpuutil TRES values.
 -- Fix -d singleton for heterogeneous jobs.
 -- Downgrade info logs about a job meeting a "maximum node limit" in the
    select plugin to DebugFlags=SelectType. These info logs could spam the
    slurmctld log file under certain circumstances.
 -- prep/script - Fix [Srun|Task]<Prolog|Epilog> missing SLURM_JOB_NODELIST.
 -- gres - Rebuild GRES core bitmap for nodes at startup. This fixes error:
    "Core bitmaps size mismatch on node [HOSTNAME]", which causes jobs to enter
    state "Requested node configuration is not available".
 -- slurmctd - Allow startup with zero nodes.
 -- Fix filesystem handling race conditions that could lead to an attacker
    taking control of an arbitrary file, or removing entire directories'
    contents. CVE-2023-41914.
 -- Return error when updating ArrayTaskThrottle on a non-ArrayJobId.

* Changes in Slurm 23.02.5
==========================
 -- Add the JobId to debug() messages indicating when cpus_per_task/mem_per_cpu
    or pn_min_cpus are being automatically adjusted.
 -- Fix regression in 23.02.2 that caused slurmctld -R to crash on startup if
    a node features plugin is configured.
 -- Fix and prevent reoccurring reservations from overlapping.
 -- job_container/tmpfs - Avoid attempts to share BasePath between nodes.
 -- Change the log message warning for rate limited users from verbose to info.
 -- With CR_Cpu_Memory, fix node selection for jobs that request gres and
    --mem-per-cpu.
 -- Fix a regression from 22.05.7 in which some jobs were allocated too few
    nodes, thus overcommitting cpus to some tasks.
 -- Fix a job being stuck in the completing state if the job ends while the
    primary controller is down or unresponsive and the backup controller has
    not yet taken over.
 -- Fix slurmctld segfault when a node registers with a configured CpuSpecList
    while slurmctld configuration has the node without CpuSpecList.
 -- Fix cloud nodes getting stuck in POWERED_DOWN+NO_RESPOND state after not
    registering by ResumeTimeout.
 -- slurmstepd - Avoid cleanup of config.json-less containers spooldir getting
    skipped.
 -- slurmstepd - Cleanup per task generated environment for containers in
    spooldir.
 -- Fix scontrol segfault when 'completing' command requested repeatedly in
    interactive mode.
 -- Properly handle a race condition between bind() and listen() calls in the
    network stack when running with SrunPortRange set.
 -- Federation - Fix revoked jobs being returned regardless of the -a/--all
    option for privileged users.
 -- Federation - Fix canceling pending federated jobs from non-origin clusters
    which could leave federated jobs orphaned from the origin cluster.
 -- Fix sinfo segfault when printing multiple clusters with --noheader option.
 -- Federation - fix clusters not syncing if clusters are added to a federation
    before they have registered with the dbd.
 -- Change pmi2 plugin to honor the SrunPortRange option. This matches the new
    behavior of the pmix plugin in 23.02.0. Note that neither of these plugins
    makes use of the "MpiParams=ports=" option, and previously were only limited
    by the systems ephemeral port range.
 -- node_features/helpers - Fix node selection for jobs requesting changeable
    features with the '|' operator, which could prevent jobs from running on
    some valid nodes.
 -- node_features/helpers - Fix inconsistent handling of '&' and '|', where an
    AND'd feature was sometimes AND'd to all sets of features instead of just
    the current set. E.g. "foo|bar&baz" was interpreted as {foo,baz} or
    {bar,baz} instead of how it is documented: "{foo} or {bar,baz}".
 -- Fix job accounting so that when a job is requeued its allocated node count
    is cleared. After the requeue, sacct will correctly show that the job has
    0 AllocNodes while it is pending or if it is canceled before restarting.
 -- sacct - AllocCPUS now correctly shows 0 if a job has not yet received an
    allocation or if the job was canceled before getting one.
 -- Fix intel oneapi autodetect: detect the /dev/dri/renderD[0-9]+ gpus, and do
    not detect /dev/dri/card[0-9]+.
 -- Format batch, extern, interactive, and pending step ids into strings that
    are human readable.
 -- Fix node selection for jobs that request --gpus and a number of tasks fewer
    than gpus, which resulted in incorrectly rejecting these jobs.
 -- Remove MYSQL_OPT_RECONNECT completely.
 -- Fix cloud nodes in POWERING_UP state disappearing (getting set to FUTURE)
    when an `scontrol reconfigure` happens.
 -- openapi/dbv0.0.39 - Avoid assert / segfault on missing coordinators list.
 -- slurmrestd - Correct memory leak while parsing OpenAPI specification
    templates with server overrides.
 -- slurmrestd - Reduce memory usage when printing out job CPU frequency.
 -- Fix overwriting user node reason with system message.
 -- Remove --uid / --gid options from salloc and srun commands.
 -- Prevent deadlock when rpc_queue is enabled.
 -- slurmrestd - Correct OpenAPI specification generation bug where fields with
    overlapping parent paths would not get generated.
 -- Fix memory leak as a result of a partition info query.
 -- Fix memory leak as a result of a job info query.
 -- slurmrestd - For 'GET /slurm/v0.0.39/node[s]', change format of node's
    energy field "current_watts" to a dictionary to account for unset value
    instead of dumping 4294967294.
 -- slurmrestd - For 'GET /slurm/v0.0.39/qos', change format of QOS's
    field "priority" to a dictionary to account for unset value instead of
    dumping 4294967294.
 -- slurmrestd - For 'GET /slurm/v0.0.39/job[s]', the 'return code' code field
    in v0.0.39_job_exit_code will be set to -127 instead of being left unset
    where job does not have a relevant return code.
 -- data_parser/v0.0.39 - Add required/memory_per_cpu and
    required/memory_per_node to `sacct --json` and `sacct --yaml` and
    'GET /slurmdb/v0.0.39/jobs' from slurmrestd.
 -- For step allocations, fix --gres=none sometimes not ignoring gres from the
    job.
 -- Fix --exclusive jobs incorrectly gang-scheduling where they shouldn't.
 -- Fix allocations with CR_SOCKET, gres not assigned to a specific socket, and
    block core distribion potentially allocating more sockets than required.
 -- gpu/oneapi - Store cores correctly so CPU affinity is tracked.
 -- Revert a change in 23.02.3 where Slurm would kill a script's process group
    as soon as the script ended instead of waiting as long as any process in
    that process group held the stdout/stderr file descriptors open. That change
    broke some scripts that relied on the previous behavior. Setting time limits
    for scripts (such as PrologEpilogTimeout) is strongly encouraged to avoid
    Slurm waiting indefinitely for scripts to finish.
 -- Allow slurmdbd -R to work if the root assoc id is not 1.
 -- Fix slurmdbd -R not returning an error under certain conditions.
 -- slurmdbd - Avoid potential NULL pointer dereference in the mysql plugin.
 -- Revert a change in 23.02 where SLURM_NTASKS was no longer set in the job's
    environment when --ntasks-per-node was requested.
 -- Limit periodic node registrations to 50 instead of the full TreeWidth.
    Since unresolvable cloud/dynamic nodes must disable fanout by setting
    TreeWidth to a large number, this would cause all nodes to register at
    once.
 -- Fix regression in 23.02.3 which broken x11 forwarding for hosts when
    MUNGE sends a localhost address in the encode host field. This is caused
    when the node hostname is mapped to 127.0.0.1 (or similar) in /etc/hosts.
 -- openapi/[db]v0.0.39 - fix memory leak on parsing error.
 -- data_parser/v0.0.39 - fix updating qos for associations.
 -- openapi/dbv0.0.39 - fix updating values for associations with null users.
 -- Fix minor memory leak with --tres-per-task and licenses.
 -- Fix cyclic socket cpu distribution for tasks in a step where
    --cpus-per-task < usable threads per core.

* Changes in Slurm 23.02.4
==========================
 -- Fix sbatch return code when --wait is requested on a job array.
 -- switch/hpe_slingshot - avoid segfault when running with old libcxi.
 -- Avoid slurmctld segfault when specifying AccountingStorageExternalHost.
 -- Fix collected GPUUtilization values for acct_gather_profile plugins.
 -- Fix slurmrestd handling of job hold/release operations.
 -- Make spank S_JOB_ARGV item value hold the requested command argv instead of
    the srun --bcast value when --bcast requested (only in local context).
 -- Fix step running indefinitely when slurmctld takes more than MessageTimeout
    to respond. Now, slurmctld will cancel the step when detected, preventing
    following steps from getting stuck waiting for resources to be released.
 -- Fix regression to make job_desc.min_cpus accurate again in job_submit when
    requesting a job with --ntasks-per-node.
 -- scontrol - Permit changes to StdErr and StdIn for pending jobs.
 -- scontrol - Reset std{err,in,out} when set to empty string.
 -- slurmrestd - mark environment as a required field for job submission
    descriptions.
 -- slurmrestd - avoid dumping null in OpenAPI schema required fields.
 -- data_parser/v0.0.39 - avoid rejecting valid memory_per_node formatted as
    dictionary provided with a job description.
 -- data_parser/v0.0.39 - avoid rejecting valid memory_per_cpu formatted as
    dictionary provided with a job description.
 -- slurmrestd - Return HTTP error code 404 when job query fails.
 -- slurmrestd - Add return schema to error response to job and license query.
 -- Fix handling of ArrayTaskThrottle in backfill.
 -- Fix regression in 23.02.2 when checking gres state on slurmctld startup or
    reconfigure. Gres changes in the configuration were not updated on slurmctld
    startup. On startup or reconfigure, these messages were present in the log:
    "error: Attempt to change gres/gpu Count".
 -- Fix potential double count of gres when dealing with limits.
 -- switch/hpe_slingshot - support alternate traffic class names with "TC_"
    prefix.
 -- scrontab - Fix cutting off the final character of quoted variables.
 -- Fix slurmstepd segfault when ContainerPath is not set in oci.conf
 -- Change the log message warning for rate limited users from debug to verbose.
 -- Fixed an issue where jobs requesting licenses were incorrectly rejected.
 -- smail - Fix issues where e-mails at job completion were not being sent.
 -- scontrol/slurmctld - fix comma parsing when updating a reservation's nodes.
 -- cgroup/v2 - Avoid capturing log output for ebpf when constraining devices,
    as this can lead to inadvertent failure if the log buffer is too small.
 -- Fix --gpu-bind=single binding tasks to wrong gpus, leading to some gpus
    having more tasks than they should and other gpus being unused.
 -- Fix main scheduler loop not starting after failover to backup controller.
 -- Added error message when attempting to use sattach on batch or extern steps.
 -- Fix regression in 23.02 that causes slurmstepd to crash when srun requests
    more than TreeWidth nodes in a step and uses the pmi2 or pmix plugin.
 -- Reject job ArrayTaskThrottle update requests from unprivileged users.
 -- data_parser/v0.0.39 - populate description fields of property objects in
    generated OpenAPI specifications where defined.
 -- slurmstepd - Avoid segfault caused by ContainerPath not being terminated by
    '/' in oci.conf.
 -- data_parser/v0.0.39 - Change v0.0.39_job_info response to tag exit_code
    field as being complex instead of only an unsigned integer.
 -- job_container/tmpfs - Fix %h and %n substitution in BasePath where %h was
    substituted as the NodeName instead of the hostname, and %n was substituted
    as an empty string.
 -- Fix regression where --cpu-bind=verbose would override TaskPluginParam.
 -- scancel - Fix --clusters/-M for federations. Only filtered jobs (e.g. -A,
    -u, -p, etc.) from the specified clusters will be canceled, rather than all
    jobs in the federation. Specific jobids will still be routed to the origin
    cluster for cancellation.
 -- Add SelectTypeParameters=LL_SHARED_GRES.

* Changes in Slurm 23.02.3
==========================
 -- Fix regression in 23.02.2 that ignored the partition DefCpuPerGPU setting
    on the first pass of scheduling a job requesting --gpus --ntasks.
 -- openapi/dbv0.0.39/users - If a default account update failed, resulting in a
    no-op, the query returned success without any warning. Now a warning is sent
    back to the client that the default account wasn't modified.
 -- srun - fix issue creating regular and interactive steps because
    *_PACK_GROUP* environment variables were incorrectly set on non-HetSteps.
 -- Fix dynamic nodes getting stuck in allocated states when reconfiguring.
 -- Avoid job write lock when nodes are dynamically added/removed.
 -- burst_buffer/lua - allow jobs to get scheduled sooner after
    slurm_bb_data_in completes.
 -- mpi/pmix - fix regression introduced in 23.02.2 which caused PMIx shmem
    backed files permissions to be incorrect.
 -- api/submit - fix memory leaks when submission of batch regular jobs or batch
    HetJobs fails (response data is a return code).
 -- openapi/v0.0.39 - fix memory leak in _job_post_het_submit().
 -- Fix regression in 23.02.2 that set the SLURM_NTASKS environment variable
    in sbatch jobs from --ntasks-per-node when --ntasks was not requested.
 -- Fix regression in 23.02 that caused sbatch jobs to set the wrong number
    of tasks when requesting --ntasks-per-node without --ntasks, and also
    requesting one of the following options: --sockets-per-node,
    --cores-per-socket, --threads-per-core (or --hint=nomultithread), or
    -B,--extra-node-info.
 -- Fix double counting suspended job counts on nodes when reconfiguring, which
    prevented nodes with suspended jobs from being powered down or rebooted
    once the jobs completed.
 -- Fix backfill not scheduling jobs submitted with --prefer and --constraint
    properly.
 -- Avoid possible slurmctld segfault caused by race condition with already
    completed slurmdbd_conn connections.
 -- Slurmdbd.conf checks included conf files for 0600 permissions
 -- slurmrestd - fix regression "oversubscribe" fields were removed from job
    descriptions and submissions from v0.0.39 end points.
 -- accounting_storage/mysql - Query for indiviual QOS correctly when you have
    more than 10.
 -- Add warning message about ignoring --tres-per-tasks=license when used
    on a step.
 -- sshare - Fix command to work when using priority/basic.
 -- Avoid loading cli_filter plugins outside of salloc/sbatch/scron/srun. This
    fixes a number of missing symbol problems that can manifest for executables
    linked against libslurm (and not libslurmfull).
 -- Allow cloud_reg_addrs to update dynamically registered node's addrs on
    subsequent registrations.
 -- switch/hpe_slingshot - Fix hetjob components being assigned different vnis.
 -- Revert a change in 22.05.5 that prevented tasks from sharing a core if
    --cpus-per-task > threads per core, but caused incorrect accounting and cpu
    binding. Instead, --ntasks-per-core=1 may be requested to prevent tasks from
    sharing a core.
 -- Correctly send assoc_mgr lock to mcs plugin.
 -- Fix regression in 23.02 leading to error() messages being sent at INFO
    instead of ERR in syslog.
 -- switch/hpe_slingshot - Fix bad instant-on data due to incorrect parsing of
    data from jackaloped.
 -- Fix TresUsageIn[Tot|Ave] calculation for gres/gpumem and gres/gpuutil.
 -- Avoid unnecessary gres/gpumem and gres/gpuutil TRES position lookups.
 -- Fix issue in the gpu plugins where gpu frequencies would only be set if both
    gpu memory and gpu frequencies were set, while one or the other suffices.
 -- Fix reservations group ACL's not working with the root group.
 -- slurmctld - Fix backup slurmctld crash when it takes control multiple times.
 -- Fix updating a job with a ReqNodeList greater than the job's node count.
 -- Fix inadvertent permission denied error for --task-prolog and --task-epilog
    with filesystems mounted with root_squash.
 -- switch/hpe_slingshot - remove the unused vni_pids option.
 -- Fix missing detailed cpu and gres information in json/yaml output from
    scontrol, squeue and sinfo.
 -- Fix regression in 23.02 that causes a failure to allocate job steps that
    request --cpus-per-gpu and gpus with types.
 -- sacct - when printing PLANNED time, use end time instead of start time for
    jobs cancelled before they started.
 -- Fix potentially waiting indefinitely for a defunct process to finish,
    which affects various scripts including Prolog and Epilog. This could have
    various symptoms, such as jobs getting stuck in a completing state.
 -- Hold the job with "(Reservation ... invalid)" state reason if the
    reservation is not usable by the job.
 -- Fix losing list of reservations on job when updating job with list of
    reservations and restarting the controller.
 -- Fix nodes resuming after down and drain state update requests from
    clients older than 23.02.
 -- Fix advanced reservation creation/update when an association that should
    have access to it is composed with partition(s).
 -- auth/jwt - Fix memory leak.
 -- sbatch - Added new --export=NIL option.
 -- Fix job layout calculations with --ntasks-per-gpu, especially when --nodes
    has not been explicitly provided.
 -- Fix X11 forwarding for jobs submitted from the slurmctld host.
 -- When a job requests --no-kill and one or more nodes fail during the job,
    fix subsequent job steps unable to use some of the remaining resources
    allocated to the job.
 -- Fix shared gres allocation when using --tres-per-task with tasks that span
    multiple sockets.

* Changes in Slurm 23.02.2
==========================
 -- Fix regression introduced with the migration to interfaces which caused
    sshare to core dump. Sshare now initialized the priority context correctly
    when calculating with PriorityFlags=NO_FAIR_TREE.
 -- Fix IPMI DCMI sensor initialization.
 -- For the select/cons_tres plugin, improve the best effort GPU to core
    binding, for requests with per job task count (-n) and GPU (--gpus)
    specification.
 -- scrontab - don't update the cron job tasks if the whole crontab file is
    left untouched after opening it with "scrontab -e".
 -- mpi/pmix - avoid crashing when running PMIx v5.0 branch with shmem support.
 -- Fix building switch topology after a reconfig with the correct nodes.
 -- Allow a dynamic node to register with a reason, using --conf, when the
    state is DOWN or DRAIN.
 -- Fix slurmd running tasks before RPC Prolog is run.
 -- Fix slurmd deadlock iff the controller were to give a bad alias_list.
 -- slurmrestd - correctly process job submission field "exclusive" with boolean
    True or False.
 -- slurmrestd - correctly process job submission field "exclusive" with strings
    "true" or "false".
 -- slurmctld/step_mgr - prevent non-allocatable steps from decrementing values
    that weren't previously incremented when trying to allocate them.
 -- auth/jwt - Fix memory leak in slurmctld with 'scontrol token'.
 -- Fix shared gres (shard/mps) leak when using --tres-per-task
 -- Fix sacctmgr segfault when listing accounts with coordinators.
 -- slurmrestd - improve error logging when client connections experience
    polling errors.
 -- slurmrestd - improve handling of sockets in different states of shutdown to
    avoid infinite poll() loop causing a thread to max CPU usage until process
    is killed.
 -- slurmrestd - avoid possible segfault caused by race condition of already
    completed connections.
 -- mpi/cray_shasta - Fix PMI shared secret for hetjobs.
 -- gpu/oneapi - Fix CPU affinity handling.
 -- Fix dynamic nodes powering up when already up after adding/deleting nodes
    when using power_save logic.
 -- slurmrestd - Add support for setting max connections.
 -- data_parser/v0.0.39 - fix sacct --json matching associations from a
    different cluster.
 -- Fix segfault when clearing reqnodelist of a pending job.
 -- Fix memory leak of argv when submitting jobs via slurmrestd or CLI commands.
 -- slurmrestd - correct miscalculation of job argument count that could cause
    memory leak when job submission fails.
 -- slurmdbd - add warning on startup if max_allowed_packet is too small.
 -- gpu/nvml - Remove E-cores from NVML's cpu affinity bitmap when
    "allow_ecores" is not set in SlurmdParameters.
 -- Fix regression from 23.02.0rc1 causing a FrontEnd slurmd to assert fail on
    startup and don't be configured with the appropriate port.
 -- Fix dynamic nodes not being sorted and not being included in topology,
    which resulted in suboptimal dynamic node selection for jobs.
 -- Fix slurmstepd crash due to potential division by zero (SIGFPE) in certain
    edge-cases using the PMIx plugin.
 -- Fix issue with PMIx HetJob requests where certain use-cases would end up
    with communication errors due to incorrect PMIx hostname info setup.
 -- openapi/v0.0.39 - revert regression in job update requests to accept job
    description for changes instead of requiring job description in "job" field.
 -- Fix regression in 23.02.0rc1 that caused a step to crash with a bad
    --gpu-bind=single request.
 -- job_container/tmpfs - skip more in-depth attempt to clean up the base path
    when not required.  This prevents unhelpful, and possibly misleading, debug2
    messages when not using the new "shared" mode.
 -- gpu/nvml - Fix gpu usage when graphics processes are running on the gpu.
 -- slurmrestd - fix regression where "exclusive" field was removed from job
    descriptions and submissions.
 -- Fix issue where requeued jobs had bad gres allocations leading to gres not
    being deallocated at the end of the job, preventing other jobs from using
    those resources.
 -- Fix regression in 23.02.0rc1 which caused incorrect values for
    SLURM_TASKS_PER_NODE when the job requests --ntasks-per-node and --exclusive
    or --ntasks-per-core=1 (or CR_ONE_TASK_PER_CORE) and without requesting
    --ntasks. SLURM_TASKS_PER_NODE is used by mpirun, so this regression
    caused mpirun to launch the wrong number of tasks and to sometimes fail to
    launch tasks.
 -- Prevent jobs running on shards from being canceled on slurmctld restart.
 -- Fix SPANK prolog and epilog hooks that rely on slurm_init() for access to
    internal Slurm API calls.
 -- oci.conf - Populate %m pattern with ContainerPath or SlurmdSpoolDir if
    ContainerPath is not configured.
 -- Removed zero padding for numeric values in container spool directory names.
 -- Avoid creating an unused task-4294967295 directory in container spooldir.
 -- Cleanup container step directories at step completion.
 -- sacctmgr - Fix segfault when printing empty tres.
 -- srun - fix communication issue that prevented slurmctld from connecting to
    an srun running outside of a compute node.

* Changes in Slurm 23.02.1
==========================
 -- job_container/tmpfs - cleanup job container even if namespace mount is
    already unmounted.
 -- When cluster specific tables are be removed also remove the job_env_table
    and job_script_table.
 -- Fix the way bf_max_job_test is applied to job arrays in backfill.
 -- data_parser/v0.0.39 - Avoid dumping -1 value or NULL when step's
    consumed_energy is unset.
 -- scontrol - Fix showing Array Job Steps.
 -- scontrol - Fix showing Job HetStep.
 -- openapi/dbv0.0.38 - Fix not displaying an error when updating QOS or
    associations fails.
 -- data_parser/v0.0.39 - Avoid crash while parsing composite structures.
 -- sched/backfill - fix deleted planned node staying in planned node bitmap.
 -- Fix nodes remaining as PLANNED after slurmctld save state recovery.
 -- Fix parsing of cgroup.controllers file with a blank line at the end.
 -- Add cgroup.conf EnableControllers option for cgroup/v2.
 -- Get correct cgroup root to allow slurmd to run in containers like Docker.
 -- Fix "(null)" cluster name in SLURM_WORKING_CLUSTER env.
 -- slurmctld - add missing PrivateData=jobs check to step ContainerID lookup
    requests originated from 'scontrol show step container-id=<id>' or certain
    scrun operations when container state can't be directly queried.
 -- Automatically sort the TaskPlugin list reverse-alphabetically. This
    addresses an issue where cpu masks were reset if task/affinity was listed
    before task/cgroup on cgroup/v2 systems with Linux kernel < 6.2.
 -- Fix some failed terminate job requests from a 23.02 slurmctld to a 22.05 or
    21.08 slurmd.
 -- Fix compile issues on 32-bit systems.
 -- Fix nodes un-draining after being drained due to unkillable step.
 -- Fix remote licenses allowed percentages reset to 0 during upgrade.
 -- sacct - Avoid truncating time strings when using SLURM_TIME_FORMAT with
    the --parsable option.
 -- data_parser/v0.0.39 - fix segfault when default qos is not set.
 -- Fix regression in 22.05.0rc1 that broke Nodes=ALL in a NodeSet.
 -- openapi/v0.0.39 - fix jobs submitted via slurmrestd being allocated fewer
    CPUs than tasks when requesting multiple tasks.
 -- Fix job not being scheduled on valid nodes and potentially being rejected
    when using parentheses at the beginning of square brackets in a feature
    request, for example: "feat1&[(feat2|feat3)]".
 -- Fix a job being scheduled on nodes that do not match a feature request that
    uses parentheses inside of brackets and requests additional features outside
    of brackets, for example: "feat1&[feat2|(feat3|feat4)]".
 -- Fix regression in 23.02.0rc1 which made --gres-flags=enforce-binding no
    longer enforce optimal core-gpu job placement.
 -- switch/hpe_slingshot - add option to disable VNI allocation per-job.
 -- switch/hpe_slingshot - restrict CXI services to the requesting user.
 -- switch/hpe_slingshot - Only output tcs once in SLINGSHOT_TCS env.
 -- switch/hpe_slingshot - Fix updating LEs and ACs limits.
 -- switch/hpe_slingshot - Use correct Max for EQs and CTs.
 -- switch/hpe_slingshot - support configuring network options per-job.
 -- switch/hpe_slingshot - retry destroying CXI service if necessary.
 -- Fix memory leak caused by job preemption when licenses are configured.
 -- mpi/pmix - Fix v5 to load correctly when libpmix.so isn't in the normal
    lib path.
 -- data_parser/v0.0.39 - fix regression where "memory_per_node" would be
    rejected for job submission.
 -- data_parser/v0.0.39 - fix regression where "memory_per_cpu" would be
    rejected for job submission.
 -- slurmctld - add an assert to check for magic number presence before deleting
    a partition record and clear the magic afterwards to better diagnose
    potential memory problems.
 -- Clean up OCI containers task directories correctly.
 -- slurm.spec - add "--with jwt" option.
 -- scrun - Run under existing job when SLURM_JOB_ID is present.
 -- Prevent a slurmstepd crash when the I/O subsystem has hung.
 -- common/conmgr - fix memory leak of complete connection list.
 -- data_parser/v0.0.39 - fix memory leak when parsing every field in a struct.
 -- job_container/tmpfs - avoid printing extraneous error messages when running
    a spank plugin that implements slurm_spank_job_prolog() or
    slurm_spank_job_epilog().
 -- Fix srun < 23.02 always getting an "exact" core allocation.
 -- Prevent scontrol < 23.02 from setting MaxCPUsPerSocket to 0.
 -- Add ScronParameters=explicit_scancel and corresponding scancel --cron
    option.

* Changes in Slurm 23.02.0
==========================
 -- scrun - Install into /bin instead of /sbin, which also ensures it is
    included in the RPM packages.
 -- data_parser/v0.0.39 - avoid erroring on unknown association id.
 -- data_parser/v0.0.39 - avoid fatal while dumping TRES values.
 -- Improve error message for using --cpus-per-gpus without any GPUs.
 -- switch/hpe_slingshot - fix rolling upgrades from 22.05 to 23.02
 -- Change cgroup/v1 behavior when waiting for a pid to be moved by waiting some
    time between retries. This helps with stray cgroup dirs on slow kernels.
 -- Workaround a bug in kernels < 3.18 with cpuset which randomly leaves stray
    cgroups after jobs have ended.
 -- Rebuild the prepacked buf going to the slurmstepd if TRES changed.
 -- Add new 'make clean-contrib' target to build system to clean contribs dir.
 -- Treat newlines as delimeters for hostlist_create(). (This is used internally
    by "scontrol show hostlist" and for handling SLURM_JOB_NODELIST.)
 -- scontrol - Print "Invalid job id specified" for 'scontrol show step ...'
    when the job does not exist, rather than "Unexpected error".
 -- Handle mismatched TRES count from the slurmstepd's instead of fatal()'ing.
 -- Fix GPU setup on CRAY systems when using the CRAY_CUDA_MPS environment
    variable. GPUs are now correctly detected in such scenarios.
 -- data_parser/v0.0.39 - improve flag handling to avoid flags having bits left
    unset after parsing.
 -- topology/tree - Add new TopologyParam=SwitchAsNodeRank option to reorder
    nodes based on switch layout. This can be useful if the naming convention
    for the nodes does not natually map to the network topology.
 -- openapi/v0.0.38 - avoid signed math errors while dumping node resources.
 -- openapi/dbv0.0.39 - avoid error while dumping account coordinators.
 -- data_parser/v0.0.39 - correct dump of stats backfill mean table size.
 -- openapi/dbv0.0.39 - avoid error while adding account coordinators.
 -- scrun - catch invalid values of environment SCRUN_FILE_DEBUG.
 -- scrun - avoid memory leak due to invalid annotation.
 -- scrun - avoid false error when pidfile not requested.
 -- Do not constrain memory in task/cgroup unless CR_Memory is set.
 -- Fix the job prolog not running for jobs with the interactive step
    (salloc jobs with LaunchParameters=use_interactive_step set in slurm.conf)
    that were scheduled on powered down nodes. The prolog not running also
    broke job_container/tmpfs, pam_slurm_adopt, and x11 forwarding.
 -- swich/hpe_slingshot - fix issues using 22.05 commands with 23.02 slurmd.
 -- swith/hpe_slingshot - avoid slurmd segfault if there is a protocol error.
 -- task/affinity - fix slurmd segfault when request launch task requests of
    type "--cpu-bind=[map,mask]_cpu:<list>" have no <list> provided.
 -- salloc/sbatch/srun - error out if "--cpu-bind=[map,mask]_cpu:<list>" fails
    to extract a list of cpus.
 -- job_container/tmpfs - cleanup job_mount when container creation fails.
 -- job_container/tmpfs - don't attempt to remove job_mount directory when it is
    still mounted.
 -- Fix regression in rc1 causing sacctmgr to segfault when printing unrelated
    fields.
 -- jobcomp/kafka - don't use the purge API if librdkafka < v1.0.0.
 -- Change shown start time of pending array job to be start time of earliest
    pending array task.
 -- job_container/tmpfs - ensure that step_ns_fd is closed before cleaning up
    the namespace.
 -- Fix assert when suspending or requeueing array tasks with scontrol.
 -- Fix federated job submissions.
 -- Fix sinfo returning non-zero exit code when querying specific clusters.
 -- openapi/v0.0.39 - correct OpenAPI schema for job update requests.
 -- openapi/v0.0.39 - prevent assertion on jobs endpoint by altering how the
    "memory_per_cpu" and "memory_per_node" fields are managed.
 -- Fix regression in 23.02.0rc1 which caused slurmctld to segfault when
    gres is added or removed in the configuration.
 -- Removed the default setting for GpuFreqDef. If unset, no attempt to change
    the GPU frequency will be made if --gpu-freq is not set for the step.
 -- Fixed GpuFreqDef option. When set in slurm.conf, it will be used if
    --gpu-freq was not explicitly set by the job step.
 -- Update database index for usage tables used for archive and purge.
 -- Fix configure script on FreeBSD.

* Changes in Slurm 23.02.0rc1
=============================
 -- Make scontrol reconfigure and sending a SIGHUP to the slurmctld behave the
    same. If you were using SIGHUP as a 'lighter' scontrol reconfigure to rotate
    logs please update your scripts to use SIGUSR2 instead.
 -- Add Account and QOS name type specifications for sprio output formatting.
 -- openapi/[db]v0.0.36 - plugins have been removed.
 -- openapi/[db]v0.0.37 - tagged as deprecated.
 -- openapi/[db]v0.0.39 - forked plugin openapi/[db]v0.0.38.
 -- Add SRUN_{ERROR,INPUT,OUTPUT} input environment variables for --error,
    --input and --output options respectively.
 -- Add MaxCPUsPerSocket to partition configuration, similar to MaxCPUsPerNode.
 -- openapi/v0.0.39 - change nice request field from string to integer.
 -- sacctmgr - no longer force updates to the AdminComment, Comment, or
    SystemComment to lower-case.
 -- openapi/dbv0.0.39 - more graceful handling of POSTs when expected field
    lists are missing or unparsable.
 -- burst_buffer/lua - pass the job's UID and GID to slurm_bb_pre_run,
    slurm_bb_data_in, slurm_bb_post_run, and slurm_bb_data_out in
    burst_buffer.lua.
 -- openapi/v0.0.39 - add new field default_memory_per_node for partitions.
 -- Change cloud nodes to show by default. PrivateData=cloud is no longer
    needed.
 -- Add -F/--future option to sinfo to display future nodes.
 -- openapi/dbv0.0.39 - resolve job user from uid when user is not provided.
 -- sacct/sinfo/squeue - use openapi/[db]v0.0.39 for --json and --yaml modes.
 -- sdiag - Add --json and --yaml arguments.
 -- Cgroupv2 plugin will not show "Controller is not enabled" error when started
    from cmd.
 -- sreport - Count planned (FKA reserved) time for jobs running in IGNORE_JOBS
    reservations. Previously was lumped into IDLE time.
 -- job_container/tmpfs - support running with an arbitrary list of private
    mount points (/tmp and /dev/shm are nolonger required, but are the default).
 -- sacct - Rename 'Reserved' field to 'Planned' to match sreport and the
    nomenclature of the 'Planned' node.
 -- oci.conf: Add %U as OCI pattern replacement to numeric user id.
 -- cli_filter/lua, jobcomp/lua, job_submit/lua - expose all Slurm error codes.
 -- jobcomp/elasticsearch - expose features field.
 -- jobcomp/elasticsearch - post non-NULL but empty string fields.
 -- Make advanced reservation flag MAINT not replace nodes, similar to
    STATIC_ALLOC
 -- NVML - Add usage gathering for Nvidia gpus.
 -- node_features plugins - invalid users specified for AllowUserBoot will now
    result in fatal() rather than just an error.
 -- job_container/tmpfs - Set more environment variables in InitScript.
 -- Make all cgroup directories created by Slurm owned by root.
 -- sbatch - add parsing of #PBS -d and #PBS -w.
 -- Avoid network receive error on heavily loaded machines where the network
    operation can be restarted.
 -- Deprecate AllowedKmemSpace, ConstrainKmemSpace, MaxKmemPercent, and
    MinKmemSpace.
 -- accounting_storage/mysql - change purge/archive to calculate record ages
    based on end time, rather than start or submission times.
 -- Add strigger --draining and -R/--resume options.
 -- Allow updating SLURM_NTASKS environment variable (from scontrol update job).
 -- Limit het job license requests to the leader job only.
 -- Change --oversubscribe and --exclusive to be mutually exclusive for job
    submission. Job submission commands will now fatal if both are set.
    Previously, these options would override each other, with the last one in
    the job submission command taking effect.
 -- job_submit/lua - add support for log_user() from slurm_job_modify().
 -- openapi/v0.0.39 - add submission of job->prefer value.
 -- Fix tasks binding to GPUs when using --ntasks-per-gpu and GPUs have
    different core/socket affinity.
 -- Add support for padding StdOut/StdErr/StdIn format specifiers to scontrol
    show job.
--  Fix sacctmgr qos filter to properly select assocs by qos inheritance rules.
 -- Prevent slurmctld from starting with invalid jobcomp plugin.
 -- Fix `sinfo -i` and interactive `scontrol> show node` replies for nodes
    going from powering down to powered down state.
 -- auth/jwt - support Azure (among other) JWKS files by preferring x5c field
    over locally reconstructing an RSA256 key file.
 -- auth/jwt - add optional AuthAltParameters field "userclaimfield=" to allow
    overriding "sun" claim to site specific field.
 -- scontrol - Requested TRES and allocated TRES will now always be printed when
    showing jobs, instead of one TRES output that was either the requested or
    allocated.
 -- Improve scheduling performance for dynamic nodes and nodes with features by
    consolidating like config records.
 -- Expose argc and entire argv to job_submit and cli_filter plugins for jobs
    submitted via salloc/srun or sbatch <script> (not via --wrap).
 -- Job command/script name is now packed with no arguments, thus clients
    displaying job information will only show the command/script name.
 -- Make acct_gather_energy plugins handle slurmd reconfiguration and support
    restart for gpu and xcc implementations.
 -- Fix --slurmd-debug to treat its argument as log level (as documented)
    instead of previous approach with it being an offset to configured log
    level.
 -- srun --slurmd-debug option is now only allowed for root and SlurmUser
 -- Change 'scontrol requeue' behavior for scron jobs to use cronspec to
    determine the next start time.
 -- serializer/url-encoded - interpet query keys without a value (flags) to be
    true instead of NULL.
 -- Add --autocomplete= option to all client commands.
 -- Allow for concurrent processing of job_submit_g_submit() and
    job_submit_g_modify() calls.
 -- Allow jobs to queue even if the user is not in AllowGroups when
    EnforcePartLimits=no is set. This ensures consistency for all the Partition
    access controls, and matches the documented behavior for EnforcePartLimits.
 -- Fix srun tasks binding/allocation when using --ntasks-per-core option. Now,
    --ntasks-per-core=1 implies --cpu-bind=cores and --ntasks-per-core>1 implies
    --cpu-bind=threads.
 -- salloc/sbatch/srun check and abort if ntasks-per-core > threads-per-core.
 -- burst_buffer/lua - fix building heterogeneous job scripts where the
    directive is not the default "BB_LUA".
 -- If a node is in a reservation add the reservation name to it for
    scontrol/sinfo/sview.
 -- common/cgroup - improve possible TOCTOU situation when reading cgroup files.
 -- slurmctld will fatal() when reconfiguring the job_submit plugin fails.
 -- Add ResumeAfter=<secs> option to "scontrol update nodename=".
 -- slurmrestd - switch to returning UNPROCESSABLE_CONTENT when parsing
    succeeds but an error about the actual contents causes a request to fail.
 -- slurmrestd - queries that result in empty contents will now be treated as
    SUCCESS. While the query worked, nothing was returned, which allows callers
    to determine how to then proceed.
 -- Add PowerDownOnIdle partition option.
 -- Make it so the [Allow|Deny]Accounts parameter for a partition is
    hierarchical.
 -- Add the ability for a add (+=) or remove (-=) nodes from a reservation
 -- Fix several problems when creating/editing partitions in sview.
 -- Enhanced burst_buffer.lua - pass UID and GID to most hooks; pass a table
    containing detailed job information to many hooks. See
    etc/burst_buffer.lua.example for a complete list of changes.
 -- Add a new "nodes=" argument to scontrol setdebug to allow the debug level
    on the slurmd processes to be temporarily altered.
 -- Add InfluxDBTimeout parameter to acct_gather.conf.
 -- job_container/tmpfs - add support for expanding %h and %n in BasePath.
 -- Prevent job submission/update with afterok/afternotok dependency set to
    an unknown jobid.
 -- Change to a new FAIL_SIGNAL job state reason (instead of FAIL_LAUNCH) for
    jobs that have raised a signal on setup.
 -- Add "[jobid.stepid]" prefix from slurmstepd and "slurmscriptd" prefix from
    slurmcriptd to Syslog logging. Previously was only happening when logging
    to a file.
 -- Make it so scrontab prints client-side the job_submit() err_msg (which can
    be set i.e. by using the log_user() function for the lua plugin).
 -- Remove ability for reservation to have STATIC_ALLOC or MAINT flags and
    REPLACE[_DOWN] flags simultaneously.
 -- Accept only one reoccurring flag when creating/updating any reservation.
 -- Remove ability to update a reservation to have a reoccurring flag if it
    is a floating reservation.
 -- squeue - removed unused '%s' and 'SelectJobInfo' formats.
 -- Add purge and archive functionality for job environment and job batch script
    records.
 -- srun - return an error if step suffers a node failure.
 -- squeue - align print format for exit and derived codes with that of other
    components (<exit_status>:<signal_number>).
 -- Add new SlurmctldParameters=validate_nodeaddr_threads=<number> option to
    allow concurrent hostname resolution at slurmctld startup.
 -- Have 'scontrol show hostlist -' read from stdin.
 -- Extend support for Include files to all "configless" client commands.
 -- Make node weight usable for powered down and rebooting nodes.
 -- node_features plugins - node_features_p_reboot_weight() function removed.
 -- Removed 'launch' plugin.
 -- Add "Extra" field to job to store extra information other than a comment.
 -- Add new AccountingStoreFlags=job_extra option to store a job's extra field
    in the database.
 -- slurmrestd - add option to allow rest_auth/local to switch user id on first
    user connection.
 -- oci.conf - add DisableHooks option.
 -- oci.conf - add SrunPath and SrunArgs options.
 -- oci.conf - add StdIODebug, SyslogDebug, FileDebug and DebugFlags options to
    allow controlling container specific logging.
 -- oci.conf - remove requirement of RunTimeQuery when RunTimeRun is set.
 -- slurmstepd - cleanup generated environment file for containers when step
    completes instead of deferring cleanup to OCI runtime.
 -- oci.conf - add configuration option "IgnoreFileConfigJson=" to allow a site
    to choose to ignore config.json.
 -- oci.conf - Add PID (%p) pattern replacement.
 -- slurmrestd - correct ordering issue of saving changes to a container's
    modified config.json where config changes by job modifing plugins would be
    silently lost.
 -- slurmstepd - merge container config.json environment into job environment
    and then overwrite config.json environment. Avoids instance where processes in
    container will not have access to job environment variables.
 -- slurmstepd - defer creating container environment file until after all
    plugin based modifications to the job environment are complete.
 -- oci.conf - modify configuration option "CreateEnvFile=" to support creating
 -- oci.conf - add RunTimeEnvExclude and EnvExclude.
 -- slurmstepd - fix container pattern bundle path replacement (%b) with
    bundle path instead of spool dir path.
 -- oci.conf - add MountSpoolDir.
 -- slurmstepd - create per task spool directory per container to avoid
    conflicts when there are more than 1 container tasks on any given node.
 -- mpi/pmix - set PMIX_SERVER_TMPDIR to container spool directory instead of
    slurmd spool directory which caused PMIx to fail to load in containers.
 -- Add new "defer_batch" option to SchedulerParameters to only defer
    scheduling for batch jobs.
 -- Reject jobs submitted with impossible --time, --deadline, and --begin
    combinations at submission time
 -- Add new DebugFlags option 'JobComp' to replace 'Elasticsearch'.
 -- sacct - Add --array option to expand job arrays and display array tasks on
    separate lines.
 -- Fix jobs submitted with a deadline never being cleared after the
    reservation is done.
 -- Change srun/salloc to wait indefinitely for their allocations to be ready.
 -- Do not attempt to "fix" malformed input to 'scontrol show hostlist'.
 -- RSMI - Add usage gathering for AMD gpus (requires ROCM 5.5+).
 -- Add job's allocated nodes, features, oversubscribe, partition, and
    reservation to SLURM_RESUME_FILE output for power saving.
 -- Automatically create directories for stdout/stderr output files. Paths may
    use %j and related substitution characters as well.
 -- Add --tres-per-task to salloc/sbatch/srun.
 -- Add configurable job requeue limit parameter - MaxBatchRequeue - in
    slurm.conf to permit changes from the old hard-coded value of 5.
 -- Add a new "nodes=" argument to "scontrol setdebugflags" as well.
 -- slurmd - add --authinfo option to allow AuthInfo options to be changed
    during the configless startup.
 -- helpers.conf - Allow specification of node specific features.
 -- helpers.conf - Allow many features to one helper script.
 -- Allow nodefeatures plugin features to work with cloud nodes.
 -- squeue - removed --array-unique option.
 -- openapi/v0.0.39 - expand job stderr, stdin, and stdout path replacement
    symbols when dumping job information via dump_job_info().
 -- Make slurmstepd cgroups constrained by total configured memory from
    slurm.conf (NodeName=<> RealMemory=#) instead of total physical memory.
 -- node_features/helpers - add support for the OR and parentheses operators
    in a --constraint expression.
 -- Fix race condition between PMIx authentication and slurmstepd task launches
    that can lead to job launch failures.
 -- fatal() when [Prolog|Epilog]Slurmctld are defined but not executable.
 -- slurmctld - Add new RPC rate limiting feature. This is enabled through
    SlurmctldParameters=rl_enable, otherwise disabled by default.
 -- Validate node registered active features are a super set of node's
    currently active changeable features.
 -- On clusters without any PrologFlags options, batch jobs with failed prologs
    nolonger generate an output file.
 -- sreport - print "Top ALL Users" for Top User report when topcount = -1.
 -- Add SLURM_JOB_START_TIME and SLURM_JOB_END_TIME environment variables.
 -- Add SuspendExcStates option to slurm.conf to avoid suspending/powering down
    specific node states.
 -- job_container/tmpfs - Add "Shared" option to support shared namespaces.
    This allows autofs to work with the job_container/tmpfs plugin when enabled.
 -- Fix incorrect min node estimation for pending jobs as displayed by client
    commands (e.g. squeue, scontrol show job).
 -- Add support for DCMI power readings in IPMI plugin.
 -- Prevent the backfill counter of tested jobs being reset by sdiag -r.
 -- sacctmgr - Add --json and --yaml arguments.
 -- openapi/v0.0.39 - Conversion of parsing and dumping of data to
    data_parser/v0.0.39 plugins. Significant restructuring of OpenAPI
    specification compared to previous plugin version.
 -- openapi/dbv0.0.39 - Conversion of parsing and dumping of data to
    data_parser/v0.0.39 plugins. Significant restructuring of OpenAPI
    specification compared to previous plugin version.
 -- Validate --gpu-bind options more strictly.
 -- Fix slurmd segfault on bad EnergyIPMIPowerSensors= parameter.
 -- Allow for --nodelist to contain more nodes than required by --nodes.
 -- Add missing logic for JobCompParams configuration key pair to be available
    for consumers of the get/print/write configuration API functions.
 -- mpi/cray_shasta - Add new PALS/PMI environment variables.
 -- Add cache around calls to getnameinfo().
 -- Add CommunicationParameters=getnameinfo_cache_timeout to tune or disable the
    getnameinfo cache.
 -- Limit the number of successive times a batch job may be requeued due to a
    prolog failure. This limit is defined by the value of the max_batch_requeue
    parameter (default 5). Jobs over this limit will be put on admin hold.
 -- Rename "nodes" to "nodes_resume" in SLURM_RESUME_FILE job output.
 -- Rename "all_nodes" to "all_nodes_resume" in SLURM_RESUME_FILE output.
 -- Add new PrologFlags=ForceRequeueOnFail option to automatically requeue
    batch jobs on Prolog failures regardless of the job --requeue setting.
 -- Add HealthCheckNodeState=NONDRAINED_IDLE option.
 -- Add 'explicit' to Flags in gres.conf
 -- Improve validation of --constraint expression syntax.
 -- srun - support job array ids as an argument to --jobid.
 -- Add jobcomp/kafka plugin.
 -- Automatically filter out E-Cores on Intel processors to avoid issues from
    differing threads-per-core values within a single socket.
 -- Add LaunchParameters=ulimit_pam_adopt, which enables setting RLIMIT_RSS in
    adopted processes.
 -- Add new PreemptParameters=reclaim_licenses option which will allow higher
    priority jobs to preempt jobs to free up used licenses. (This is only
    enabled for with PreemptModes of CANCEL and REQUEUE, as Slurm cannot
    guarantee suspended jobs will release licenses correctly.)
 -- Make it so that the REQUEST_STEP_STAT handler only polls jobacct_gather
    information once per RPC. This improves sstat results performance time.
 -- Fix sbcast --force option to work with --send-libs option. Now when --force
    is set, library directores transmitted will overwrite pre-existing libraries
    that were previously transmitted.
 -- hpe/slingshot - Add support for user requestible job VNIs.
 -- hpe/slingshot - Add support for user requestible single node vnis.
 -- hpe/slingshot - Add support for the instant-on feature.
 -- Add ability to update SuspendExc* parameters with scontrol.
 -- Add ability to preserve SuspendExc* parameters on reconfig with
    ReconfigFlags=KeepPowerSaveSettings.
 -- Add ability to restore SuspendExc* parameters on restart with slurmctld -R
    option.
 -- Fix leaving allocated gres on a non-cloud node after being allocated
    from a powered down state after a slurmctld restart.
 -- 'scontrol update job' can now set a GRES specification to "0" to effectively
    clear a GRES speficiation from a job.
 -- Jobs with old GRES that are no longer configured in any configuration files
    can now be succesfully updated to use currently configured GRES.
 -- Add tres_per_node to resource_allocation_response_msg to fix srun jobs
    running with outdated GRES. This is necessary for srun jobs whose GRES are
    updated while they are pending. By having tres_per_node in the
    resourece_allocation_response_msg, slurmctld can send back the correct and
    updated GRES, whereas without it, the srun job would use the old GRES.
 -- Cleaned up various "warning", "Warning", and "WARNING" messages with a new
    warning() logging call. All will now print as "warning: ...".
 -- Add SLURM_JOB_OVERSUBSCRIBE environment variable for Epilog, Prolog,
    EpilogSlurmctld, PrologSlurmctld, and mail ouput.
 -- Fix node reason time skew when setting a reboot message.
 -- Append ResumeTimeout message to an existing node reason instead of always
    clearing it first.
 -- slurmrestd - added support for Bearer Authentication using auth/jwt.
 -- Add check to detect invalid HetJob component and abort job if identified.
 -- sched/backfill - fix job test against advanced reservations if job uses a
    preemptable QOS with Flags=NoReserve.
 -- New command scrun has been added. scrun acts as an Open Container Initiative
    (OCI) runtime proxy to run containers seamlessly via Slurm.
 -- Added support for Linux kernel user namespaces. Process user and group ids
    are no longer used unless explicitly requested as an argument. They are
    left as SLURM_AUTH_NOBODY (99) by default.

* Changes in Slurm 22.05.12
===========================

* Changes in Slurm 22.05.11
===========================
 -- Prevent message extension attacks that could bypass the message hash.
    CVE-2023-49933.
 -- Prevent NULL pointer dereference on size_valp overflow. CVE-2023-49936.
 -- Prevent double-xfree() on error in _unpack_node_reg_resp().
    CVE-2023-49937.
 -- Prevent modified sbcast RPCs from opening a file with the wrong group
    permissions. CVE-2023-49938.

* Changes in Slurm 22.05.10
===========================
 -- Fix filesystem handling race conditions that could lead to an attacker
    taking control of an arbitrary file, or removing entire directories'
    contents. CVE-2023-41914.

* Changes in Slurm 22.05.9
==========================
 -- Allocate correct number of sockets when requesting gres and running with
    CR_SOCKET*.
 -- Fix handling of --prefer for job arrays.
 -- Fix regression in 22.05.5 that causes some jobs that request
    --ntasks-per-node to be incorrectly rejected.
 -- Fix slurmctld crash when a step requests fewer tasks than nodes.
 -- Fix incorrect task count in steps that request --ntasks-per-node and a node
    count with a range (e.g. -N1-2).
 -- Fix some valid step requests hanging instead of running.
 -- slurmrestd - avoid possible race condition which would cause slurmrestd to
    silently no longer accept new client connections.
 -- Fix GPU setup on CRAY systems when using the CRAY_CUDA_MPS environment
    variable. GPUs are now correctly detected in such scenarios.
 -- Fix the job prolog not running for jobs with the interactive step
    (salloc jobs with LaunchParameters=use_interactive_step set in slurm.conf)
    that were scheduled on powered down nodes. The prolog not running also
    broke job_container/tmpfs, pam_slurm_adopt, and x11 forwarding.
 -- task/affinity - fix slurmd segfault when request launch task requests of
    type "--cpu-bind=[map,mask]_cpu:<list>" have no <list> provided.
 -- sched/backfill - fix segfault when removing a PLANNED node from system.
 -- sched/backfill - fix deleted planned node staying in planned node bitmap.
 -- Fix nodes remaining as PLANNED after slurmctld save state recovery.
 -- Fix regression in 22.05.0rc1 that broke Nodes=ALL in a NodeSet.
 -- Fix incorrect memory constraint when receiving a job from 20.11 that uses
    cpu count for memory calculation.
 -- openapi/v0.0.[36-38] - avoid possible crash from jobs submitted with argv.
 -- openapi/v0.0.[36-38] - avoid possible crash from rejected jobs submitted
    with batch_features.
 -- srun - fix regression in 22.05.7 that prevented slurmctld from connecting
    to an srun running outside of a compute node.

* Changes in Slurm 22.05.8
==========================
 -- Fix potential deadlock at slurmctld startup when job has invalid qos.
 -- Avoid unnecessary call to clusteracct_storage_g_cluster_tres() when pinging
    dynamic nodes. This avoids significant slowdowns for slurmctld when
    ping_nodes() calls all nodes to re-register.
 -- openapi/dbv0.0.3[6-8] - fix segfault that could arrise from Slurm database
    connnection failing.
 -- Fix regression introduced in 22.05.0rc1 when updating a NodeName=<nodelist>
    with NodeAddr and/or NodeHostname if the specified nodelist wasn't sorted.
 -- openapi/v0.0.38 - change type of nice field for job submissions to integer
    from string.
 -- openapi/v0.0.38 - add oversubscribe option to job submission properties.
 -- openapi/v0.0.38 - fix incorrect data used to populate "time/start" field
    for jobs.
 -- openapi/dbv0.0.38 - avoid dumping failure if preempt qos with level 0 is
    provided by slurmdbd query.
 -- Avoid an fd leak when lib dir for sbcast fails to be created.
 -- common/slurmdbd_pack - fix env and script hash when unpacking a 21.08
    dbd_job_start_msg_t.
 -- Fix a race between job_container/tmpfs, cncu, x11 setup and adoption of pids
    in cray with pam_slurm_adopt.

* Changes in Slurm 22.05.7
==========================
 -- Fix slurmctlds in a federation not recovering a lost connection until a
    slurmctld restart or a federation update.
 -- Fix incorrectly rejecting jobs that request GRES on multiple sockets and
    --gres-flags=enforce-binding.
 -- Fix job core selection with --gres-flags=enforce-binding: this fixes cases
    where enforce-binding was not respected.
 -- openapi/v0.0.38 - set assoc_id resolution failure as a debug log instead of
    an error log.
 -- Fix issues when running in FrontEnd mode.
 -- Fix srun and salloc I/O code to set keepaliveinterval/keepalivetime on
    connections.
 -- Fix overwrite race of cont_id in cgroup/v2 when using task/cgroup with
    proctrack/cray_aries.
 -- Fix node remaining allocated after a reconfig with a completing job that
    has an EpilogSlurmctld instance still running.
 -- openapi/dbv0.0.38 - fix a cast to a wrong type
 -- openapi/dbv0.0.38 - correct issues where modifying association fields were
    ignored.
 -- openapi/dbv0.0.38 - correct issue where 16 bit integers were not able to be
    unset.
 -- openapi/dbv0.0.38 - correct issue where 16 & 32 bit integers were not able
    to be unset.
 -- Fix 'scontrol show hostlist' to read off a pipe correctly.
 -- Fix 'scontrol reconfigure' with configless enabled to send updated configs
    to 21.08 nodes correctly. (22.05 nodes are unaffected.)
 -- Fix assertion and locks for dynamic node registrations with rpc queueing.
 -- rest_auth/local - avoid logging root access as an error but instead as a
    normal info log.
 -- slurmrestd - switch users earlier on startup to avoid sockets being made as
    root.
 -- slurmrestd - disable umask during socket creation as the authentication is
    handled by Slurm instead of file ACLs.
 -- Fix sbcast, srun --bcast, sstat not working with cloud/dynamic nodes.
 -- sacctmgr - Allow removal of user's default account when AllowNoDefAcct=yes.
 -- Fix segfault caused by race condition when a reconfiguration is requested
    while slurmd initializes.
 -- openapi/v0.0.38 - avoid divison by zero causing slurmrestd to crash during
    diag queries.
 -- Update default values for text/blob columns in the database if upgrading
    to MariaDB >= 10.2.1 from a pre-10.2.1 version or from MySQL to avoid
    sacctmgr failures.
 -- Fix several minor memory leaks in the cgroup/v2 plugin.
 -- Fix possible issue when enabling controllers with long names in cgroup/v2.
 -- Fix potential segfault in slurmd when using acct_gather_energy/ipmi.
 -- Fix controller being able to contact non-addressable step hosts.
 -- Allow setting SuspendTime to -1 when used on a partition.
 -- openapi/v0.0.38 - fix maximum_memory_per_node description typo.
 -- openapi/v0.0.38 - add maximum_memory_per_cpu to GET /partitions
 -- openapi/v0.0.38 - add default_memory_per_node to GET /partitions
 -- Fix dynamic node losing dynamic node status when changing state to FUTURE.
 -- Fix adoption into most recent job in pam_slurm_adopt and cgroup/v2.
 -- gres/shard - Fix plugin_name definition to print correctly in debug lines.

* Changes in Slurm 22.05.6
==========================
 -- Fix a partition's DisableRootJobs=no from preventing root jobs from working.
 -- Fix the number of allocated cpus for an auto-adjustment case in which the
    job requests --ntasks-per-node and --mem (per-node) but the limit is
    MaxMemPerCPU.
 -- Fix POWER_DOWN_FORCE request leaving node in completing state.
 -- Do not count magnetic reservation queue records towards backfill limits.
 -- Clarify error message when --send-libs=yes or BcastParameters=send_libs
    fails to identify shared library files, and avoid creating an empty
    "<filename>_libs" directory on the target filesystem.
 -- Fix missing CoreSpec on dynamic nodes upon slurmctld restart.
 -- Fix node state reporting when using specialized cores.
 -- Fix number of CPUs allocated if --cpus-per-gpu used.
 -- Add flag ignore_prefer_validation to not validate --prefer on a job.
 -- Fix salloc/sbatch SLURM_TASKS_PER_NODE output environment variable when the
    number of tasks is not requested.
 -- Permit using wildcard magic cookies with X11 forwarding.
 -- cgroup/v2 - Add check for swap when running OOM check after task
    termination.
 -- Fix deadlock caused by race condition when disabling power save with a
    reconfigure.
 -- Fix memory leak in the dbd when container is sent to the database.
 -- openapi/dbv0.0.38 - correct dbv0.0.38_tres_info.
 -- Fix node SuspendTime, SuspendTimeout, ResumeTimeout being updated after
    altering partition node lists with scontrol.
 -- jobcomp/elasticsearch - fix data_t memory leak after serialization.
 -- Fix issue where '*' wasn't accepted in gpu/cpu bind.
 -- Fix SLURM_GPUS_ON_NODE for shared GPU gres (MPS, shards).
 -- Add SLURM_SHARDS_ON_NODE environment variable for shards.
 -- Fix srun error with overcommit.
 -- Fix bug in core selection for the default cyclic distribution of tasks
    across sockets, that resulted in random task launch failures.
 -- Fix core selection for steps requesting multiple tasks per core when
    allocation contains more cores than required for step.
 -- gpu/nvml - Fix MIG minor number generation when GPU minor number
    (/dev/nvidia[minor_number]) and index (as seen in nvidia-smi) do not match.
 -- Fix accrue time underflow errors after slurmctld reconfig or restart.
 -- Surpress errant errors from prolog_complete about being unable to locate
    "node:(null)".
 -- Fix issue where shards were selected from multiple gpus and failed to
    allocate.
 -- Fix step cpu count calculation when using --ntasks-per-gpu=.
 -- Fix overflow problems when validating array index parameters in slurmctld
    and prevent a potential condition causing slurmctld to crash.
 -- Remove dependency on json-c in slurmctld when running with power saving.
    Only the new "SLURM_RESUME_FILE" support relies on this, and it will be
    disabled if json-c support is unavailable instead.

* Changes in Slurm 22.05.5
==========================
 -- Fix node becoming IDLE while in an invalid registration state.
 -- When a job is completing avoid potential dereference.
 -- Avoid setting preempt_time for a job erroneously.
 -- Fix situation where we don't requeue correctly when a job is finishing.
 -- job_container/tmpfs - Avoid leaking namespace file descriptor.
 -- common/slurm_opt - fix memory leak in client commands or slurmrestd when the
    --chdir option is set after option reset.
 -- openapi/dbv0.0.38 - gracefully handle unknown associations assigned to jobs.
 -- openapi/dbv0.0.38 - query all associations to avoid errors while dumping
    jobs.
 -- Load hash plugin at slurmstepd launch time to prevent issues loading the
    plugin at step completion if the Slurm installation is upgraded.
 -- Fix gcc 12.2.1 compile errors.
 -- Fix future magnetic reservations preventing heterogeneous jobs from
    starting.
 -- Prevent incorrect error message from being generated for operator/admins
    using the 'scontrol top' command.
 -- slurmrestd - correct issue where larger requests could result in a single
    byte getting removed from inside of the POST request.
 -- Fix regression in task count calculation for --ntasks-per-gpu with multiple
    nodes.
 -- Update nvml plugin to match the unique id format for MIG devices in new
    Nvidia drivers.
 -- Fix segfault on backup slurmdbd if no QoS is present in DB.
 -- Fix clang 11 compile errors.
 -- Fix task distribution calculations across sockets with
    --distribution=cyclic.
 -- Fix task distribution calculations with --ntasks-per-gpu specified without
    an explicit --ntasks value.
 -- Fix job arrays not showing correct features.
 -- Fix job having wrong features used when using preferred features.
 -- Fix task/cray_aries error finishing an interactive step, avoiding correct
    cleanup.
 -- Correctly set max_nodes when --ntasks=1.
 -- Fix configure script on FreeBSD.

* Changes in Slurm 22.05.4
==========================
 -- Fix return code from salloc when the job is revoked prior to executing user
    command.
 -- Fix minor memory leak when dealing with gres with multiple files.
 -- Fix printing for no_consume gres in scontrol show job.
 -- sinfo - Fix truncation of very large values when outputting memory.
 -- Fix multi-node step launch failure when nodes in the controller aren't in
    natural order. This can happen with inconsistent node naming (such as
    node15 and node052) or with dynamic nodes which can register in any order.
 -- job_container/tmpfs - Prevent reading the plugin config multiple times per
    step.
 -- Fix wrong attempt of gres binding for gres w/out cores defined.
 -- Fix build to work with '--without-shared-libslurm' configure flag.
 -- Fix power_save mode when repeatedly configuring too fast.
 -- Fix sacct -I option.
 -- Prevent jobs from being scheduled on future nodes.
 -- Fix memory leak in slurmd happening on reconfigure when CPUSpecList used.
 -- Fix sacctmgr show event [min|max]cpus.
 -- Fix regression in 22.05.0rc1 where a prolog or epilog that redirected stdout
    to a file could get erroneously killed, resulting in job launch failure
    (for the prolog) and the node being drained.
 -- cgroup/v1 - Make a static variable to remove potential redundant checking
    for if the system has swap or not.
 -- cgroup/v1 - Add check for swap when running OOM check after task
    termination.
 -- job_submit/lua - add --prefer support
 -- cgroup/v1 - fix issue where sibling steps could incorrectly be accounted as
    OOM when step memory limit was the same as the job allocation. Detect OOM
    events via memory.oom_control oom_kill when exposed by the kernel instead of
    subscribing notifications with eventfd.
 -- Fix accounting of oom_kill events in cgroup/v2 and task/cgroup.
 -- Fix segfault when slurmd reports less than configured gres with links after
    a slurmctld restart.
 -- Fix TRES counts after node is deleted using scontrol.
 -- sched/backfill - properly handle multi-reservation HetJobs.
 -- sched/backfill - don't try to start HetJobs after system state change.
 -- openapi/v0.0.38 - add submission of job->prefer value.
 -- slurmdbd - become SlurmUser at the same point in logic as slurmctld to match
    plugins initialization behavior. This avoids a fatal error when starting
    slurmdbd as root and root cannot start the auth or accounting_storage
    plugins (for example, if root cannot read the jwt key).
 -- Fix memory leak when attempting to update a job's features with invalid
    features.
 -- Fix occasional slurmctld crash or hang in backfill due to invalid pointers.
 -- Fix segfault on Cray machines if cgroup cpuset is used in cgroup/v1.

* Changes in Slurm 22.05.3
==========================
 -- job_container/tmpfs - cleanup containers even when the .ns file isn't
    mounted anymore.
 -- Ignore the bf_licenses option if using sched/builtin.
 -- Do not clear the job's requested QOS (qos_id) when ineligible due to QOS.
 -- Emit error and add fail-safe when job's qos_id changes unexpectedly.
 -- Fix timeout value in log.
 -- openapi/v0.0.38 - fix setting of DefaultTime when dumping a partition.
 -- openapi/dbv0.0.38 - correct parsing association QOS field.
 -- Fix LaunchParameters=mpir_use_nodeaddr.
 -- Fix various edge cases where accrue limits could be exceeded or cause
    underflow error messages.
 -- Fix issue where a job requesting --ntasks and --nodes could be wrongly
    rejected when spanning heterogeneous nodes.
 -- openapi/v0.0.38 - detect when partition PreemptMode is disabled
 -- openapi/v0.0.38 - add QOS flag to handle partition PreemptMode=within
 -- Add total_cpus and total_nodes values to the partition list in
    the job_submit/lua plugin.
 -- openapi/dbv0.0.38 - reject and error on invalid flag values in well defined
    flag fields.
 -- openapi/dbv0.0.38 - correct QOS preempt_mode flag requests being silently
    ignored.
 -- accounting_storage/mysql - allow QOS preempt_mode flag updates when GANG
    mode is requested.
 -- openapi/dbv0.0.38 - correct QOS flag modifications request being silently
    ignored.
 -- sacct/sinfo/squeue - use openapi/[db]v0.0.38 for --json and --yaml modes.
 -- Improve error messages when using configless and fetching the config fails.
 -- Fix segfault when reboot_from_controller is configured and scontrol reboot
    is used.
 -- Fix regression which prevented a cons_tres gpu job to be submitted to a
    cons_tres cluster from a non-con_tres cluster.
 -- openapi/dbv0.0.38 - correct association QOS list parsing for updates.
 -- Fix rollup incorrectly divying up unused reservation time between
    associations.
 -- slurmrestd - add SLURMRESTD_SECURITY=disable_unshare_files environment
    variable.
 -- Update rsmi detection to handle new default library location.
 -- Fix header inclusion from slurmstepd manager code leading to multiple
    definition errors when linking --without-shared-libslurm.
 -- slurm.spec - explicitly disable Link Time Optimization (LTO) to avoid
    linking errors on systems where LTO-related RPM macros are enabled by
    default and the binutils version has a bug.
 -- Fix issue in the api/step_io message writing logic leading to incorrect
    behavior in API consuming clients like srun or sattach, including a segfault
    when freeing IO buffers holding traffic from the tasks to the client.
 -- openapi/dbv0.0.38 - avoid job queries getting rejected when cluster is not
    provided by client.
 -- openapi/dbv0.0.38 - accept job state filter as verbose names instead of
    only numeric state ids.
 -- Fix regression in 22.05.0rc1: if slurmd shuts down while a prolog is
    running, the job is cancelled and the node is drained.
 -- Wait up to PrologEpilogTimeout before shutting down slurmd to allow prolog
    and epilog scripts to complete or timeout. Previously, slurmd waited 120
    seconds before timing out and killing prolog and epilog scripts.
 -- GPU - Fix checking frequencies to check them all and not skip the last one.
 -- GPU - Fix logic to set frequencies properly when handling multiple GPUs.
 -- cgroup/v2 - Fix typo in error message.
 -- cgroup/v2 - More robust pattern search for events.
 -- Fix slurm_spank_job_[prolog|epilog] failures being masked if a Prolog or
    Epilog script is defined (regression in 22.05.0rc1).
 -- When a job requested nodes and can't immediately start, only report to
    the user (squeue/scontrol et al) if nodes are down in the requested list.
 -- openapi/dbv0.0.38 - Fix qos list/preempt not being parsed correctly.
 -- Fix dynamic nodes registrations mapping previously assigned nodes.
 -- Remove unnecessarily limit on count of 'shared' gres.
 -- Fix shared gres on CLOUD nodes not properly initializing.

* Changes in Slurm 22.05.2
==========================
 -- Fix a segfault in slurmctld when requesting gres in job arrays.
 -- Prevent jobs from launching on newly powered up nodes that register with
    invalid config.
 -- Fix a segfault when there's no memory.swap.current interface in cgroup/v2.
 -- Fix memleak in cgroup/v2.

* Changes in Slurm 22.05.1
==========================
 -- Flush the list of Include config files on SIGHUP.
 -- Fix and update Slurm completion script.
 -- jobacct_gather/cgroup - Add VMem support both for cgroup v1 and v2.
 -- Allow subset of node state transitions when node is in INVAL state.
 -- Remove INVAL state from cloud node after being powered down.
 -- When showing reason UID in scontrol show node, use the authenticated UID
    instead of the login UID.
 -- Fix calculation of reservation's NodeCnt when using dynamic nodes.
 -- Add SBATCH_{ERROR,INPUT,OUTPUT} input environment variables for --error,
    --input and --output options respectively.
 -- Prevent oversubscription of licenses by the backfill scheduler when not
    using the new "bf_licenses" option.
 -- Jobs with multiple nodes in a heterogeneous cluster now have access to all
    the memory on each node by using --mem=0. Previously the memory limit was
    set by the node with the least amount of memory.
 -- Don't limit the size of TaskProlog output (previously TaskProlog output was
    limited to 4094 characters per line, which limited the size of exported
    environment variables or logging to the task).
 -- Fix usage of possibly uninitialized buffer in proctrack/cgroup.
 -- Fix memleak in proctrack/cgroup proctrack_p_wait.
 -- Fix cloud/remote het srun jobs.
 -- Fix a segfault that may happen on gpu configured as no_consume.

* Changes in Slurm 22.05.0
==========================
 -- openapi/v0.0.38 - add group name to job info
 -- openapi/v0.0.38 - add container field to job description.
 -- openapi/v0.0.38 - add container to job submission.
 -- openapi/[db]v0.0.38 - add container field to job description.
 -- openapi/dbv0.0.38 - fix bug where QOS update set various limits to 0.
 -- openapi/dbv0.0.38 - properly initialize wckey record.
 -- openapi/dbv0.0.38 - properly initialize cluster record.
 -- openapi/dbv0.0.38 - gracefully update existing QOSs.
 -- Fix x11 forwarding with job_container/tmpfs and without home_xauthority.
 -- Fix reconfig of dynamic nodes with gres.
 -- Fix corner case issues when removing assocs/qos' while jobs are completing
    and a reconfigure happens.
 -- Add SlurmdParameters=numa_node_as_socket to use the numa node as a socket.
 -- Avoid creating and referencing NULL script/env hash entries when not storing
    the job script or job environment.
 -- slurmd - If a het component job fails to launch due to a node prolog or
    other failure, properly handle the whole het job.
 -- Fix possible race condition while handling forwarded messages.
 -- Add new SchedulerParameters option "bf_licenses" to track licenses as
    within the backfill scheduler.
 -- Fix resuming nodes not part of an allocation.
 -- Minor memory leak fixes.
 -- Use accept4() and pipe2() to ensure new file descriptors are always set
    with close-on-exec flag.
 -- slurmctld - allow users to request tokens for themselves by name.
 -- srun - adjust output of "--mpi=list".
 -- Fix "--gpu-bind=single:" having wrong env variables.
 -- Sync missing pieces in slurmctld SIGHUP handler with respect to
    REQUEST_RECONFIGURE RPC handler.
 -- Fixed the behavior of the --states=all option in squeue to actually show
    all of the states.
 -- job_container - Don't constrain a job using --no-allocate.
 -- Fix slurmctld segfault when a step requests a gres without a file.
 -- Fix slurmctld segfault when cleaning up an overlapping step.
 -- Dynamic node fixes and updates.
 -- Added error logging when a node goes into an invalid state so that the user
    can still see the reason even if the user set a custom reason beforehand.
 -- Remove redundant message when libdbus is found during configure.
 -- Fix pmix to honor SrunPortRange.
 -- Fix issue with ntasks_per_socket and ntasks_per_core with --exclusive
 -- openapi/v0.0.38 - change job parsing error message to reflect reality.
 -- Avoid segfault/assert when --thread-spec used with config_overrides
 -- Don't send SIGTERM to prematurely in run_command.
 -- Add logging to inform where networking errors are occurring on slurmd end.
 -- openapi/dbv0.0.38 - Enforce GET /association/ to dump only a single
    association.
 -- openapi/dbv0.0.38 - Enforce DELETE /association/ to delete only a single
    association.
 -- openapi/dbv0.0.38 - Add parameters to filter to GET /associations/.
 -- openapi/dbv0.0.38 - Add DELETE /associations using parameters to set filters.
 -- openapi/dbv0.0.38 - Fix plural form of delete association response schema.

* Changes in Slurm 22.05.0rc1
=============================
 -- gres/gpu - Avoid stripping GRES type field during normalization if any
    other GRES have a defined type field.
 -- burst_buffer/datawarp - free bb_job after stage-out or teardown are done.
 -- acct_gather_energy_rsmi has been renamed acct_gather_energy_gpu.
 -- Remove support for (non-functional) --cpu-bind=boards.
 -- accounting_storage/mysql - ensure new non-HetJobs have het_job_offset NO_VAL
    in the database and fix the same field when retrieving older bad records.
 -- PreemptMode now works as a condition for qos in sacctmgr.
 -- scancel - add "--me" option.
 -- gres/gpu - Fix configured/system-detected GRES match for some combinations
    for which the sorting affected the expected selection result.
 -- openapi/v0.0.38 - Fork existing openapi/v0.0.37 plugin.
 -- openapi/dbv0.0.38 - Fork existing openapi/dbv0.0.37 plugin.
 -- openapi/v0.0.35 - Plugin has been removed.
 -- scrontab - Don't accept extra letters after a '@' repeating pattern.
 -- openapi/dbv0.0.38 - Add missing method POST for /associations/.
 -- Make DefMemPerCPU/MaxMemPerCPU and DefMemPerNode/MaxMemPerNode precedence
    at the global level the same as in partition level, and print an error
    if both of a pair are set.
 -- openapi/v0.0.38 - Allow strings for JobIds instead of only numerical JobIds
    for GET, DELETE, and POST job methods.
 -- openapi/v0.0.38 - enable job priority field for job submissions and updates.
 -- openapi/v0.0.38 - request node states query includes MIXED state instead of
    only allocated.
 -- openapi/dbv0.0.38 - Correct tree position of dbv0.0.38_job_step.
 -- Enforce all Slurm plugin requirements for plugins specified with absolute
    path.
 -- Added --prefer option at job submission to allow for 'soft' constraints.
 -- Remove support for PMIx 1.x
 -- slurmrestd - Unlink unix sockets before binding to avoid errors where
    previous run of slurmrestd did not properly cleanup the sockets.
 -- Add extra 'EnvironmentFile=-/etc/default/$service' setting to service files.
 -- slurmctld/agent - spawn more agent threads in a single _agent_retry().
 -- openapi/v0.0.38 - change job response types to more specific types than
    generic string.
 -- srun - refuse to run on malformed SPANK environment variable.
 -- Allow jobs to pack onto nodes already rebooting with the desired features.
 -- Reset job start time after nodes are rebooted.
 -- Node features (if any) are passed to RebootProgram if run from slurmctld.
 -- Fix sending multiple features to RebootProgram.
 -- If a task/srun prolog fails don't allow the step to continue running.
 -- Fail srun when using invalid --cpu-bind options.
 -- cgroup/v1 - Set swappiness at job level instead of at root level.
 -- Fix issues where a step's GRES request could never be satisfied but the step
    remained pending forever instead of being rejected.
 -- openapi/v0.0.38 - Remove errant extra space after JOB_CPUS_SET flag.
 -- slurmrestd - refuse to run with gid 0, or under SlurmUser's gid.
 -- Storing batch scripts and env vars are now in indexed tables using
    substantially less disk space.  Those storing scripts in 21.08 will all
    be moved and indexed automatically.
 -- Run MailProg through slurmscriptd instead of directly fork+exec()'ing
    from slurmctld.
 -- Add acct_gather_interconnect/sysfs plugin.
 -- Fix gpus spanning more resources than needed when usng --cpus-per-gpu.
 -- burst_buffer plugins - err_msg added to bb_p_job_validate().
 -- burst_buffer plugins - Send user specific error message if permission
    denied due to AllowUsers or DenyUsers in burst_buffer.conf.
 -- Fatal if the mutually-exclusive JobAcctGatherParams options of UsePss and
    NoShared are both defined.
 -- Future and Cloud nodes are treated as "Planned Down" in usage reports.
 -- Add "condflags=open" to sacctmgr show events to return open/currently down
    events.
 -- Skip --mem-per-gpu impact on GRES availability when CR_MEMORY not set.
 -- Add reservation start time as a new schedulers sorting factor for magnetic
    or multi-reservation job queue records.
 -- Improve Dynamic Future node startup to load in config with mapped nodename.
 -- Add new shard plugin for sharing gpus but not with mps.
 -- acct_gather_energy/xcc - add support for Lenovo SD650 V2.
 -- Remove cgroup_allowed_devices_file.conf support.
 -- sacct -f flag implies -c flag.
 -- Node state flags (DRAIN, FAILED, POWERING UP, etc.) will be cleared now if
    node state is updated to FUTURE.
 -- Clear GRES environment variables for jobs or steps that request --gres=none.
 -- slurmctld - Avoid requiring environment to be set when container job is
    specified.
 -- Move the KeepAliveTime option into CommunicationParameters.
 -- slurm.spec - stop explicitly packaging pkgconfig directory to avoid a
    conflict with the pkgconfig package.
 -- Fix sacctmgr load dump printing incorrect default QOS when no value is set.
 -- Fix very early logging in the controller when daemonized
 -- Fix possibility of primary group going missing when running jobs submitted
    after a user has switched primary groups (eg: with sg).
 -- Make it so srun no longer inherits SLURM_CPUS_PER_TASK. It now will only
    inherit SRUN_CPUS_PER_TASK.
 -- Make HetJob signaling requests using the HetJobId+HetJobOffset format behave
    the same as with direct JobId requests with regards to job state and
    whole_hetjob considerations.
 -- scancel - avoid issuing a RPC for each HetJob non-leader components hit by
    using filters (not using jobids) when a RPC is issued for their leader.
 -- Make slurmctld call the JobCompPlugin set location operation on SIGUSR2. As
    a relevant consequence, the filetxt plugin reopens the file for potential
    logrotation.
 -- openapi/v0.0.38 - added fields bf_table_size and bf_table_size_mean to
    diag query.
 -- Handle scontrol setdebug[flags] and scontrol reconfigure in slurmscriptd.
 -- openapi/v0.0.38 - add /licenses endpoint.
 -- slurmrestd - only compile JWT authentication plugin if libjwt is present.
 -- Remove connect_timeout and timeout options from JobCompParams as there's no
    longer a connectivity check happening in the jobcomp/elasticsearch plugin
    when setting the location off of JobCompLoc.
 -- Add %n for NodeName substitution in SlurmdSpoolDir in nss_slurm.conf.
 -- job_container/tmpfs - add basic environment variables to InitScript.
 -- openapi/dbv0.0.38 - split security entries in openapi.json.
 -- openapi/v0.0.38 - Add schema for Slurm meta in responses.
 -- openapi/dbv0.0.38 - Add schema for Slurm meta in responses.
 -- openapi/v0.0.38 - Correct field "errno" to "error_number" in schema for
    errors.
 -- openapi/dbv0.0.38 - add failure response contents in openapi.json.
 -- openapi/v0.0.38 - add failure response contents in openapi.json.
 -- openapi/dbv0.0.38 - add requestBody for /users/ in openapi.json.
 -- openapi/dbv0.0.38 - add requestBody for /accounts/ in openapi.json.
 -- openapi/dbv0.0.38 - add missing response field "removed_associations"
    in openapi.json
 -- openapi/dbv0.0.38 - Correct type from object to array for user assocations
    list in openapi.json.
 -- openapi/dbv0.0.38 - Add missing field for tres minutes per qos in qos list
    in openapi.json.
 -- openapi/dbv0.0.38 - Add missing field for name in qos list in openapi.json.
 -- openapi/dbv0.0.38 - Correct tres field in qos list in openapi.json.
 -- openapi/dbv0.0.38 - Correct het job details types in jobs in openapi.json
 -- openapi/dbv0.0.38 - Correct task type for job steps in openapi.json.
 -- openapi/dbv0.0.38 - Sync fields for errors to source in openapi.json.
 -- openapi/dbv0.0.38 - Add missing field for adding clusters in clusters list
    in openapi.json.
 -- openapi/v0.0.38 - correct parameter styles from "simple" to "form".
 -- openapi/dbv0.0.38 - correct parameter styles from "simple" to "form".
 -- openapi - add flags to slurm_openapi_p_get_specification().
 -- openapi/v0.0.38 - use new operationId generation to ensure uniqueness.
 -- openapi/dbv0.0.38 - use new operationId generation to ensure uniqueness.
 -- slurmstepd - avoid possible race condition while updating step return code
    during job startup.
 -- slurmstepd - report and log I/O setup failure using corresponding error
    code during job start.
 -- Do not run the job if PrologSlurmctld times out.
 -- Fix SPANK plugin calls slurm_spank_job_prolog and slurm_spank_job_epilog
    not properly respecting PrologEpilogTimeout.
 -- Add support for 'scontrol delete <ENTITY> <ID>' format alongside the already
    expected 'scontrol delete <ENTITY>=<ID>'.
 -- Fix task/cgroup plugin which was not adding stepd to memory cgroup.
 -- preempt/qos - add support for WITHIN mode to allow for preemption between
    jobs within the same qos.
 -- Fix sattach for interactive step.
 -- Fix srun -Z when using nss_slurm.
 -- Avoid memory leak in srun -Z.
 -- openapi/dbv0.0.38 - disable automatic lookup of all HetJob components on
    specific job lookups.
 -- Add support for hourly reoccurring reservations.
 -- openapi/v0.0.38 - Fix misspelling of job parameter time_minimum.
 -- openapi/v0.0.38 - Fix misspelling of job parameter cpu_binding_hint.
 -- openapi/v0.0.38 - Fix misspelling of job parameter mcs_label
 -- openapi/dbv0.0.38 - Fix issue where association's QOS list consisted of IDs
    instead of names.
 -- Allow nodes to be dynamically added and removed from the system.
 -- srun --overlap now allows the step to share all resources (CPUs, memory, and
    GRES), where previously --overlap only allowed the step to share CPUs with
    other steps.
 -- openapi/v0.0.38 - new format for how core and socket allocations are dumped
    for jobs.
 -- openapi/v0.0.38 - add RPC call statistics to diag endpoint.
 -- openapi/[db]v0.0.36 - plugins have been marked as deprecated.
 -- sacct - allocations made by srun will now always display the allocation and
    step(s). Previously, the allocation and step were combined when possible.
 -- Steps now allocate gres according to topo data.
 -- Add validation of numbers provided to --gpu-bind=map_gpu and
    --gpu-bind=mask_gpu=.
 -- Fatal error if CgroupReleaseAgentDir is configured in cgroup.conf. The
    option has long been obsolete.
 -- cons_tres - change definition of the "least loaded node" (LLN) to the
    node with the greatest ratio of available cpus to total cpus.
 -- Fatal if more than one burst buffer plugin is configured.
 -- Added keepaliveinterval and keepaliveprobes options to
    CommunicationParameters.
 -- Correctly failover to backup slurmdbd if the primary slurmdbd node crashes.
 -- Add support to ship Include configuration files with configless.
 -- Fix issues with track_script cleanup.
 -- Add new max_token_lifespan limit to AuthAltParameters.
 -- sacctmgr - allow Admins to update AdminComment and SystemComment fields.
 -- slurmd - Cache node features at startup and scontrol reconfig. It avoids
    executing node_features/helpers scripts in the middle of a job. This clould
    potentially affect job performance.
 -- Pass and use alias_list through credential instead of environment variable.
 -- Add ability to get host addresses from nss_slurm.
 -- Enable reverse fanout for cloud+alias_list jobs.
 -- Disallow slurm.conf node configurations with NodeName=ALL.
 -- Add support to delete/update nodes by specifying nodesets or the 'ALL'
    keyword alongside the delete/update node message nodelist expression (i.e.
    'scontrol delete/update NodeName=ALL' or 'scontrol delete/update
    NodeName=ns1,nodes[1-3]').
 -- Add support for PMIx v4
 -- Add support for PMIx v5
 -- Correctly load potentially NULL values from slurmdbd archive files.
 -- Add slurmdbd.conf option AllowNoDefAcct to remove requirement for users to
    have a default account.
 -- Fix issues related to users with very large uids.
 -- common/openapi - fix bug populating methods for parameter-less endpoint.
 -- slurmrestd/operations - fix memory leak when resolving bad path.
 -- sacctmgr - improve performance of query generation for archive load.
 -- sattach - allow connecting to interactive steps with JOBID.interactive
 -- Fix for --gpus-per-task parsing when using --cpus-per-gpu and multiple gpu
    types in the same request.
 -- rest_auth/local - always log when new slurmdbd connection fails.
 -- openapi/dbv0.0.38 - gracefully update existing associations.
 -- Improve auto-detection of pmix
 -- openapi/dbv0.0.38 - Add missing method POST for /qos/.
 -- scrontab - On errors, print 1-index line numbers instead of 0-indexing them.
 -- openapi/dbv0.0.38 - Correct OpenAPI specification for diag request.
 -- openapi/dbv0.0.38 - reject requests with incorrect TRES specification.
 -- sacctmgr - reject requests with incorrect TRES specification.
 -- Correct issue where conversion to/from JSON/YAML may have resulted in empty
    strings being replaced with strings containing "null" instead.
 -- Attempt to requeue jobs terminated by slurm.conf changes (node vanish, node
    socket/core change, etc). Processes may still be running on excised nodes.
    Admin should take precautions when removing nodes that have jobs on running
    on them.
 -- Fix race with task/cgroup memory and jobacctgather/cgroup, the first was
    removing the pid from the task_X cgroup directory.
 -- openapi/dbv0.0.38 - set default account org and desc to be account name.
 -- openapi/dbv0.0.38 - Allow strings for JobId instead of only numerical JobId
    for GET job methods.
 -- Add switch/hpe_slingshot plugin.
 -- cloud_reg_addrs - use hostname from slurmd rather than from munge
    credential for NodeHostName.
 -- Store assoc usage in parent assoc when deleted to preserve account
    fairshare.
 -- CVE-2022-29500 - Prevent credential abuse.
 -- CVE-2022-29501 - Prevent abuse of REQUEST_FORWARD_DATA.
 -- CVE-2022-29502 - Correctly validate io keys.
 -- openapi/dbv0.0.38 - set with_deleted to false by default for /user[s].
 -- openapi/dbv0.0.38 - add with_deleted input parameter to GET /user[s].
 -- openapi/dbv0.0.38 - add deleted flag to /user[s] output.
 -- openapi/dbv0.0.38 - set with_deleted to false by default for GET /qos.
 -- openapi/dbv0.0.38 - add with_deleted input to GET /qos.
 -- openapi/dbv0.0.38 - set with_deleted to false by default for GET /account[s]
 -- openapi/dbv0.0.38 - add with_deleted input to GET /account[s].
 -- Include k12 hash of the RPC message body in the auth/munge tokens to
    provide for additional communication resiliency.
 -- Allow job steps to continue to launch during OverTimeLimit.
 -- slurmctld - avoid crash when attempting to load job without a script.
 -- Fix exclusive jobs breaking MaxCPUsPerNode limit
 -- Error if ConstrainSwapSpace is set and system doesn't have the kernel with
    CONFIG_MEMCG_SWAP set. This will avoid bad configurations.
 -- Add SlurmdParameters=numa_node_as_socket.
 -- Fix incorrect node allocation when using multiple counts with --constraint
    and --ntasks-per-node.

* Changes in Slurm 21.08.9
==========================
 -- Fix cross-endian communication.
 -- Fix slurmd segfault when seeing authentication issues alongside a failed
    message forward.
 -- Fix resuming nodes not part of an allocation.
 -- Fix "--gpu-bind=single:" having wrong env variables.
 -- Fix logic estimating when a job can start based on ANY_NODES / LICENSE_ONLY
    reservations that could lead to an infinite loop in backfill.
 -- Fix a segfault that may happen on gpu configured as no_consume.
 -- Fix regression which prevented a cons_tres gpu job to be submitted to a
    cons_tres cluster from a non-con_tres cluster.
 -- select/linear - fix regression introduced in 21.08.6 which prevented step
    requests with --threads-per-core or --hint=nomultithread from being created.
 -- Fix gcc 12.2.1 compile errors.

* Changes in Slurm 21.08.8-2
============================
 -- Fix communication forwarding when running with a mix of patch and unpatched
    slurmd processes.

* Changes in Slurm 21.08.8
==========================
 -- openapi/dbv0.0.37 - fix slurmrestd fatal() when deleting an association.
 -- Allow scontrol update <job> Gres=... to not require "gres:".
 -- Fix inconsistent reboot message appending behavior.
 -- Fix incorrect reason_time and reason_uid on reboot message.
 -- Fix "scontrol reboot" clearing node reason on ResumeTimeout.
 -- Fix ResumeTimeout error message missing when node already has reason set.
 -- Avoid "running with local config" error when conf server is provided by DNS.
 -- openapi/v0.0.37 - resolve job user name when not sent by slurmctld.
 -- openapi/dbv0.0.37 - Correct OpenAPI specification for diag request.
 -- Ignore power_down request when node is already powering down.
 -- CVE-2022-29500 - Prevent credential abuse.
 -- CVE-2022-29501 - Prevent abuse of REQUEST_FORWARD_DATA.
 -- CVE-2022-29502 - Correctly validate io keys.

* Changes in Slurm 21.08.7
==========================
 -- openapi/v0.0.37 - correct calculation for bf_queue_len_mean in /diag.
 -- Optimize sending down nodes in maintenance mode to the database when
    removing reservations.
 -- Avoid shrinking a reservation when overlapping with downed nodes.
 -- Fix 'planned time' in rollups for jobs that were still pending when the
    rollup happened.
 -- Prevent new elements from a job array from causing rerollups.
 -- Only check TRES limits against current usage for TRES requested by the job.
 -- Do not allocate shared gres (MPS) in whole-node allocations
 -- Fix minor memory leak when dealing with configless setups.
 -- Constrain slurmstepd to job/step cgroup like in previous versions of Slurm.
 -- Fix warnings on 32-bit compilers related to printf() formats.
 -- Fix memory leak when freeing kill_job_msg_t.
 -- Fix memory leak when using data_t.
 -- Fix reconfigure issues after disabling/reenabling the GANG PreemptMode.
 -- Fix race condition where a cgroup was being deleted while another step
    was creating it.
 -- Set the slurmd port correctly if multi-slurmd
 -- openapi/v0.0.37 - Fix misspelling of account_gather_frequency in spec.
 -- openapi/v0.0.37 - Fix misspelling of cluster_constraint in spec.
 -- Fix FAIL mail not being sent if a job was cancelled due to preemption.
 -- slurmrestd - move debug logs for HTTP handling to be gated by debugflag
    NETWORK to avoid unnecessary logging of communication contents.
 -- Fix issue with bad memory access when shrinking running steps.
 -- Fix various issues with internal job accounting with GRES when jobs are
    shrunk.
 -- Fix ipmi polling on slurmd reconfig or restart.
 -- Fix srun crash when reserved ports are being used and het step fails
    to launch.
 -- openapi/dbv0.0.37 - fix DELETE execution path on /user/{user_name}.
 -- slurmctld - Properly requeue all components of a het job if PrologSlurmctld
    fails.
 -- rlimits - remove final calls to limit nofiles to 4096 but to instead use
    the max possible nofiles in slurmd and slurmdbd.
 -- Fix slurmctld memory leak after a reconfigure with configless.
 -- Fix slurmd memory leak when fetching configless files.
 -- Allow the DBD agent to load large messages (up to MAX_BUF_SIZE) from state.
 -- Fix minor memory leak with cleaning up the extern step.
 -- Fix potential deadlock during slurmctld restart when there is a completing
    job.
 -- slurmstepd - reduce user requested soft rlimits when they are above max
    hard rlimits to avoid rlimit request being completely ignored and
    processes using default limits.
 -- Fix memory leaks when job/step specifies a container.
 -- Fix Slurm user commands displaying available features as active features
    when no features were active.
 -- Don't power down nodes that are rebooting.
 -- Clear pending node reboot on power down request.
 -- Ignore node registrations while node is powering down.
 -- Don't reboot any node that is power<ing|ed> down.
 -- Don't allow a node to reboot if it's marked for power down.
 -- Fix issuing reboot and downing when rebooting a powering up node.
 -- Clear DRAIN on node after failing to resume before ResumeTimeout.
 -- Prevent repeating power down if node fails to resume before ResumeTimeout.
 -- Fix federated cloud node communication with srun and cloud_dns.
 -- Fix jobs being scheduled on nodes marked to be powered_down when idle.
 -- Fix problem where a privileged user could not view array tasks specified by
    <array_job_id>_<task_id> when PrivateData had the jobs value set.

* Changes in Slurm 21.08.6
==========================
 -- Handle typed shared GRES better in accounting.
 -- Fix plugin_name definitions in a number of plugins to improve logging.
 -- Close sbcast file transfers when job is cancelled.
 -- job_submit/lua - allow mail_type and mail_user fields to be modified.
 -- scrontab - fix handling of --gpus and --ntasks-per-gpu options.
 -- sched/backfill - fix job_queue_rec_t memory leak.
 -- Fix magnetic reservation logic in both main and backfill schedulers.
 -- job_container/tmpfs - fix memory leak when using InitScript.
 -- slurmrestd / openapi - fix memory leaks.
 -- Fix slurmctld segfault due to job array resv_list double free.
 -- Fix multi-reservation job testing logic.
 -- Fix slurmctld segfault due to insufficient job reservation parse validation.
 -- Fix main and backfill schedulers handling for already rejected job array.
 -- sched/backfill - restore resv_ptr after yielding locks.
 -- acct_gather_energy/xcc - appropriately close and destroy the IPMI context.
 -- Protect slurmstepd from making multiple calls to the cleanup logic.
 -- Prevent slurmstepd segfault at cleanup time in mpi_fini().
 -- Fix slurmctld sometimes hanging if shutdown while PrologSlurmctld or
    EpilogSlurmctld were running and PrologEpilogTimeout is set in slurm.conf.
 -- Fix affinity of the batch step if batch host is different than the first
    node in the allocation.
 -- slurmdbd - fix segfault after multiple failover/failback operations.
 -- Fix jobcomp filetxt job selection condition.
 -- Fix -f flag of sacct not being used.
 -- Select cores for job steps according to the socket distribution. Previously,
    sockets were always filled before selecting cores from the next socket.
 -- Keep node in Future state if epilog completes while in Future state.
 -- Fix erroneous --constraint behavior by preventing multiple sets of brackets.
 -- Make ResetAccrueTime update the job's accrue_time to now.
 -- Fix sattach initialization with configless mode.
 -- Revert packing limit checks affecting pmi2.
 -- sacct - fixed assertion failure when using -c option and a federation
    display
 -- Fix issue that allowed steps to overallocate the job's memory.
 -- Fix the sanity check mode of AutoDetect so that it actually works.
 -- Fix deallocated nodes that didn't actually launch a job from waiting for
    Epilogslurmctld to complete before clearing completing node's state.
 -- Job should be in a completing state if EpilogSlurmctld when being requeued.
 -- Fix job not being requeued properly if all node epilog's completed before
    EpilogSlurmctld finished.
 -- Keep job completing until EpilogSlurmctld is completed even when "downing"
    a node.
 -- Fix handling reboot with multiple job features.
 -- Fix nodes getting powered down when creating new partitions.
 -- Fix bad bit_realloc which potentially could lead to bad memory access.
 -- slurmctld - remove limit on the number of open files.
 -- Fix bug where job_state file of size above 2GB wasn't saved without any
    error message.
 -- Fix various issues with no_consume gres.
 -- Fix regression in 21.08.0rc1 where job steps failed to launch on systems
    that reserved a CPU in a cgroup outside of Slurm (for example, on systems
    with WekaIO).
 -- Fix OverTimeLimit not being reset on scontrol reconfigure when it is
    removed from slurm.conf.
 -- serializer/yaml - use dynamic buffer to allow creation of YAML outputs
    larger than 1MiB.
 -- Fix minor memory leak affecting openapi users at process termination.
 -- Fix batch jobs not resolving the username when nss_slurm is enabled.
 -- slurmrestd - Avoid slurmrestd ignoring invalid HTTP method if the response
    serialized without error.
 -- openapi/dbv0.0.37 - Correct conditional that caused the diag output to
    give an internal server error status on success.
 -- Make --mem-bind=sort work with task_affinity
 -- Fix sacctmgr to set MaxJobsAccruePer{User|Account} and MinPrioThres in
    sacctmgr add qos, modify already worked correctly.
 -- job_container/tmpfs - avoid printing extraneous error messages in Prolog
    and Epilog, and when the job completes.
 -- Fix step CPU memory allocation with --threads-per-core without --exact.
 -- Remove implicit --exact when --threads-per-core or --hint=nomultithread
    is used.
 -- Do not allow a step to request more threads per core than the
    allocation did.
 -- Remove implicit --exact when --cpus-per-task is used.

* Changes in Slurm 21.08.5
==========================
 -- Fix issue where typeless GRES node updates were not immediately reflected.
 -- Fix setting the default scrontab job working directory so that it's the home
    of the different user (-u <user>) and not that of root or SlurmUser editor.
 -- Fix stepd not respecting SlurmdSyslogDebug.
 -- Fix concurrency issue with squeue.
 -- Fix job start time not being reset after launch when job is packed onto
    already booting node.
 -- Fix updating SLURM_NODE_ALIASES for jobs packed onto powering up nodes.
 -- Cray - Fix issues with starting hetjobs.
 -- auth/jwks - Print fatal() message when jwks is configured but file could
    not be opened.
 -- If sacctmgr has an association with an unknown qos as the default qos
    print 'UNKN-###' instead of leaving a blank name.
 -- Correctly determine task count when giving --cpus-per-gpu, --gpus and
    --ntasks-per-node without task count.
 -- slurmctld - Fix places where the global last_job_update was not being set
    to the time of update when a job's reason and description were updated.
 -- slurmctld - Fix case where a job submitted with more than one partition
    would not have its reason updated while waiting to start.
 -- Fix memory leak in node feature rebooting.
 -- Fix time limit permanetly set to 1 minute by backfill for job array tasks
    higher than the first with QOS NoReserve flag and PreemptMode configured.
 -- Fix sacct -N to show jobs that started in the current second
 -- Fix issue on running steps where both SLURM_NTASKS_PER_TRES and
    SLURM_NTASKS_PER_GPU are set.
 -- Handle oversubscription request correctly when also requesting
    --ntasks-per-tres.
 -- Correctly detect when a step requests bad gres inside an allocation.
 -- slurmstepd - Correct possible deadlock when UnkillableStepTimeout triggers.
 -- srun - use maximum number of open files while handling job I/O.
 -- Fix writing to Xauthority files on root_squash NFS exports, which was
    preventing X11 forwarding from completing setup.
 -- Fix regression in 21.08.0rc1 that broke --gres=none.
 -- Fix srun --cpus-per-task and --threads-per-core not implicitly setting
    --exact. It was meant to work this way in 21.08.
 -- Fix regression in 21.08.0 that broke dynamic future nodes.
 -- Fix dynamic future nodes remembering active state on restart.
 -- Fix powered down nodes getting stuck in COMPLETING+POWERED_DOWN when job is
    cancelled before nodes are powering up.

* Changes in Slurm 21.08.4
==========================
 -- Fix potential deadlock when using PMI v1.
 -- Fix tight loop sending DBD_SEND_MULT_JOB_START when the slurmctld has an
    issue talking correctly to the DBD.
 -- Fix memory leak in step creation.
 -- Fix potential deadlock when shutting down slurmctld.
 -- Fix regression in 21.08 where multi-node steps that requested MemPerCPU
    were not counted against the job's memory allocation on some nodes.
 -- Fix issue with select/cons_tres and the partition limit MaxCpusPerNode where
    the limit was enforced for one less CPU than the configured value.
 -- jobacct_gather/common - compare Pss to Rss after scaling Pss to Rss units.
 -- Fix SLURM_NODE_ALIASES in RPC Prolog for batch jobs.
 -- Fix regression in 21.08 where slurmd and slurmstepd were not constrained
    with CpuSpecList or CoreSpecCount.
 -- Fix cloud jobs running without powering up nodes after a reconfig/restart.
 -- CVE-2021-43337 - Fix security issue with new AccountingStoreFlags=job_script
    and job_env options where users could request scripts and environments they
    should not have been permitted to access.

* Changes in Slurm 21.08.3
==========================
 -- Return error to sacctmgr when running 'sacctmgr archive load' and the load
    fails due to an invalid or corrupted file.
 -- slurmctld/gres_ctld - fix deallocation of typed GRES without device.
 -- scrontab - fix capturing the cronspec request in the job script.
 -- openapi/dbv0.0.37 - Add missing method POST for /associations/.
 -- If ALTER TABLE was already run, continue with database upgrade.
 -- slurmstepd - Gracefully handle RunTimeQuery returning no output.
 -- srun - automatically handle issues with races to listen() on an ephemeral
    socket, and suppress otherwise needless error messages.
 -- Schedule sooner after Epilog completion with SchedulerParameters=defer.
 -- Improve performance for AccountingStoreFlags=job_env.
 -- Expose missing SLURMD_NODENAME and SLURM_NODEID to TaskEpilog environment.
 -- Bring slurm_completion.sh up to date with changes to commands.
 -- Fix issue where burst buffer stage-in could only start for one job in a job
    array per scheduling cycle instead of bb_array_stage_cnt jobs per scheduling
    cycle.
 -- Fix checking if the dependency is the same job for array jobs.
 -- Fix checking for circular dependencies with job arrays.
 -- Restore dependent job pointers on slurmctld startup to avoid race.
 -- openapi/v0.0.37 - Allow strings for JobIds instead of only numerical JobIds
    for GET, DELETE, and POST job methods.
 -- openapi/dbv0.0.36 - Gracefully handle missing associations.
 -- openapi/dbv0.0.36 - Avoid restricting job association lookups to only
    default associations.
 -- openapi/dbv0.0.37 - Gracefully handle missing associations.
 -- openapi/dbv0.0.37 - Avoid restricting job association lookups to only
    default associations.
 -- Fix error in GPU frequency validation logic.
 -- Fix regression in 21.08.1 that broke federated jobs.
 -- Correctly handle requested GRES when used in job arrays.
 -- Fix error in pmix logic dealing with the incorrect size of buffer.
 -- Fix handling of no_consume GRES, add it to allocated job allocated TRES.
 -- Fix issue with typed GRES without Files= (bitmap).
 -- Fix job_submit/lua support for 'gres' which is now stored as a 'tres'
    when requesting jobs so needs a 'gres' prefix.
 -- Fix regression where MPS would not deallocate from the node properly.
 -- Fix --gpu-bind=verbose to work correctly.
 -- Do not deny --constraint with special operators "[]()|*" when no changeable
    features are requested, but continue to deny --constraint with special
    operators when changeable features are requested.
 -- openapi/v0.0.{35,36,37} - prevent merging the slurmrestd environment
    alongside a new job submission.
 -- openapi/dbv0.0.36 - Correct tree position of dbv0.0.36_job_step.
 -- openapi/dbv0.0.37 - Correct tree position of dbv0.0.37_job_step.
 -- openapi/v0.0.37 - enable job priority field for job submissions and updates.
 -- openapi/v0.0.37 - request node states query includes MIXED state instead of
    only allocated.
 -- mpi/pmix - avoid job hanging until the time limit on PMIx agent failures.
 -- Correct inverted logic where reduced version matching applied to non-SPANK
    plugins where it should have only applied to SPANK plugins.
 -- Fix issues where prologs would run in serial without PrologFlags=serial.
 -- Make sure a job coming in is initially considered for magnetic reservations.
 -- PMIx v1.1.4 and below are no longer supported.
 -- Add comment to service files about disabling logging through journald.
 -- Add SLURM_NODE_ALIASES env to RPC Prolog (PrologFlags=alloc) environment.
 -- Limit max_script_size to 512 MB.
 -- Fix shutdown of slurmdbd plugin to correctly notice when the agent thread
    finishes.
 -- slurmdbd - fix issue with larger batch script files being sent to SlurmDBD
    with AccountingStoreFlags=job_script that can lead to accounting data loss
    as the resulting RPC generated can exceed internal limits and won't be
    sent, preventing further communication with SlurmDBD.
    This issue is indicated by "error: Invalid msg_size" in your log files.
 -- Fix compile issue with --without-shared-libslurm.

* Changes in Slurm 21.08.2
==========================
 -- slurmctld - fix how the max number of cores on a node in a partition are
    calculated when the partition contains multi-socket nodes. This in turn
    corrects certain jobs node count estimations displayed client-side.
 -- job_submit/cray_aries - fix "craynetwork" GRES specification after changes
    introduced in 21.08.0rc1 that made TRES always have a type prefix.
 -- Ignore nonsensical check in the slurmd for [Pro|Epi]logSlurmctld.
 -- Fix writing to stderr/syslog when systemd runs slurmctld in the foreground.
 -- Fix locking around log level setting routines.
 -- Fix issue with updating job started with node range.
 -- Fix issue with nodes not clearing state in the database when the slurmctld
    is started with clean-start.
 -- Fix hetjob components > 1 timing out due to InactiveLimit.
 -- Fix sprio printing -nan for normalized association priority if
    PriorityWeightAssoc was not defined.
 -- Disallow FirstJobId=0.
 -- Preserve job start info in the database for a requeued job that hadn't
    registered the first time in the database yet.
 -- Only send one message on prolog failure from the slurmd.
 -- Remove support for TaskAffinity=yes in cgroup.conf.
 -- accounting_storage/mysql - fix issue where querying jobs via sacct
    --whole-hetjob=yes or slurmrestd (which automatically includes this flag)
    could in some cases return more records than expected.
 -- Fix issue for preemption of job array task that makes afterok dependency
    fail. Additionally, send emails when requeueing happens due to preemption.
 -- Fix sending requeue mail type.
 -- Properly resize a job's GRES bitmaps and counts when resizing the job.
 -- Fix node being able to transition to CLOUD state from non-cloud state.
 -- Fix regression introduced in 21.08.0rc1 which broke a step's ability to
    inherit GRES from the job when the step didn't request GRES but the job did.
 -- Fix errors in logic when picking nodes based on bracketed anded constraints.
    This also enforces the requirement to have a count when using such
    constraints.
 -- Handle job resize better in the database.
 -- Exclude currently running, resized jobs from the runaway jobs list.
 -- Make it possible to shrink a job more than once.

* Changes in Slurm 21.08.1
==========================
 -- Fix potential memory leak if a problem happens while allocating GRES for
    a job.
 -- If an overallocation of GRES happens terminate the creation of a job.
 -- AutoDetect=nvml: Fatal if no devices found in MIG mode.
 -- slurm.spec - fix querying for PMIx and UCX version.
 -- Print federation and cluster sacctmgr error messages to stderr.
 -- Fix off by one error in --gpu-bind=mask_gpu.
 -- Fix statement condition in http_parser autoconf macro.
 -- Fix statement condition in netloc autoconf macro.
 -- Add --gpu-bind=none to disable gpu binding when using --gpus-per-task.
 -- Handle the burst buffer state "alloc-revoke" which previously would not
    display in the job correctly.
 -- Fix issue in the slurmstepd SPANK prolog/epilog handler where configuration
    values were used before being initialized.
 -- Restore a step's ability to utilize all of an allocations memory if --mem=0.
 -- Fix --cpu-bind=verbose garbage taskid.
 -- Fix cgroup task affinity issues from garbage taskid info.
 -- Make gres_job_state_validate() client logging behavior as before 44466a4641.
 -- Fix steps with --hint overriding an allocation with --threads-per-core.
 -- Require requesting a GPU if --mem-per-gpu is requested.
 -- Return error early if a job is requesting --ntasks-per-gpu and no gpus or
    task count.
 -- Properly clear out pending step if unavailable to run with available
    resources.
 -- Kill all processes spawned by burst_buffer.lua including decendents.
 -- openapi/v0.0.{35,36,37} - Avoid setting default values of min_cpus,
    job name, cwd, mail_type, and contiguous on job update.
 -- openapi/v0.0.{35,36,37} - Clear user hold on job update if hold=false.
 -- Prevent CRON_JOB flag from being cleared when loading job state.
 -- sacctmgr - Fix deleting WCKeys when not specifying a cluster.
 -- Fix getting memory for a step when the first node in the step isn't the
    first node in the allocation.
 -- Make SelectTypeParameters=CR_Core_Memory default for cons_tres and cons_res.
 -- Correctly handle mutex unlocks in the gres code if failures happen.
 -- Give better error message if -m plane is given with no size.
 -- Fix --distribution=arbitrary for salloc.
 -- Fix jobcomp/script regression introduced in 21.08.0rc1 0c75b9ac9d.
 -- Only send the batch node in the step_hostlist in the job credential.
 -- When setting affinity for the batch step don't assume the batch host is node
    0.
 -- In task/affinity better checking for node existence when laying out
    affinity.
 -- slurmrestd - fix job submission with auth/jwt.
 -- Fix 'scontrol setdebug' not respecting slurm.conf logging configurations.

* Changes in Slurm 21.08.0
==========================
 -- Restored --gpu-bind=single:<ntasks> to check core affinity like
    --gpu-bind=closest does. This removal of this behavior only was in rc2.
 -- slurmd - Fix assert failure on initialization due to bad node name.
 -- Fix error codes in cgroup/v1.
 -- Don't destroy the memory step outside fini, which leads to a double destroy
    causing an error message.
 -- Add support for lua 5.4.
 -- Force cgroup.clone_children to 0 in slurm cgroup directories. This caused
    issues in task cpuset plugin in systems with it enabled by default.
 -- Clear GRES HAS_TYPE flag when removing type name.
 -- Environment flags in gres.conf now override flags set by AutoDetect.
 -- Environment flags in gres.conf now apply to subsequent gres.conf lines where
    Environment flags are not set.
 -- Set missing job_uid and job_gid members when preparing a kill_job_msg_t in
    abort_job_on_node(), abort_job_on_nodes() and kill_job_on_node().
 -- Fix swappiness not being set in cgroups.
 -- Fix coordinators for new subaccounts.
 -- Fix coordinators when adding existing users with PrivateData=users.
 -- slurmctld - do not attempt to relinquish control to self.
 -- openapi/v0.0.37 - Honor kill_on_invalid_dependency as job parameter.
 -- Check max_gres when doing step allocation, fix for regression in rc2.
 -- SPANK plugins are now required to match the current Slurm version, and must
    be recompiled for each new Slurm release.
 -- node_features/helpers - add ExecTime configuration option.
 -- srun - Fix force termination with -X.
 -- On slurmctld restart set node typed GRES counts correctly.
 -- Fix places where a step wasn't allocated in the slurmctld but wasn't ever
    removed from the job.
 -- Fix step allocation memory when using --threads-per-core.
 -- Fix step allocations to consume all threads on a core when using
    threads-per-core.
 -- Add check to validate cpu request on a step if --threads-per-core is given
    and it is less than what the core on the node has in the allocation.
 -- Fix issue where a step could request more gres than the job had and the step
    would hang forever. This bug was only introduced in 21.08.0rc2.
 -- Only print \r\n for logging messages on stderr when --pty has been
    explicitly requested.
 -- Relax check on SPANK plugins to only require Slurm major + minor versions
    to match.
 -- job_container/tmpfs - delegate handling of /dev/shm to the extern step
    so new step launches will be attached correctly even after the slurmd
    process has been restarted.
 -- Limit the wait time in proctrack_g_wait() to UnkillableStepTimeout instead
    of a hardcoded value of 256 seconds, and limit the delay between tests to a
    maximum of 32 seconds.
 -- fatal() on start if using job_container/tmpfs without PrologFlags=Contian.

* Changes in Slurm 21.08.0rc2
=============================
 -- Load bf_when_last_cycle from job state only if protocol version >= 21.08.
 -- Docs - remove man3 section entirely.
 -- Enable OCI container execution support as a technical preview.
 -- Set step memory when using MemPerGPU or DefMemPerGPU. Previously a step's
    memory was not set even when it requested --mem-per-gpu and at least one
    GPU.
 -- Add cli_filter.lua support in configless mode.
 -- Remove some of the MAX macro usages with return codes.
 -- Check that the step requests at least as many gres as nodes.
 -- sacct - Add --json and --yaml arguments.
 -- squeue - Add --json and --yaml arguments.
 -- sinfo - Add --json and --yaml arguments.
 -- Make job's SLURM_JOB_GPUS print global GPU IDs instead of MIG unique_ids.
 -- Fix miscounting of GPU envs in prolog/epilog if MultipleFiles was used.
 -- Support MIGs in prolog/epilog's CUDA_VISIBLE_DEVICES & co.
 -- Add SLURM_JOB_GPUS back into Prolog; add it to Epilog.
 -- Fix issue where the original executable, not the bcast'd version, was
    executed with 'srun --bcast'.
 -- Fix memory leaks when cleaning up config_response_msg_t.
 -- sacct - print '-' header correctly for fields over 53-characters wide.
 -- openapi/dbv0.0.37 - replace "REST" with "Slurm OpenAPI" for plugin_name.
 -- openapi/v0.0.37 - replace "REST" with "Slurm OpenAPI" for plugin_name.
 -- configless - fix segfault on 'scontrol reconfigure'.
 -- Fix bad reference to step_ptr->job_ptr after step_ptr is freed.
 -- Fix bad reference to config_for_clients when shutting down slurmctld.
 -- Fix memory leak on gres_list_alloc when freeing steps.
 -- Fix memory leak on kill_job_msg_t->work_dir when freeing struct.
 -- Fix memory leak on slurmdb_step_rec_t->submit_line when freeing struct.
 -- Fix memory leak in the slurmdbd when requesting wckeys from all clusters.
 -- Use FREE_NULL_LIST instead of list_destroy.
 -- Fix bad pointer reference after bad unpack of jobacctinfo_t.
 -- If we made are running an interactive session we need to force track_steps.
 -- Disable OPOST flag when using --pty to avoid issues with Emac.
 -- Fix issue where extra bonus core was allocated in some situations.
 -- Avoid putting gres with count of 0 on a TRES req/alloc.
 -- Fix determining if a reservation is used or not.
 -- Fix memory in requested TRES when --mem-per-gpu is used.
 -- Changed ReqMem field in sacct to match memory from ReqTRES.
 -- Changed --gpu-bind=single:<ntasks> to no longer check core affinity like
    --gpu-bind=closest does. This consequently affects --ntasks-per-gpu.

* Changes in Slurm 21.08.0rc1
=============================
 -- slurmrestd - add v0.0.37 OpenAPI plugin.
 -- slurmrestd/v0.0.37 - rename standard_in -> standard_input.
 -- slurmrestd/v0.0.37 - rename standard_out -> standard_output.
 -- slurmdbd - Improve log messages of more time than possible on rollups.
 -- Changed the --format handling for negative field widths (left justified)
    to apply to the column headers as well as the printed fields.
 -- Add LimitFactor to the QOS. A float that is factored into an associations
    [Grp|Max]TRES limits.  For example, if the LimitFactor is 2, then an
    association with a GrpTRES of 30 CPUs, would be allowed to allocate 60
    CPUs when running under this QOS.
 -- slurmrestd - Pass SLURM_NO_CHANGE_IN_DATA to client as 403 (Not Modified).
 -- slurmrestd/v0.0.37 - Add update_time field to Jobs query to allow clients
    to only get jobs list based on change timestamp.
 -- Reset job eligible time when job is manually held.
 -- Add DEBUG_FLAG_JAG to improve logging related to job account gathering.
 -- Convert logging in account_gather/common to DEBUG_FLAG_JAG.
 -- Add more logging for jag_common_poll_data() when prec_extra() called.
 -- slurmrestd/v0.0.37 - add API to fetch reservation(s) info.
 -- Catch more errors in task/cgroup initalization and cleanup to avoid allowing
    jobs to start when cgroups failure to configure correctly.
 -- Fix cgroup ns detection when using containers (e.g. LXC or Docker).
 -- Reset job's next_step_id counter to 0 after being requeued.
 -- Make scontrol exit with non-zero status after failing to delete a partition
    or reservation.
 -- Make NtasksPerTRES optional in slurm_sprint_job_info().
 -- slurmrestd/v0.0.37 - Add update_time field to nodes query to allow clients
    to only get nodes list based on change timestamp.
 -- common/parse_config - catch and propagate return codes when handling a match
    on a key-value pattern. This implies error codes detected in the handlers
    are now not ignored and users of _handle_keyvalue_match() can fatal().
 -- common/hostlist - fix hostlist_delete_nth() xassert() upper bound check.
 -- API change: Removed slurm_kill_job_msg and modified the function signature
    for slurm_kill_job2. slurm_kill_job2 should be used instead of
    slurm_kill_job_msg.
 -- Fix non-zero exit code for scontrol ping when all controllers are down.
 -- Enforce a valid configuration for AccountingStorageEnforce in slurm.conf.
    If the configuration is invalid, then an error message will be printed and
    the command or daemon (including slurmctld) will not run.
 -- slurmrestd/v0.0.37 - Add update_time field to partitions/reservations query
    to allow clients to only get the entities list when something changed.
 -- slurmdbd.service - add "After" relationship to all common names for MariaDB
    to reduce startup delays.
 -- slurmrestd/v0.0.37 - Correct displaying node states that are UNKNOWN.
 -- slurmrestd/v0.0.37 - Add flags to node states.
 -- Fix first job on fresh cluster not being assigned JobId=1 (or FirstJobId).
 -- squeue - make it so --nodelist is sensitive to --clusters.
 -- squeue - do --nodelist node validation in the same order as listing.
 -- Removed AccountingStoreJobComment option.  Please update your config to use
    AccountingStoreFlags=job_comment instead.
 -- AccountingStoreFlags=job_script allows you to store the job's batch script.
 -- AccountingStoreFlags=job_env allows you to store the job's env vars.
 -- Add sacct -o SubmitLine to get the submit line of a job/step.
 -- Removed DefaultStorage{Host,Loc,Pass,Port,Type,User} options.
 -- Fix NtasksPerTRES delimiter from : to = in scontrol show job output.
 -- Removed CacheGroups, CheckpointType, JobCheckpointDir, MemLimitEnforce,
    SchedulerPort, SchedulerRootFilter options.
 -- Make job accounting queries use consistent timeframes with and w/o jobs.
 -- --cpus-per-task and --threads-per-core now imply --exact.
    This fixes issues where steps would be allocated the wrong number of CPUs.
 -- configure: the --with option handling has been made consistent across the
    various optional libraries. Specifying --with-foo=/path/to/foo will only
    check that directory for the applicable library (rather than, in some cases,
    falling back to the default directories), and will always error the build
    if the library is not found (instead of a mix of error messages and non-
    fatal warning messages).
 -- configure: replace --with-rmsi_dir option with proper handling for
    --with-rsmi=dir.
 -- Pass additional job environment variables to MailProg.
 -- Add SLURM_JOB_WORK_DIR to Prolog, Epilog.
 -- Removed sched/hold plugin.
 -- Fix srun overwriting SLURM_SUBMIT_DIR and SLURM_SUBMIT_HOST when within an
    existing allocation.
 -- step_ctx code has been removed from the api.
 -- cli_filter/lua, jobcomp/lua, job_submit/lua now load their scripts from the
    same directory as the slurm.conf file (and thus now will respect changes
    to the SLURM_CONF environment variable).
 -- SPANK - call slurm_spank_init if defined without slurm_spank_slurmd_exit in
    slurmd context.
 -- job_container/tmpfs - Remove need for .active file to allow salloc without
    an interactive step to work.
 -- Add new 'PLANNED' state to a node to represent when the backfill scheduler
    has it planned to be used in the future instead of showing as 'IDLE'.
 -- slurmd - Delay background node registration on every failure up to 128s on
    startup.
 -- slurmctld - Always notify slurmd that node registration was accepted to
    avoid slurmd needless attempting to re-register if there is configuration
    issue.
 -- Put node into "INVAL" state upon registering with an invalid node
    configuration. Node must register with a valid configuration to continue.
 -- Make --cpu-bind=threads default for --threads-per-core -- cli and env can
    override.
 -- jobcomp/elasticsearch - Use data_t to serialize data. The plugin now has the
    JSON-C library as a prerequisite.
 -- scrontab - create the temporary file under the TMPDIR environment variable
    (if set), otherwise continue to use TmpFS as configured in slurm.conf.
 -- Add LastBusyTime to "scontrol show nodes" and slurmrestd nodes output,
    which represents the time the node last had jobs on it.
 -- slurmd - allow multiple comma-separated controllers to be specified in
    configless mode with --conf-server
 -- sacctmgr - changed column headings to "ParentID" and "ParentName" instead
    of "Par ID" and "Par Name" respectively.
 -- Perl API - make sure man pages are installed under the --prefix given to
    configure.
 -- Manually powering down of nodes with scontrol now ignores
    SuspendExc<Nodes|Parts>.
 -- SALLOC_THREADS_PER_CORE and SBATCH_THREADS_PER_CORE have been added as
    input environment variables for salloc and sbatch, respectively. They do
    the same thing as --threads-per-core.
 -- Distinguish queued reboot requests (REBOOT) from issued reboots (REBOOT^).
 -- Set the maximum number of open files per process to 4096 to avoid
    performance issues when closing the entire range with closeall().
 -- auth/jwt - add support for RS256 tokens.
 -- Relax reservation purge due to any invalid uid after creation time.
 -- Reject srun that requests both --exclusive and --overlap.
 -- service files - change dependency to network-online rather than just
    network to ensure DNS and other services are available.
 -- RSMI: Fix incorrect PCI BDF bits.
 -- plugins/cli_filter - Convert to using data_t to serialize JSON.
 -- Fix testing array job after regaining locks in backfill.
 -- Don't display node's comment with "scontrol show nodes" unless set.
 -- Add "Extra" field to node to store extra information other than a comment.
 -- scrontab - Use /tmp instead of TmpFS if TMPDIR is not set.
 -- Add ResumeTimeout, SuspendTimeout and SuspendTime to Partitions.
 -- sreport - change to sorting TopUsage by the --tres option.
 -- slurmrestd - do not run allow operation as SlurmUser/root by default.
 -- Allow map_cpu and mask_cpu for non-whole node allocation.
 -- TaskPluginParam=verbose is now treated as a default. Previously it would be
    applied regardless of the job specifying a --cpu-bind.
 -- Add "node_reg_mem_percent" SlurmctldParameter to define percentage of
    memory nodes are allowed to register with.
 -- Show correct number of SocketsPerBoard in slurmd -C with hwloc2.
 -- Alter sreport's cluster utilization report column name from
    'Reserved' to 'Planned' to match the nomenclature of the 'Planned' node.
 -- Add StateComplete format option to sinfo to show base_state+flags.
 -- "scontrol show node" now shows State as base_state+flags instead of
    shortened state with flags appended. eg. IDLE# -> IDLE+POWERING_UP.
    Also "POWER" state flag string is "POWERED_DOWN".
 -- slurmd/req - add missing job_env_t's het_job_id initialization off the
    request in _rpc_{abort,terminate}_job(). This caused problems for Native
    Cray builds when joining a CNCU job_container plugin with Epilog configured.
 -- Fix joining a CNCU job_container on a Native Cray build before executing the
    UnkillableStepProgram for a HetJob step.
 -- slurmrestd/v0.0.35 - Plugin has been tagged as deprecated.
 -- srun - Job steps requiring more cores than available to be rejected unless
    '--overlap' is specificed.
 -- Add bf_node_space_size to SchedulerParameters.
 -- Add scontrol update node state=POWER_DOWN_FORCE and POWER_DOWN_ASAP as new
    ways to power off and reset especially CLOUD nodes.
 -- Define and separate node power state transitions. Previously a powering
    down node was in both states, POWERING_OFF and POWERED_OFF. These are now
    separated.
 -- Create a new process called slurmscriptd which runs PrologSlurmctld and
    EpilogSlurmctld. This avoids fork() calls from slurmctld, and can avoid
    performance issues if the slurmctld has a large memory footprint.
 -- Added new Script option to DebugFlags for debugging slurmscriptd.
 -- scrontab - add ability to update crontab from a file or standard input.
 -- scrontab - add ability to set and expand variables.
 -- Pass JSON of job to node mappings to ResumeProgram.
 -- If running steps in an allocation with CR_PACK_NODE or -mpack the srun will
    only attempt to allocate as much as needed from the allocation instead
    of always trying to allocate every node in the allocation.
 -- Jobs that request the whole node now check to see if any gres are allocated.
 -- Rename SbcastParameters to BcastParameters.
 -- Make srun sensitive to BcastParameters.
 -- RSMI: Add gres_links_create_empty() and preserve RSMI enumeration order.
 -- GPUs: Use index instead of dev_num for CUDA_VISIBLE_DEVICES
 -- Don't run epilog on nodes if job never launched.
 -- QOS accrue limits only apply to the job QOS, not partition QOS.
 -- Add --gpu-bind=per_task:<gpus_per_task> option, --gpus-per-task will now
    set this option by default.
 -- Treat any return code from SPANK plugin that is not SLURM_SUCCESS to be an
    error or rejection.
 -- Print the statistics for extern step adopted processes in sstat.
 -- Fix SLURM_NODE_ALIASES to work for ipv6 node addrs.
 -- Add support for automatically detecting and broadcasting executable shared
    object dependencies for sbcast and srun --bcast.
 -- Delay steps when memory already used instead of rejecting step request.

* Changes in Slurm 20.11.10
===========================
 -- Fix cross-endian communication.
 -- Fix slurmd segfault when seeing authentication issues alongside a failed
    message forward.

* Changes in Slurm 20.11.9
==========================
 -- burst_buffer - add missing common directory to the Makefile SUBDIRS.
 -- sacct - fix truncation when printing jobidraw field.
 -- GRES - Fix loading state of jobs using --gpus to request gpus.
 -- Fix minor logic error in health check node state output
 -- Fix GCC 11.1 compiler warnings.
 -- Delay steps when memory already used instead of rejecting step request.
 -- Fix memory leak in the slurmdbd when requesting wckeys from all clusters.
 -- Fix determining if a reservation is used or not.
 -- openapi/v0.0.35 - Honor kill_on_invalid_dependency as job parameter.
 -- openapi/v0.0.36 - Honor kill_on_invalid_dependency as job parameter.
 -- Fix various issues dealing with updates on magnetic reservations that could
    lead to abort slurmctld.
 -- openapi/v0.0.36 - Avoid setting default values of min_cpus, job name, cwd,
    mail_type, and contiguous on job update.
 -- openapi/v0.0.36 - Clear user hold on job update if hold=false.
 -- Fix slurmctld segfault due to a bit_test() call with a MAINT+ANY_NODES
    reservation NULL node_bitmap.
 -- Fix slurmctld segfault due to a bit_copy() call with a REPLACE+ANY_NODES
    reservation NULL node_bitmap.
 -- Fix error in GPU frequency validation logic.
 -- Fix error in pmix logic dealing with the incorrect size of buffer.
 -- PMIx v1.1.4 and below are no longer supported.
 -- Fix shutdown of slurmdbd plugin to correctly notice when the agent thread
    finishes.
 -- Fix slurmctld segfault due to job array --batch features double free.
 -- CVE-2022-29500 - Prevent credential abuse.
 -- CVE-2022-29501 - Prevent abuse of REQUEST_FORWARD_DATA.

* Changes in Slurm 20.11.8
==========================
 -- slurmctld - fix erroneous "StepId=CORRUPT" messages in error logs.
 -- Correct the error given when auth plugin fails to pack a credential.
 -- Fix unused-variable compiler warning on FreeBSD in fd_resolve_path().
 -- acct_gather_filesystem/lustre - only emit collection error once per step.
 -- srun - leave SLURM_DIST_UNKNOWN as default for --interactive.
 -- Add GRES environment variables (e.g., CUDA_VISIBLE_DEVICES) into the
    interactive step, the same as is done for the batch step.
 -- Fix various potential deadlocks when altering objects in the database
    dealing with every cluster in the database.
 -- slurmrestd - handle slurmdbd connection failures without segfaulting.
 -- slurmrestd - fix segfault for searches in slurmdb/v0.0.36/jobs.
 -- slurmrestd - remove (non-functioning) users query parameter for
    slurmdb/v0.0.36/jobs from openapi.json
 -- slurmrestd - fix segfault in slurmrestd db/jobs with numeric queries
 -- slurmrestd - add argv handling for job/submit endpoint.
 -- srun - fix broken node step allocation in a heterogeneous allocation.
 -- Fail step creation if -n is not multiple of --ntasks-per-gpu.
 -- job_container/tmpfs - Fix slowdown on teardown.
 -- Fix problem with SlurmctldProlog where requeued jobs would never launch.
 -- job_container/tmpfs - Fix issue when restarting slurmd where the namespace
    mount points could disappear.
 -- sacct - avoid truncating JobId at 34 characters.
 -- scancel - fix segfault when --wckey filtering option is used.
 -- select/cons_tres - Fix memory leak.
 -- Prevent file descriptor leak in job_container/tmpfs on slurmd restart.
 -- slurmrestd/dbv0.0.36 - Fix values dumped in job state/current and
    job step state.
 -- slurmrestd/dbv0.0.36 - Correct description for previous state property.
 -- perlapi/libslurmdb - expose tres_req_str to job hash.
 -- scrontab - close and reopen temporary crontab file to deal with editors
    that do not change the original file, but instead write out then rename
    a new file.
 -- sstat - fix linking so that it will work when --without-shared-libslurm
    was used to build Slurm.
 -- Clear allocated cpus for running steps in a job before handling requested
    nodes on new step.
 -- Don't reject a step if not enough nodes are available. Instead, defer the
    step until enough nodes are available to satisfy the request.
 -- Don't reject a step if it requests at least one specific node that is
    already allocated to another step. Instead, defer the step until the
    requested node(s) become available.
 -- slurmrestd - add description for slurmdb/job endpoint.
 -- Better handling of --mem=0.
 -- Ignore DefCpuPerGpu when --cpus-per-task given.
 -- sacct - fix segfault when printing StepId (or when using --long).

* Changes in Slurm 20.11.7
==========================
 -- slurmd - handle configless failures gracefully instead of hanging
    indefinitely.
 -- select/cons_tres - fix Dragonfly topology not selecting nodes in the same
    leaf switch when it should as well as requests with --switches option.
 -- Fix issue where certain step requests wouldn't run if the first node in the
    job allocation was full and there were idle resources on other nodes in
    the job allocation.
 -- Fix deadlock issue with <Prolog|Epilog>Slurmctld.
 -- torque/qstat - fix printf error message in output.
 -- When adding associations or wckeys avoid checking multiple times a user or
    cluster name.
 -- Fix wrong jobacctgather information on a step on multiple nodes
    due to timeouts sending its the information gathered on its node.
 -- Fix missing xstrdup which could result in slurmctld segfault on array jobs.
 -- Fix security issue in PrologSlurmctld and EpilogSlurmctld by always
    prepending SPANK_ to all user-set environment variables. CVE-2021-31215.

* Changes in Slurm 20.11.6
==========================
 -- Fix sacct assert with the --qos option.
 -- Use pkg-config --atleast-version instead of --modversion for systemd.
 -- common/fd - fix getsockopt() call in fd_get_socket_error().
 -- Properly handle the return from fd_get_socket_error() in _conn_readable().
 -- cons_res - Fix issue where running jobs were not taken into consideration
    when creating a reservation.
 -- Avoid a deadlock between job_list for_each and assoc QOS_LOCK.
 -- Fix TRESRunMins usage for partition qos on restart/reconfig.
 -- Fix printing of number of tasks on a completed job that didn't request
    tasks.
 -- Fix updating GrpTRESRunMins when decrementing job time is bigger than it.
 -- Make it so we handle multithreaded allocations correctly when doing
    --exclusive or --core-spec allocations.
 -- Fix incorrect round-up division in _pick_step_cores
 -- Use appropriate math to adjust cpu counts when --ntasks-per-core=1.
 -- cons_tres - Fix consideration of power downed nodes.
 -- cons_tres - Fix DefCpuPerGPU, increase cpus-per-task to match with
    gpus-per-task * cpus-per-gpu.
 -- Fix under-cpu memory auto-adjustment when MaxMemPerCPU is set.
 -- Make it possible to override CR_CORE_DEFAULT_DIST_BLOCK.
 -- Perl API - fix retrieving/storing of slurm_step_id_t in job_step_info_t.
 -- Recover state of burst buffers when slurmctld is restarted to avoid skipping
    burst buffer stages.
 -- Fix race condition in burst buffer plugin which caused a burst buffer
    in stage-in to not get state saved if slurmctld stopped.
 -- auth/jwt - print an error if jwt_file= has not been set in slurmdbd.
 -- Fix RESV_DEL_HOLD not being a valid state when using squeue --states.
 -- Add missing squeue selectable states in valid states error message.
 -- Fix scheduling last array task multiple times on error, causing segfault.
 -- Fix issue where a step could be allocated more memory than the job when
    dealing with --mem-per-cpu and --threads-per-core.
 -- Fix removing qos from assoc with -= can lead to assoc with no qos
 -- auth/jwt - fix segfault on invalid credential in slurmdbd due to
    missing validate_slurm_user() function in context.
 -- Fix single Port= not being applied to range of nodes in slurm.conf
 -- Fix Jobs not requesting a tres are not starting because of that tres limit.
 -- acct_gather_energy/rapl - fix AveWatts calculation.
 -- job_container/tmpfs - Fix issues with cleanup and slurmd restarting on
    running jobs.

* Changes in Slurm 20.11.5
==========================
 -- Fix main scheduler bug where bf_hetjob_prio truncates SchedulerParameters.
 -- Fix sacct not displaying UserCPU, SystemCPU and TotalCPU for large times.
 -- scrontab - fix to return the correct index for a bad #SCRON option.
 -- scrontab - fix memory leak when invalid option found in #SCRON line.
 -- Add errno for when a user requests multiple partitions and they are using
    partition based associations.
 -- Fix issue where a job could run in a wrong partition when using
    EnforcePartLimits=any and partition based associations.
 -- Remove possible deadlock when adding associations/wckeys in multiple
    threads.
 -- When using PrologFlags=alloc make sure the correct Slurm version is set
    in the credential.
 -- When sending a job a warning signal make sure we always send SIGCONT
    beforehand.
 -- Fix issue where a batch job would continue running if a prolog failed on a
    node that wasn't the batch host and requeuing was disabled.
 -- Fix issue where sometimes salloc/srun wouldn't get a message about a prolog
    failure in the job's stdout.
 -- Requeue or kill job on a prolog failure when PrologFlags is not set.
 -- Fix race condition causing node reboots to get requeued before
    ResumeTimeout expires.
 -- Preserve node boot_req_time on reconfigure.
 -- Preserve node power_save_req_time on reconfigure.
 -- Fix node reboots being queued and issued multiple times and preventing the
    reboot to time out.
 -- Fix debug message related to GrpTRESRunMin (AssocGrpCPURunMinutesLimit).
 -- Fix run_command to exit correctly if track_script kills the calling thread.
 -- Only requeue a job when the PrologSlurmctld returns nonzero.
 -- When a job is signaled with SIGKILL make sure we flush all
    prologs/setup scripts.
 -- Handle burst buffer scripts if the job is canceled while stage_in is
    happening.
 -- When shutting down the slurmctld make note to ignore error message when
    we have to kill a prolog/setup script we are tracking.
 -- scrontab - add support for the --open-mode option.
 -- acct_gather_profile/influxdb - avoid segfault on plugin shutdown if setup
    has not completed successfully.
 -- Reduce delay in starting salloc allocations when running with prologs.
 -- Fix issue passing open fd's with [send|recv]msg.
 -- Alter AllocNodes check to work if the allocating node's domain doesn't
    match the slurmctld's. This restores the pre-20.11 behavior.
 -- Fix slurmctld segfault if jobs from a prior version had the now-removed
    INVALID_DEPEND state flag set and were allowed to run in 20.11.
 -- Add job_container/tmpfs plugin to give a method to provide a private /tmp
    per job.
 -- Set the correct core affinity when using AutoDetect.
 -- Start relying on the conf again in xcpuinfo_mac_to_abs().
 -- Fix global_last_rollup assignment on job resizing.
 -- slurmrestd - hand over connection context on _on_message_complete().
 -- slurmrestd - mark "environment" as required for job submissions in schema.
 -- slurmrestd - Disable credential reuse on the same TCP connection. Pipelined
    HTTP connections will have to provide authentication with every request.
 -- Avoid data conversion error on NULL strings in data_get_string_converted().
 -- Handle situation where slurmctld is too slow processing
    REQUEST_COMPLETE_BATCH_SCRIPT and it gets resent from the slurmstepd.
 -- Fix sacct crashing with the --qos option

* Changes in Slurm 20.11.4
==========================
 -- Fix node selection for advanced reservations with features.
 -- mpi/pmix: Handle pipe failure better when using ucx.
 -- mpi/pmix: include PMIX_NODEID for each process entry.
 -- Fix job getting rejected after being requeued on same node that died.
 -- job_submit/lua - add "network" field.
 -- Fix situations when a reoccuring reservation could erroneously skip a
    period.
 -- Ensure that a reservations [pro|epi]log are ran on reoccuring reservations.
 -- Fix threads-per-core memory allocation issue when using CR_CPU_MEMORY.
 -- Fix scheduling issue with --gpus.
 -- Fix gpu allocations that request --cpus-per-task.
 -- mpi/pmix: fixed print messages for all PMIXP_* macros
 -- Add mapping for XCPU to --signal option.
 -- Fix regression in 20.11 that prevented a full pass of the main scheduler
    from ever executing.
 -- Work around a glibc bug in which "0" is incorrectly printed as "nan"
    which will result in corrupted association state on restart.
 -- Fix regression in 20.11 which made slurmd incorrectly attempt to find the
    parent slurmd address when not applicable and send incorrect reverse-tree
    info to the slurmstepd.
 -- Fix cgroup ns detection when using containers (e.g. LXC or Docker).
 -- scrontab - change temporary file handling to work with emacs.

* Changes in Slurm 20.11.3
==========================
 -- Fix segfault when parsing bad "#SBATCH hetjob" directive.
 -- Allow countless gpu:<type> node GRES specifications in slurm.conf.
 -- PMIx - Don't set UCX_MEM_MMAP_RELOC for older version of UCX (pre 1.5).
 -- Don't green-light any GPU validation when core conversion fails.
 -- Allow updates to a reservation in the database that starts in the future.
 -- Better check/handling of primary key collision in reservation table.
 -- Improve reported error and logging in _build_node_list().
 -- Fix uninitialized variable in _rpc_file_bcast() which could lead to an
    incorrect error return from sbcast / srun --bcast.
 -- mpi/cray_shasta - fix use-after-free on error in _multi_prog_parse().
 -- Cray - Handle setting correct prefix for cpuset cgroup with respects to
    expected_usage_in_bytes.  This fixes Cray's OOM killer.
 -- mpi/pmix: Fix PMIx_Abort support.
 -- Don't reject jobs allocating more cores than tasks with MaxMemPerCPU.
 -- Fix false error message complaining about oversubscribe in cons_tres.
 -- scrontab - fix parsing of empty lines.
 -- Fix regression causing spank_process_option errors to be ignored.
 -- Avoid making multiple interactive steps.
 -- Fix corner case issues where step creation should fail.
 -- Fix job rejection when --gres is less than --gpus.
 -- Fix regression causing spank prolog/epilog not to be called unless the
    spank plugin was loaded in slurmd context.
 -- Fix regression preventing SLURM_HINT=nomultithread from being used
    to set defaults for salloc->srun, sbatch->srun sequence.
 -- Reject job credential if non-superuser sets the LAUNCH_NO_ALLOC flag.
 -- Make it so srun --no-allocate works again.
 -- jobacct_gather/linux - Don't count memory on tasks that have already
    finished.
 -- Fix 19.05/20.02 batch steps talking with a 20.11 slurmctld.
 -- jobacct_gather/common - Do not process jobacct's with same taskid when
    calling prec_extra.
 -- Cleanup all tracked jobacct tasks when extern step child process finishes.
 -- slurmrestd/dbv0.0.36 - Correct structure of dbv0.0.36_tres_list.
 -- Fix regression causing task/affinity and task/cgroup to be out of sync when
    configured ThreadsPerCore is different than the physical threads per core.
 -- Fix situation when --gpus is given but not max nodes (-N1-1) in a job
    allocation.
 -- Interactive step - ignore cpu bind and mem bind options, and do not set
    the associated environment variables which lead to unexpected behavior
    from srun commands launched within the interactive step.
 -- Handle exit code from pipe when using UCX with PMIx.
 -- Partially revert changes made in 20.11.0 to srun step behavior. This change
    required steps to explicitly request resources, otherwise the minimal set
    of resources required would be assigned. This broke OpenMPI's 'mpiexec'
    alongside other use cases. This reverts the behavior such that all resources
    on a node are assigned to the job step by default.
 -- srun - add a new --exact option, and deprecate the --whole option (which has
    been restored as the default behavior).

* Changes in Slurm 20.11.2
==========================
 -- Fix older versions of sacct not working with 20.11.
 -- Fix slurmctld crash when using a pre-20.11 srun in a job allocation.
 -- Correct logic problem in _validate_user_access.
 -- Fix libpmi to initialize Slurm configuration correctly.

* Changes in Slurm 20.11.1
==========================
 -- Fix spelling of "overcomited" to "overcomitted" in sreport's cluster
    utilization report.
 -- Silence debug message about shutting down backup controllers if none are
    configured.
 -- Don't create interactive srun until PrologSlurmctld is done.
 -- Fix fd symlink path resolution.
 -- Fix slurmctld segfault on subnode reservation restore after node
    configuration change.
 -- Fix resource allocation response message environment allocation size.
 -- Ensure that details->env_sup is NULL terminated.
 -- select/cray_aries - Correctly remove jobs/steps from blades using NPC.
 -- cons_tres - Avoid max_node_gres when entire node is allocated with
    --ntasks-per-gpu.
 -- Allow NULL arg to data_get_type().
 -- In sreport have usage for a reservation contain all jobs that ran in the
    reservation instead of just the ones that ran in the time specified. This
    matches the report for the reservation is not truncated for a time period.
 -- Fix issue with sending wrong batch step id to a < 20.11 slurmd.
 -- Add a job's alloc_node to lua for job modification and completion.
 -- Fix regression getting a slurmdbd connection through the perl API.
 -- Stop the extern step terminate monitor right after proctrack_g_wait().
 -- Fix removing the normalized priority of assocs.
 -- slurmrestd/v0.0.36 - Use correct name for partition field:
    "min nodes per job" -> "min_nodes_per_job".
 -- slurmrestd/v0.0.36 - Add node comment field.
 -- Fix regression marking cloud nodes as "unexpectedly rebooted" after
    multiple boots.
 -- Fix slurmctld segfault in _slurm_rpc_job_step_create().
 -- slurmrestd/v0.0.36 - Filter node states against NODE_STATE_BASE to avoid
    the extended states all being reported as "invalid".
 -- Fix race that can prevent the prolog for a requeued job from running.
 -- cli_filter - add "type" to readily distinguish between the CLI command in
    use.
 -- smail - reduce sleep before seff to 5 seconds.
 -- Ensure SPANK prolog and epilog run without an explicit PlugStackConfig.
 -- Disable MySQL automatic reconnection.
 -- Fix allowing "b" after memory unit suffixes.
 -- Fix slurmctld segfault with reservations without licenses.
 -- Due to internal restructuring ahead of the 20.11 release, applications
    calling libslurm MUST call slurm_init(NULL) before any API calls.
    Otherwise the API call is likely to fail due to libslurm's internal
    configuration not being available.
 -- slurm.spec - allow custom paths for PMIx and UCX install locations.
 -- Use rpath if enabled when testing for Mellanox's UCX libraries.
 -- slurmrestd/dbv0.0.36 - Change user query for associations to optional.
 -- slurmrestd/dbv0.0.36 - Change account query for associations to optional.
 -- mpi/pmix - change the error handler error message to be more useful.
 -- Add missing connection in acct_storage_p_{clear_stats, reconfig, shutdown}.
 -- Perl API - fix issue when running in configless mode.
 -- nss_slurm - avoid deadlock when stray sockets are found.
 -- Display correct value for ScronParameters in 'scontrol show config'.

* Changes in Slurm 20.11.0
==========================
 -- x11 forwarding: fix race on setup that prevented X11 forwarding from
    working within the new Interactive Step.
 -- Fix various Coverity issues.
 -- cons_tres - Fix DefCpuPerGPU
 -- Make it so you can have a job with multiple partitions and multiple
    reservations.
 -- Fix primary controller assert when shutting down backup controllers.
 -- Enforce invalid argument combinations with --ntasks-per-gpu
 -- slurmrestd/auth_local - Verify username on slurm_rest_auth_p_apply()
 -- Fix requeue of job on node failure.
 -- Prevent a job from requesting too much memory if it
    requests MEM_PER_CPUS and --threads-per-core < the number of threads
    on a core.
 -- slurmrestd - Avoid sending close header after body in
    _operations_router_reject().
 -- slurmrestd - Set new job environment for SLURM_JOB_NAME, SLURM_OPEN_MODE,
    SLURM_JOB_DEPENDENCY, SLURM_PROFILE, SLURM_ACCTG_FREQ, SLURM_NETWORK and
    SLURM_CPU_FREQ_REQ to match sbatch.
 -- slurmrestd - Avoid defaulting open_mode to append for job submission.
 -- Fix "scontrol takeover [backup]" hangs when specifying a backup > 1.
 -- salloc now waits for PrologSlurmctld to finish before entering the shell.

* Changes in Slurm 20.11.0rc2
==============================
 -- MySQL - Remove potential race condition when sending updates to a cluster
    and commit_delay used.
 -- Fixed regression in rc1 where sinfo et al would not show a node in a resv
    state.
 -- select/linear will now allocate up to nodes RealMemory when configured with
    SelectTypeParameters=CR_Memory and --mem=0 specified. Previous behavior was
    no memory accouted and no memory limits implied to job.
 -- Remove unneeded lock check from running the slurmctld prolog for a job.
 -- Fix duplicate key error on clean starts after slurmctld is killed.
 -- Avoid double free of step_record_t in the slurmctld when node is removed
    from config.
 -- Zero out step_record_t's magic when freed.
 -- Fix sacctmgr clearing QosLevel when trailing comma is used.
 -- slurmrestd - fix a fatal() error when connecting over IPv6.
 -- slurmrestd - add API to interface with slurmdbd.
 -- mpi/cray_shasta - fix PMI port parsing for non-contiguous port ranges.
 -- squeue and sinfo -O no longer repeat the last suffix specified.
 -- cons_tres - fix regression regarding gpus with --cpus-per-task.
 -- Avoid non-async-signal-safe functions calls in X11 fowarding which can
    lead to the extern step terminating unexpectedly.
 -- Don't send job completion email for revoked federation jobs.
 -- Fix device or resource busy errors on cgroup cleanup on older kernels.
 -- Avoid binding to IPv6 wildcard address in slurmd if IPv6 is not explicitly
    enabled.
 -- Make ntasks_per_gres work with cpus_per_task.
 -- Various alterations in reference to ntasks_per_tres.
 -- slurmrestd - multiple changes to make Slurm's OpenAPI spec compatible with
    https://openapi-generator.tech/.
 -- nss_slurm - avoid loading slurm.conf to avoid issues on configless systems,
    or systems with config files loaded on shared storage.
 -- scrontab - add cli_filter hooks.
 -- job_submit/lua - expose a "cron_job" flag to identify jobs submitted
    through scrontab.
 -- PMIx - fix potential buffer overflows from use of unpackmem().
    CVE-2020-27745.
 -- X11 forwarding - fix potential leak of the magic cookie when sent as an
    argument to the xauth command. CVE-2020-27746.

* Changes in Slurm 20.11.0rc1
==============================
 -- Fix corner case issue with interrupted resource allocation requests.
 -- Pack all gres information in the slurmd to send to the stepd to help
    reduce calls in the stepd to read gres.conf.
 -- The example systemd unit files have been changed to the "simple" type of
    operation, and the daemon will now run in the foreground within systemd
    instead of daemonizing itself.
 -- Add --gpu-bind=mask_gpu reusability functionality if tasks > elements.
 -- Add separate unversion libslurm_pmi.so library to use with libpmi.so.
 -- Configurations including CR_Socket and AllowSpecResourcesUsage=NO will now
    fatal if there are no allocatable sockets due to core specialization.
 -- Make sacct get UID from database instead of from the username and a
    system call. Add --use-local-uid option to sacct to use old behavior.
 -- Limit number of jobs updated by as_mysql_flush_jobs_on_cluster() to avoid
    boot loop failures in slurmdbd.
 -- Add Autodetect option to NodeName line in gres.conf to override the global
    Autodetect option.
 -- Add NetworkRaw debugflag.
 -- Make REQUEST_LAUNCH_PROLOG handler fail if PrologFlags includes Contain and
    the credential has already expired when setting the memory limits.
 -- Reject jobs that request more nodes than provided in job credential if
    PrologFlags includes Contain.
 -- Slurmdbd is now set to fatal if slurmdbd.conf file isn't owned by SlurmUser
    or it's mode is not set to 0600.
 -- libsrun/opt - use slurm_option_reset() when ignoring ntasks_per_node.
 -- Removed "regression" script from testsuite. Please use regression.py.
 -- Avoid communication issues if TreeWidth greatly exceeds the node count
    for a job.
 -- accounting_storage/filetxt has been removed as an option.
 -- Update and validate reservations after loading from state save.
 -- Update and validate reservations after setting node to down, drain or
    updating node state.
 -- Change reservation selection order to attempt to reserve unreserved nodes
    first, followed by reserved nodes under OVERLAP|MAINT reservations, and
    finally all nodes in the partition for MAINT reservations.
 -- Add [Accounting]StorageParameters slurm[dbd].conf parameter.
 -- Improve detection and logging of incompatible options involving the
    REPLACE[_DOWN] flags when creating/updating reservations.
 -- Export SLURMD_NODENAME envvar to HealthCheckProgram.
 -- SlurmctldParameters=user_resv_delete which allows any user able to run
    in a reservation to delete it.
 -- Set default unit when parsing #BSUB -M to KB to match LSF documentation.
 -- slurmrestd - fatal() when accept() returns an unexpected result.
 -- slurmrestd - Parse multiple OpenAPI specifications for path resolution.
 -- slurmrestd - Add v0.0.36 OpenAPI plugin.
 -- slurmrestd/v0.0.36 - Add error schema.
 -- slurmrestd/v0.0.36 - return array of nodes instead of dictionary.
 -- slurmrestd/v0.0.36 - return array of partitions instead of dictionary
 -- slurmrestd/v0.0.36 - return -1 (integer) instead of INFINITE (as a string)
 -- slurmrestd/v0.0.36 - return array of pings instead of dictionary
 -- slurmrestd/v0.0.36 - Simplify possible signals for canceling jobs.
 -- slurmrestd/v0.0.36 - Simplify exclusive for jobs submissions.
 -- slurmrestd/v0.0.36 - Simplify nodes for jobs submissions.
 -- slurmrestd/v0.0.36 - Use "/slurm/v0.0.36/" as server instead of "/" to
    simply naming for clients.
 -- Add 'scontrol update res=name skip' to skip the current/next reoccurring
    reservation.
 -- Add ability for reservations to be accessed by Linux Groups.
 -- Let users submit to multiple reservations as they can partitions.
 -- Report a wider range of error codes for sbcast when opening a file.
 -- Rename acct_gather_energy/cray_aries to acct_gather_energy/pm_counters.
 -- Removed gres_alloc and gres_req from job_record_t.Tres should be used
    instead.
 -- The JobCompLoc URL endpoint when the JobCompType=jobcomp/elasticsearch
    plugin is enabled is now fully configurable and the plugin no longer appends
    a hardcoded "/slurm/jobcomp" index and type suffix to it.
 -- Add check to the reservation create/update logic to prevent an inconsistent
    state without nodes and with no ANY_NODES flag with either Licenses,
    BurstBuffer and/or Watts.
 -- slurmrestd - allow the host to be optional when specifying the address to
    listen on.
 -- slurmrestd - Log numerical service name when referencing host port pairs.
 -- slurmrestd - Log host port information in RFC3986 format.
 -- sview - Remove (long-broken) batch job submission option.
 -- Dynamic Future Nodes - slurmds started with -F[<feature>] will be
    associated with a nodename in Slurm that matches the same hardware
    configuration.
 -- SlurmctldParameters=cloud_reg_addrs - Cloud nodes automatically get
    NodeAddr and NodeHostname set from slurmd registration.
 -- SlurmctldParameters=power_save[_min]_interval - Configure how often the
    power save module looks to do work.
 -- Add CLOUD state to sinfo --state filter list.
 -- Add ability for sinfo state filtering to require all listed states.
 -- Add the "Reserved" license count to 'scontrol show licenses'.
 -- Don't display MailUser/MailType in scontrol show jobs if mail won't be sent.
 -- Throw an error and ignore CpuSpecList if it cannot be translated to bitmap
    of number of CPUs size.
 -- Validate at submission that --hint is mutully exclusive with --cpu-bind,
    --ntasks-per-core, --threads-per-core or -B.
 -- Make --exclusive the default with srun as a step adding --overlap to
    reverse behavior.
 -- Add --whole option to srun to allocate all resources on a node
    in an allocation.
 -- Allow --threads-per-core to influence task layout/binding.
 -- Remove support for "default_gbytes" option from SchedulerParameters.
 -- gres.conf - Add new MultipleFiles configuration entry to allow a single
    GRES to manage multiple device files simultaneously.
 -- Fix scontrol write config to output OverSubscribe intead of Shared.
 -- job_submit/lua - print/access oversubscribe variable with "oversubscribe".
 -- Remove SallocDefaultCommand option.
 -- Add support for an "Interactive Step", designed to be used with salloc to
    launch a terminal on an allocated compute node automatically.
 -- Add time specification: "now-<x>" (i.e. subtract from the present)
 -- Add IPv6 support. Must be explicitly enabled with EnableIPv6 in
    CommunicationParameters.
 -- Add LaunchParameters=mpir_use_nodeaddr configuration option.
 -- Allow use of a target directory with "srun --bcast", and change the default
    filename to include the node name as well.
 -- Set -fno-omit-frame-pointer compiler flag.
 -- Add --mail-type=INVALID_DEPEND option to salloc, sbatch, and srun.
 -- Fix passing names with commas to the slurmdbd.
 -- squeue - put sorted start times of "N/A" or 0 at the end of the list.
 -- Add correspond_after_task_cnt to SchedulerParameters
 -- Fix node's not being considered unresponsive/down for ResumeTimeout after
    reboot or power_up.
 -- Change "scontrol reboot ASAP" to use next_state=resume logic.
 -- Exclude HetJobs from GANG scheduling operations.
 -- Add scrontab as a new command.
 -- Enable -lnodes=#:gpus=# in #PBS/qsub -l nodes syntax.
 -- Add admin-settable "Comment" field to each Node.
 -- Fix show runaway and/on hidden partitions for >= Operator.
 -- Add --ntasks-per-gpu option.
 -- Add --gpu-bind=single option.

* Changes in Slurm 20.02.8
==========================

* Changes in Slurm 20.02.7
==========================
 -- cons_tres - Fix DefCpuPerGPU
 -- select/cray_aries - Correctly remove jobs/steps from blades using NPC.
 -- Fix false positive oom-kill events on extern step termination when
    jobacct_gather/cgroup configured.
 -- Ensure SPANK prolog and epilog run without an explicit PlugStackConfig.
 -- Fix missing xstrdup which could result in slurmctld segfault on array jobs.
 -- Fix security issue in PrologSlurmctld and EpilogSlurmctld by always
    prepending SPANK_ to all user-set environment variables. CVE-2021-31215.

* Changes in Slurm 20.02.6
==========================
 -- Fix sbcast --fanout option.
 -- Tighten up keyword matching for --dependency.
 -- Fix "squeue -S P" not sorting by partition name.
 -- Fix segfault in slurmctld if group resolution fails during job credential
    creation.
 -- sacctmgr - Honor PreserveCaseUser when creating users with load command.
 -- Avoid attempting to schedule jobs on magnetic reservations when they aren't
    allowed.
 -- Always make sure we clear the magnetic flag from a job.
 -- In backfill avoid NULL pointer dereference.
 -- Fix Segfault at end of slurmctld if you have a magnetic reservation and
    you shutdown the slurmctld.
 -- Silence security warning when a Slurm is trying a job for a
    magnetic reservation.
 -- Have sacct exit correctly when a user/group id isn't valid.
 -- Remove extra \n from invalid user/group id error message.
 -- Detect when extern steps trigger OOM events and mark extern step correctly.
 -- pam_slurm_adopt - permit root access to the node before reading the config
    file, which will give root a chance to fix the config if missing or broken.
 -- Reset DefMemPerCPU, MaxMemPerCPU, and TaskPluginParam (among other minor
    flags) on reconfigure.
 -- Fix incorrect memory handling of mail_user when updating mail_type=none.
 -- Handle mail_user and mail_type independently.
 -- Fix thread-safety issue with assoc_mgr_get_admin_level().
 -- Ignore step features if equal to job features
 -- Fix slurmstepd segfault caused by incorrect strtok() usage.
 -- CRAY - Remove unneeded ATP spank plugin from ansible playbook.
 -- Fix core selection for exclusive step on nodes where CPUs == Cores.
 -- Fix topology aware scheduling reservations.
 -- Fix loading cpus_per_task on a job from state file.
 -- When a partition has no nodes fix estimate of max cpus possible on a job
    trying to run there.
 -- In cons_tres fix sorting functions to handle node/topo weight
    correctly.
 -- Fix regression in 20.02.5 where you couldn't request contraints with a
    simple & and a count.
 -- Limit the number of threads for servicing emails.
 -- Avoid possible double init race condition in assoc_mgr_lock().
 -- Add missing locks in slurm_cred_handle_reissue().
 -- Add missing locks in slurm_cred_revoked().
 -- Fix slurmctld segfault due to tight reconfigure RPC requests by serializing
    the RPC handler processing logic.
 -- Use _exit() instead exit() after fork().
 -- Perl API - fix hang reading config in configless environments.
 -- slurmrestd - request detailed node information to populate GRES fields.
 -- slurmrestd - request detailed job information to populate GRES fields.
 -- Fix job license update bug on array tasks or hetjob components.
 -- Fix job partition update bug on array tasks or hetjob components.
 -- Fix slurmctld segfault on _pick_best_nodes() when processing a job request
    with XOR'd constraints and no nodeset has the feature.
 -- Fix job requests rejected with incorrect NODE_CONFIG_UNAVAIL when nodes are
    actually only busy due to an overlapping MAINT reservation.
 -- Fix sacctmgr allowing the deletion of a user's default account.
 -- Fix srun and other Slurm commands running within a "configless" salloc
    terminal.
 -- MySQL - Correctly handle QOS deletion from assocation tables.
 -- Fix update of First_Cores flag in a reservation.
 -- Fix parsing of update reservation flags.
 -- Fix --switches for cons_tres.
 -- Retry connection on ETIMEDOUT in slurm_send_addr_recv_msgs.
 -- Fix wait for RPC_PROLOG_LAUNCH notification 2*MessageTimeout.
 -- Have slurm_send_addr_recv_msgs conn_timeout to match rpc_wait in slurmd.
 -- pam_slurm_adopt - operate correctly even if ConstrainRAMSpace is not
    enabled on the node by falling back to the cpuset, devices, or freezer
    subsystem instead.
 -- slurmrestd - use memmove() instead of memcpy() in string manipulation
    to avoid bugs related to overlapping memory regions.
 -- slurmrestd - avoid xassert() failure on duplicated headers in request.
 -- Remove stale 'ReqNodeNotAvail, Reserved for maintenance' message from
    pending jobs after a maintenance reservation ended.
 -- MySQL - Stop steps from printing when outside time range.
 -- Fixed kmem limit calculation to use MaxKmemPercent correctly.
 -- Fix initialization of cpuset.mems/cpus on uid cgroup subdir.
 -- MySQL - Remove potential race condition when sending updates to a cluster
    and commit_delay used.
 -- Avoid double free of step_record_t in the slurmctld when node is removed
    from config.
 -- cons_tres - fix regression regarding gpus with --cpus-per-task.
 -- Don't send job completion email for revoked federation jobs.
 -- PMIx - fix potential buffer overflows from use of unpackmem().
    CVE-2020-27745.
 -- X11 forwarding - fix potential leak of the magic cookie when sent as an
    argument to the xauth command. CVE-2020-27746.

* Changes in Slurm 20.02.5
==========================
 -- Fix leak of TRESRunMins when job time is changed with --time-min
 -- pam_slurm - explicitly initialize slurm config to support configless mode.
 -- scontrol - Fix exit code when creating/updating reservations with wrong
    Flags.
 -- When a GRES has a no_consume flag, report 0 for allocated.
 -- Fix cgroup cleanup by jobacct_gather/cgroup.
 -- When creating reservations/jobs don't allow counts on a feature unless
    using an XOR.
 -- Improve number of boards discovery
 -- Fix updating a reservation NodeCnt on a zero-count reservation.
 -- slurmrestd - provide an explicit error messages when PSK auth fails.
 -- cons_tres - fix job requesting single gres per-node getting two or more
    nodes with less CPUs than requested per-task.
 -- cons_tres - fix calculation of cores when using gres and cpus-per-task.
 -- cons_tres - fix job not getting access to socket without GPU or with less
    than --gpus-per-socket when not enough cpus available on required socket
    and not using --gres-flags=enforce binding.
 -- Fix HDF5 type version build error.
 -- Fix creation of CoreCnt only reservations when the first node isn't
    available.
 -- Fix wrong DBD Agent queue size in sdiag when using accounting_storage/none.
 -- Improve job constraints XOR option logic.
 -- Fix preemption of hetjobs when needed nodes not in leader component.
 -- Fix wrong bit_or() messing potential preemptor jobs node bitmap, causing
    bad node deallocations and even allocation of nodes from other partitions.
 -- Fix double-deallocation of preempted non-leader hetjob components.
 -- slurmdbd - prevent truncation of the step nodelists over 4095.
 -- Fix nodes remaining in drain state state after rebooting with ASAP option.

* Changes in Slurm 20.02.4
==========================
 -- srun - suppress job step creation warning message when waiting on
    PrologSlurmctld.
 -- slurmrestd - fix incorrect return values in data_list_for_each() functions.
 -- mpi/pmix - fix issue where HetJobs could fail to launch.
 -- slurmrestd - set content-type header in responses.
 -- Fix cons_res GRES overallocation for --gres-flags=disable-binding.
 -- Fix cons_res incorrectly filtering cores with respect to GRES locality for
    --gres-flags=disable-binding requests.
 -- Fix regression where a dependency on multiple jobs in a single array using
    underscores would only add the first job.
 -- slurmrestd - fix corrupted output due to incorrect use of memcpy().
 -- slurmrestd - address a number of minor Coverity warnings.
 -- Handle retry failure when slurmstepd is communicating with srun correctly.
 -- Fix jobacct_gather possibly duplicate stats when _is_a_lwp error shows up.
 -- Fix tasks binding to GRES which are closest to the allocated CPUs.
 -- Fix AMD GPU ROCM 3.5 support.
 -- Fix handling of job arrays in sacct when querying specific steps.
 -- slurmrestd - avoid fallback to local socket authentication if JWT
    authentication is ill-formed.
 -- slurmrestd - restrict ability of requests to use different authentication
    plugins.
 -- slurmrestd - unlink named unix sockets before closing.
 -- slurmrestd - fix invalid formatting in openapi.json.
 -- Fix batch jobs stuck in CF state on FrontEnd mode.
 -- Add a separate explicit error message when rejecting changes to active node
    features.
 -- cons_common/job_test - fix slurmctld SIGABRT due to double-free.
 -- Fix updating reservations to set the duration correctly if updating the
    start time.
 -- Fix update reservation to promiscuous mode.
 -- Fix override of job tasks count to max when ntasks-per-node present.
 -- Fix min CPUs per node not being at least CPUs per task requested.
 -- Fix CPUs allocated to match CPUs requested when requesting GRES and
    threads per core equal to one.
 -- Fix NodeName config parsing with Boards and without CPUs.
 -- Ensure SLURM_JOB_USER and SLURM_JOB_UID are set in SrunProlog/Epilog.
 -- Fix error messages for certain invalid salloc/sbatch/srun options.
 -- pmi2 - clean up sockets at step termination.
 -- Fix 'scontrol hold' to work with 'JobName'.
 -- sbatch - handle --uid/--gid in #SBATCH directives properly.
 -- Fix race condition in job termination on slurmd.
 -- Print specific error messages if trying to run use certain
    priority/multifactor factors that cannot work without SlurmDBD.
 -- Avoid partial GRES allocation when --gpus-per-job is not satisfied.
 -- Cray - Avoid referencing a variable outside of it's correct scope when
    dealing with creating steps within a het job.
 -- slurmrestd - correctly handle larger addresses from accept().
 -- Avoid freeing wrong pointer with SlurmctldParameters=max_dbd_msg_action
    with another option after that.
 -- Restore MCS label when suspended job is resumed.
 -- Fix insufficient lock levels.
 -- slurmrestd - use errno from job submission.
 -- Fix "user" filter for sacctmgr show transactions.
 -- Fix preemption logic.
 -- Fix no_consume GRES for exclusive (whole node) requests.
 -- Fix regression in 20.02 that caused an infinite loop in slurmctld when
    requesting --distribution=plane for the job.
 -- Fix parsing of the --distribution option.
 -- Add CONF READ_LOCK to _handle_fed_send_job_sync.
 -- prep/script - always call slurmctld PrEp callback in _run_script().
 -- Fix node estimation for jobs that use GPUs or --cpus-per-task.
 -- Fix jobcomp, job_submit and cli_filter Lua implementation plugins causing
    slurmctld and/or job submission CLI tools segfaults due to bad return
    handling when the respective Lua script failed to load.
 -- Fix propagation of gpu options through hetjob components.
 -- Add SLURM_CLUSTERS environment variable to scancel.
 -- Fix packing/unpacking of "unlinked" jobs.
 -- Connect slurmstepd's stderr to srun for steps launched with --pty.
 -- Handle MPS correctly when doing exclusive allocations.
 -- slurmrestd - fix compiling against libhttpparser in a non-default path.
 -- slurmrestd - avoid compilation issues with libhttpparser < 2.6.
 -- Fix compile issues when compiling slurmrestd without --enable-debug.
 -- Reset idle time on a reservation that is getting purged.
 -- Fix reoccurring reservations that have Purge_comp= to keep correct
    duration if they are purged.
 -- scontrol - changed the "PROMISCUOUS" flag to "MAGNETIC"
 -- Early return from epilog_set_env in case of no_consume.
 -- Fix cons_common/job_test start time discovery logic to prevent skewed
    results between "will run test" executions.
 -- Ensure TRESRunMins limits are maintained during "scontrol reconfigure".
 -- Improve error message when host lookup fails.

* Changes in Slurm 20.02.3
==========================
 -- Factor in ntasks-per-core=1 with cons_tres.
 -- Fix formatting in error message in cons_tres.
 -- Fix calling stat on a NULL variable.
 -- Fix minor memory leak when using reservations with flags=first_cores.
 -- Fix gpu bind issue when CPUs=Cores and ThreadsPerCore > 1 on a node.
 -- Fix --mem-per-gpu for heterogenous --gres requests.
 -- Fix slurmctld load order in load_all_part_state().
 -- Fix race condition not finding jobacct gather task cgroup entry.
 -- Suppress error message when selecting nodes on disjoint topologies.
 -- Improve performance of _pack_default_job_details() with large number of job
    arguments.
 -- Fix archive loading previous to 17.11 jobs per-node req_mem.
 -- Fix regresion validating that --gpus-per-socket requires --sockets-per-node
    for steps. Should only validate allocation requests.
 -- error() instead of fatal() when parsing an invalid hostlist.
 -- nss_slurm - fix potential deadlock in slurmstepd on overloaded systems.
 -- cons_tres - fix --gres-flags=enforce-binding and related --cpus-per-gres.
 -- cons_tres - Allocate lowest numbered cores when filtering cores with gres.
 -- Fix getting system counts for named GRES/TRES.
 -- MySQL - Fix for handing typed GRES for association rollups.
 -- Fix step allocations when tasks_per_core > 1.
 -- Fix allocating more GRES than requested when asking for multiple GRES types.

* Changes in Slurm 20.02.2
==========================
 -- Fix slurmctld segfault when checking no_consume GRES node allocation counts.
 -- Fix resetting of cloud_dns on a reconfigure.
 -- squeue - change output for dependency column to use "(null)" instead of ""
    for no dependncies as documented in the man page, and used by other columns.
 -- Clear node_cnt_wag after job update.
 -- Fix regression where AccountingStoreJobComment was not defaulting to 'yes'.
 -- Send registration message immediately after a node is resumed.
 -- Cray - Fix hetjobs when using only a single component in the step launch.
 -- Cray - Fix hetjobs launched without component 0.
 -- Cray - Quiet cookies missing message which is expected on for hetjobs.
 -- Fix handling of -m/--distribution options for across socket/2nd level by
    task/affinity plugin.
 -- Fix grp_node_bitmap error when slurmctld started before slurmdbd.
 -- Fix scheduling issue when there are not enough nodes available to run a job
    resulting in possible job starvation.
 -- Make it so mpi/cray_shasta appears in srun --mpi=list
 -- Don't requeue jobs that have been explicitly canceled.
 -- Fix error message for a regular user trying to update licenses on a running
    job.
 -- Fix backup slurmctld handling for logrotation via SIGUSR2.
 -- Fix reservation feature specification when looking for inactive features
    after active features fails.
 -- Prevent misleading error messages for reservation creation.
 -- Print message in scontrol when a request fails for not having enough nodes.
 -- Fix duplicate output in sacct with multiple resv events.
 -- auth/jwt - return correct gid for a given user. This was incorrectly
    assuming the users's primary group name matched their username.
 -- slurmrestd - permit non-SlurmUser/root job submission.
 -- Use host IP if hostname unknown for job submission for allocating node.
 -- Fix issue with primary_slurmdbd_resumed_operation trigger not happening
    on slurmctld restart.
 -- Fix race in acct_gather_interconnect/ofed on step termination.
 -- Fix typo of SlurmctldProlog -> PrologSlurmctld in error message.
 -- slurm.spec - add SuSE-specific dependencies for optional slurmrestd package.
 -- Fix FreeBSD build issues.
 -- Fixed sbatch not processing --ignore-pbs in batch script.
 -- Don't clear the qos_id of an invalid QOS.
 -- Allow a job that was once FAIL_[QOS|ACCOUNT] to be eligible again if
    the qos|account limitation is remedied.
 -- Fix core reservations using the FLEX flag to allow use of resources
    outside of the reservation allocation.
 -- Fix MPS without File with 1 GPU, and without GPUs.
 -- Add FreeBSD support to proctrack/pgid plugin.
 -- Fix remote dependency testing for meta job in job array.
 -- Fix preemption when dealing with a job array.
 -- Don't send remote non-pending singleton dependencies on federation update.
 -- slurmrestd - fix crash on empty query.
 -- Fix race condition which could lead to invalid references in backfill.
 -- Fix edge case in _remove_job_hash().
 -- Fix exit code when using --cluster/-M client options.
 -- Fix compilation issues in GCC10.
 -- Fix invalid references when federated job is revoked while in backfill loop.
 -- Fix distributing job steps across idle nodes within a job.
 -- Fix detected floating reservation overlapping.
 -- Break infinite loop in cons_tres dealing with incorrect tasks per tres
    request resulting in slurmctld hang.
 -- Send the current (not the previous) reason for a pending job to client
    commands like squeue/scontrol.
 -- Fix incorrect lock levels for select_g_reconfigure().
 -- Handle hidden nodes correctly in slurmrestd.
 -- Allow sacctmgr to use MaxSubmitP[U|A] as format options.
 -- Fix segfault when trying to delete a corrupted association.
 -- Fix setting ntasks-per-core when using --multithread.
 -- Only override job wait reason to priority if Reason=None or
    Reason=Resources.
 -- Perl API / seff - fix missing symbol issue with accounting_storage/slurmdbd.
 -- slurm.spec - add --with cray_shasta option.
 -- Downgrade "Node config differ.." error message if config_overrides enabled.
 -- Add client error when using --gpus-per-socket without --sockets-per-node.
 -- Fix nvml/rsmi debug statements making it to stderr.
 -- NodeSets - fix slurmctld segfault in newer glibc if any nodes have no
    defined features.
 -- ConfigLess - write out plugstack config to correct config file name in
    the config cache.
 -- priority/multifactor - gracefully handle NULL list of associations or array
    of siblings when calculating FairTree fairshare.
 -- Fix cons_tres --exclusive=user to allocate only requested number of CPUs.
 -- Add MySQL deadlock detection and automatic retry mechanism.
 -- Reject repeating floating reservations as they aren't supported.
 -- Fix testing of reservation flags that may be NO_VAL64.
 -- Fix _verify_node_state memory requested as --mem-per-gpu DefMemPerGPU.
 -- Fix DependencyNeverSatisfied not set as the job's state reason if
    kill_invalid_depend or --kill-on-invalid-dep are used.
 -- pam_slurm_adopt - explicitly call slurm_conf_init().
 -- configless - fix plugstack.conf handling for client commands.
 -- Set SLURM_JOB_USER and SLURM_JOB_UID in task_epilog correctly.
 -- slurmrestd - authenticate job submissions by SlurmUser properly.

* Changes in Slurm 20.02.1
==========================
 -- Improve job state reason for jobs hitting partition_job_depth.
 -- Speed up testing of singleton dependencies.
 -- Fix negative loop bound in cons_tres.
 -- srun - capture the MPI plugin return code from mpi_hook_client_fini() and
    use as final return code for step failure.
 -- Fix segfault in cli_filter/lua.
 -- Fix --gpu-bind=map_gpu reusability if tasks > elements.
 -- Make sure config_flags on a gres are sent to the slurmctld on node
    registration.
 -- Prolog/Epilog - Fix missing GPU information.
 -- Fix segfault when using config parser for expanded lines.
 -- Fix bit overlap test function.
 -- Don't accrue time if job begin time is in the future.
 -- Remove accrue time when updating a job start/eligible time to the future.
 -- Fix regression in 20.02.0 that broke --depend=expand.
 -- Reset begin time on job release if it's not in the future.
 -- Fix for recovering burst buffers when using high-availability.
 -- Fix invalid read due to freeing an incorrectly allocated env array.
 -- Update slurmctld -i message to warn about losing data.
 -- Fix scontrol cancel_reboot so it clears the DRAIN flag and node reason for a
    pending ASAP reboot.

* Changes in Slurm 20.02.0
==========================
 -- Fix minor memory leak in slurmd on reconfig.
 -- Fix invalid ptr reference when rolling up data in the database.
 -- Change shtml2html.py to require python3 for RHEL8 support, and match
    man2html.py.
 -- slurm.spec - override "hardening" linker flags to ensure RHEL8 builds
    in a usable manner.
 -- Fix type mismatches in the perl API.
 -- Prevent use of uninitialized slurmctld_diag_stats.
 -- Fixed various Coverity issues.
 -- Only show warning about root-less topology in daemons.
 -- Fix accounting of jobs in IGNORE_JOBS reservations.
 -- Fix issue with batch steps state not loading correctly when upgrading from
    19.05.
 -- Deprecate max_depend_depth in SchedulerParameters and move it to
    DependencyParameters.
 -- Silence erroneous error on slurmctld upgrade when loading federation state.
 -- Break infinite loop in cons_tres dealing with incorrect tasks per tres
    request resulting in slurmctld hang.
 -- Improve handling of --gpus-per-task to make sure appropriate number of GPUs
    is assigned to job.
 -- Fix seg fault on cons_res when requesting --spread-job.

* Changes in Slurm 20.02.0rc1
=============================
 -- sbatch - fix segfault when no newline at the end of a burst buffer file.
 -- Change scancel to only check job's base state when matching -t options.
 -- Save job dependency list in state files.
 -- cons_tres - allow jobs to be run on systems with root-less topologies.
 -- Restore pre-20.02pre1 PrologSlurmctld synchonization behavior to avoid
    various race conditions, and ensure proper batch job launch.
 -- Add new slurmrestd command/daemon which implements the Slurm REST API.

* Changes in Slurm 20.02.0pre1
==============================
 -- Avoid possible race when 2 conf files are read at the same exact time.
 -- Add last and mean backfill table size to sdiag output.
 -- Add support for additional job submit environment variables:
    SALLOC_MEM_PER_CPU, SALLOC_MEM_PER_NODE, SBATCH_MEM_PER_CPU and
    SBATCH_MEM_PER_NODE.
 -- Add 'Agent thread count' stat to sdiag.
 -- Add sdiag -M, --clusters option.
 -- NodeName configurations with CPUs != Sockets*Cores or
    Sockets*Cores*Threads will be rejected with fatal.
 -- Add scontrol write config <filename> option.
 -- Increase maximum number of hostlist ranges from 64k to 256k.
 -- Don't acquire unneeded locks in slurmctld _run_prolog thread.
 -- Fix sinfo/squeue sort by nodename/nodeaddr/hostname.
 -- Optimize getting wckey and associations usage.
 -- Keep SLURM_MPI_TYPE variable in srun when not set to 'none'.
 -- Remove slurm.spec-legacy packaging file.
 -- pam_slurm_adopt - with action_unknown=newest configured, pick a user job
    even when failing to get cgroup mtime.
 -- Fix "srun --export=" parsing to handle nested commas.
 -- Add default "reboot requested" reason to nodes when rebooting with scontrol.
 -- Duplicate PartitionName entries in slurm.conf will now fatal() instead of
    printing an error message and ignoring the successive records.
 -- Remove the smap command.
 -- Change exclusive behavior of a node to include all GRES on a node as well
    as the cpus.
 -- Append ": reboot issued" to node reason when reboot is issued from
    controller. Previously only happened when nextstate was specified.
 -- Add default jobname of "no-shell" for salloc --no-shell.
 -- Save reservation state when automatically shrinking nodes.
 -- Add slurm.conf option MaxDBDMsgs to control how many messages will be
    stored in the slurmctld before throwing them away when the slurmdbd is down.
 -- Change default SLURM_PMIX_TMPDIR to include user id to avoid potential
    conflicts on development systems running multiple Slurm instances.
 -- Return a newly added ESLURM_DEFER error and set a job state reason to
    FAIL_DEFER for immediate alloc requests if defer in SchedulerParameters.
 -- Make slurmctld fatal if unable to load a script or a job environment when
    building the launch job message.
 -- Removed the checkpoint plugin interface and all associated API calls.
 -- Add job_get_grace_time() functions to preempt plugins and refactor
    slurm_job_check_grace() to use them.
 -- Remove --disable-iso8601 configure option.
 -- Display StepId=<jobid>.batch instead of StepId=<jobid>.4294967294 in output
    of "scontrol show step". (slurm_sprint_job_step_info())
 -- Make it so you can have a grace time when preempting by requeue.
 -- Translate MpiDefault=openmpi to functionally-equivalent MpiDefault=none,
    and remove the mpi/openmpi plugin.
 -- burst_buffer/datawarp - add a set of % symbols that will be replaced by
    job details. E.g., %d will be filled in with the WorkDir for the job.
 -- Fix sacctmgr show events to support node list ranges.
 -- Add SchedulerParameters option bf_one_resv_per_job to disallow adding more
    than one backfill reservation per job.
 -- Allow sacctmgr to filter node events by states that are flags.
 -- Allow sacctmgr to filter node events by REBOOT state/flag.
 -- Add ability to set MailType and MailUser of job with scontrol.
 -- slurm_init_job_desc_msg() initializes mail_type as uint16_t. This allows
    mail_type to be set to NONE with scontrol.
 -- Add new slurm_spank_log() function to print messages back to the user from
    within a SPANK plugin. (This can be done with slurm_error() instead, but
    that will always prepend "error: " to every message which may lead to
    confusion.)
 -- Enforce specification of partition and ALL nodes with PART_NODES flag.
 -- Add 'promiscuous' flag to a reservation.
 -- Implement the idea of PURGE_COMP=timespec.
 -- SPANK - removed never-implemented slurm_spank_slurmd_init() interface. This
    hook has always been accessible through slurm_spank_init() in the
    S_CTX_SLURMD context instead.
 -- sbcast - add new BcastAddr option to NodeName lines to allow sbcast traffic
    to flow over an alternate network path.
 -- Add auth/jwt plugin.
 -- Add new 'scontrol token' subcommand.
 -- PMIx - improve performance of proc map generation.
 -- For a heterogeneous job to be considered for preemption all components must
    be eligible for preemption.
 -- Added JobCompParams to slurm.conf.
 -- Add configuration parameter DependencyParameters to slurm.conf.
 -- Deprecate kill_invalid_depend in SchedulerParameters and move it to new
    DependencyParameters.
 -- Enable job dependencies for any job on any cluster in the same federation.
 -- Stricter escaping of strings sent to Elasticsearch.
 -- Allow clusters to be added automatically to db at startup of ctld.
 -- Add AccountingStorageExternalHost slurm.conf parameter.
 -- Add support for srun -M<cluster> --jobid=# for existing remote allocations.
 -- Remove LicensesUsed from 'scontrol show config'.
 -- sbatch - adjusted backoff times for "--wait" option to reduce load on
    slurmctld. This results in a steady-state delay of 32s between queries,
    instead of the prior 10s delay.
 -- Add SchedulerParameters option bf_running_job_reserve to add backfill
    reservations for jobs running on whole nodes
 -- salloc/sbatch/srun - error on invalid --profile option strings.
 -- Remove max_job_bf option and replace with bf_max_job_test.
 -- Disable sbatch, salloc, srun --reboot for non-admins.
 -- jobcomp/elasticsearch - added connect_timeout and timeout options to
    JobCompParams.
 -- SPANK - added support for S_JOB_GID in the job script context with
    spank_get_item().
 -- Prolog/Epilog - add SLURM_JOB_GID environment variable.
 -- Add gpu/rsmi plugin to support AMD GPUs
 -- Make it so you can "stack" the energy plugins
 -- Add energy accounting plugin for AMD GPU

* Changes in Slurm 19.05.9
==========================

* Changes in Slurm 19.05.8
==========================
 -- sbatch - handle --uid/--gid in #SBATCH directives properly.
 -- Fix HDF5 type version build error.
 -- PMIx - fix potential buffer overflows from use of unpackmem().
    CVE-2020-27745.
 -- X11 forwarding - fix potential leak of the magic cookie when sent as an
    argument to the xauth command. CVE-2020-27746.

* Changes in Slurm 19.05.7
==========================
 -- Fix handling of -m/--distribution options for across socket/2nd level by
    task/affinity plugin.
 -- Fix grp_node_bitmap error when slurmctld started before slurmdbd.
 -- Fix compilation issues in GCC10.
 -- Fix distributing job steps across idle nodes within a job.
 -- Break infinite loop in cons_tres dealing with incorrect tasks per tres
    request resulting in slurmctld hang.
 -- priority/multifactor - gracefully handle NULL list of associations or array
    of siblings when calculating FairTree fairshare.
 -- Fix cons_tres --exclusive=user to allocate only requested number of CPUs.
 -- Add MySQL deadlock detection and automatic retry mechanism.
 -- Fix _verify_node_state memory requested as --mem-per-gpu DefMemPerGPU.
 -- Factor in ntasks-per-core=1 with cons_tres.
 -- Fix formatting in error message in cons_tres.
 -- Fix gpu bind issue when CPUs=Cores and ThreadsPerCore > 1 on a node.
 -- Fix --mem-per-gpu for heterogenous --gres requests.
 -- Fix slurmctld load order in load_all_part_state().
 -- Fix getting system counts for named GRES/TRES.
 -- MySQL - Fix for handing typed GRES for association rollups.
 -- Fix step allocations when tasks_per_core > 1.

* Changes in Slurm 19.05.6
==========================
 -- Fix OverMemoryKill.
 -- Fix memory leak in scontrol show config.
 -- Remove PART_NODES reservation flag after ignoring it at creation.
 -- Fix deprecation of MemLimitEnforce parameter.
 -- X11 forwarding - alter Xauthority regex to work when "FamilyWild" cookies
    are present in the "xauth list" output.
 -- Fix memory leak when utilizing core reservations.
 -- Fix issue where adding WCKeys and then using them right away didn't always
    work.
 -- Add cosmetic batch step to correct component in a hetjob.
 -- Fix to make scontrol write config create a usable config without editing.
 -- Fix memory leak when pinging backup controller.
 -- Fix issue with 'scontrol update' not enforcing all QoS / Association limits.
 -- Fix to properly schedule certain jobs with cons_tres plugin.
 -- Fix FIRST_CORES for reservations when using cons_tres.
 -- Fix sbcast -C argument parsing.
 -- Replace/deprecate max_job_bf with bf_max_job_test and print error message.
 -- sched/backfill - fix options parsing when bf_hetjob_prio enabled.
 -- Fix for --gpu-bind when no gpus requested.
 -- Fix sshare -l crash with large values.
 -- Fix printing NULL job and step pointers.
 -- Break infinite loop in cons_tres dealing with incorrect tasks per tres
    request resulting in slurmctld hang.
 -- Improve handling of --gpus-per-task to make sure appropriate number of GPUs
    is assigned to job.

* Changes in Slurm 19.05.5
==========================
 -- Fix both socket-[un]constrained GRES issues that would lead to incorrect
    GRES allocations and GRES underflow errors at deallocation time.
 -- Reject unrunnable jobs submitted to reservations.
 -- Fix misleading error returned for immediate allocation requests when defer
    in SchedulerParameters by decoupling defer from too fragmented logic.
 -- Fix printf format string error on FreeBSD.
 -- Fix parsing of delay_boot in controller when additional arguments follow it.
 -- Fix --ntasks-per-node in cons_tres.
 -- Fix array tasks getting same reject reason.
 -- Ignore DOWN/DRAIN partitions in reduce_completing_frag logic.
 -- Fix alloc_node validation when updating a job.
 -- Fix for requesting specific nodes when using cons_tres topology.
 -- Ensure x11 is setup before launching a job step.
 -- Fix incorrect SLURM_CLUSTER_NAME env var in batch step.
 -- Perl API - Fix undefined symbol for slurmdbd_pack_fini_msg.
 -- Install slurmdbd.conf.example with 0600 permissions to encourage secure
    use. CVE-2019-19727.
 -- srun - do not continue with job launch if --uid fails. CVE-2019-19728.

* Changes in Slurm 19.05.4
==========================
 -- Don't allow empty string as a reservation name; generate a name if empty
    string is provided.
 -- Fix salloc segfault when using --no-shell option.
 -- Fix divide by zero when normalizing partition priorities.
 -- Restore ability to set JobPriorityFactor to 0 on a partition.
 -- Fix multi-partition non-normalized job priorities.
 -- Adjust precedence between --mem-per-cpu and --mem-per-node to enforce
    them as mutually exclusive. Specifying either on the command line will
    now explicitly override any value inherited through the environment.
 -- Always print node's version, if it exists, in scontrol show nodes.
 -- sbatch - ensure SLURM_NTASKS_PER_NODE is exported when --ntasks-per-node
    is set.
 -- slurmctld - fix memory leak when using DebugFlags=Reservation.
 -- Reset --mem and --mem-per-cpu options correctly when using --mem-per-gpu.
 -- Use correct function signature for step_set_env() in gres plugin interface.
 -- Restore pre-19.05 hostname handling behavior for AllocNodes by always
    truncating to just the host portion and dropping any domain name portion
    returned by gethostbyaddr().
 -- Fix abort initializing a configuration without acct_gather.conf.
 -- Fix GRES binding and CLOUD nodes GRES setup regressions.
 -- Make sview work with glib2 v2.62.
 -- Fix slurmctld abort when in developer mode and submitting to multiple
    partitions with a bad QOS and not enforcing QOS.
 -- Enforce PART_NODES if only PartitionName is specified.
 -- Fix slurmd -G functionality.
 -- Fix build on 32-bit systems.
 -- Remove duplicate log entry on update job.
 -- sched/backfill - fix the estimated sched_nodes for multi-part jobs.
 -- slurm.spec - fix pmix_version global context macro.
 -- Fix cons_tres topology logic incorrectly evaluating insufficient resoruces.
 -- Fix job "--switches=count@time" option handling in cons_tres topology.
 -- scontrol - allow changes to the WorkDir for pending jobs.
 -- Enable coordinators to delete users if they only belong to accounts that
    the coordinator is over.
 -- Fix regression on update from older versions with DefMemPerCPU.
 -- Fix issues with --gpu-bind while using cgroups.
 -- Suspend nodes after being down for SuspendTime.
 -- Fix rebooting nodes from skipping nextstate states on boot.
 -- Fix regression in reservation creation logic from 19.05.3 which would
    incorrectly deny certain valid reservations from being created.
 -- slurmdbd - process sacct/sacctmgr job queries from older clients correctly.

* Changes in Slurm 19.05.3-2
============================
 -- Fix missing include for Cray Aries systems.

* Changes in Slurm 19.05.3
==========================
 -- Fix missing check from conversion of cray -> cray_aries.
 -- Improve job state reason string when required nodes are not available by
    not including those that don't belong to the job partition.
 -- Set a more appropriate ESLURM_RESERVATION_MAINT job state reason for jobs
    requesting feature(s) and required nodes are in a maintenance reservation.
 -- Fix logic to better handle maintenance reservations.
 -- Add spank options to cache in remote callback.
 -- Enforce the use of spank_option_getopt().
 -- Fix select plugins' will run test under-allocating nodes usage for
    completing jobs.
 -- Nodes in COMPLETING state treated as being currently available for job
    will-run test.
 -- Cray - fix contribs slurm.conf.j2 with updated cray_aries plugin names.
 -- job_submit/lua - fix problem where nil was expected for min_mem_per_cpu.
 -- Fix extra, unaccounted TRESRunMins usage created by heterogeneous jobs when
    running with the priority/multifactor plugin.
 -- Detach threads once they are done to avoid having to join them
    in track scripts code.
 -- Handle situation where a slurmctld tries to communicate with slurmdbd more
    than once at the same time.
 -- Fix XOR/XAND features like cpu&fastio&[knl|westmere] to be resolved
    correctly.
 -- Don't update [min|max]_exit_code on job array task requeue.
 -- Don't assume the first node of a job is the batch host when testing if the
    job's allocated nodes are booted/ready.
 -- Make --batch=<feature> requests wait for all nodes to be booted so that it
    can choose the batch host after the nodes have been booted -- possibly with
    different features.
 -- Fix talking to batch host on it's protocol version when using --batch.
 -- gres/mic plugin - add missing fini() function to clean up plugin state.
 -- Move _validate_node_choice() before prolog/epilog check.
 -- Look forward one week while create new reservation.
 -- Set mising resv_desc.flags before call _select_nodes().
 -- Use correct start_time for TIME_FLOAT reservation in _job_overlap().
 -- Properly enforce a job's mem-per-cpu option when allocate the node
    exclusively to that job.
 -- sched/backfill - clear estimated sched_nodes as done for start_time.
 -- Have safe_[read|write] handle EAGAIN and EINTR.
 -- Fix checking for flag with logical AND.
 -- Correct "extern" definition of variable if compiling with __APPLE__.
 -- Deprecate FastSchedule. FastSchedule will be removed in 20.02.
    The FastSchedule=2 functionality (used for testing and development) has
    been retained as the new SlurmdParameters=config_overrides option.
 -- Fix preemption issue when picking nodes for a feature job request.
 -- Fix race condition preventing held array job from getting a db_index.
 -- Fix select/cons_tres gres code infinite loop leaving slurmctld unresponsive.
 -- Remove redefinition of global variable in gres.c
 -- Fix issue where GPU devices are denied access when MPS is enabled.
 -- Fix uninitialized errors when compiling with CFLAGS="--coverage".
 -- Fix scancel --full for proctrack/cgroups.
 -- Fix sdiag backfill last and mean queue length stats.
 -- Do not remove batch host when resizing/shrinking a batch job.
 -- nss_slurm - fix file descriptor leaks.
 -- Fix preemption for jobs using complex feature requests
    (e.g. -C "[rack1*2&rack2*4]").
 -- Fix memory leaks in preemption when jobs request multiple features.
 -- Allow Operator users to show/fix runaways.
 -- Disallow coordinators to show/fix runaways.
 -- mpi/pmi2 - increase array len to avoid buffer size exceeded error.
 -- Preserve rebooting node's nextstate when updating state with scontrol.
 -- Fully merge slurm.conf and gres.conf before node_config_load().
 -- Remove FastSchedule dependence from gres.conf's AutoDetect=nvml.
 -- Forbid mix of typed and untyped GRES of same name in slurm.conf.
 -- cons_tres: Prevent creating a job without CPUs.
 -- Prevent underflow when filtering cores with gres.
 -- proctrack/cray_aries: use current pid instead of thread if we're in a fork.
 -- Fix missing check for prolog launch credential creation failure that can
    lead to segfaults.

* Changes in Slurm 19.05.2
==========================
 -- Wrap END_TIMER{,2,3} macro definition in "do {} while (0)" block.
 -- Allow account coordinators to add users who don't already have an
    association with any account.
 -- If only allowing particular alloc nodes in a partition, deny any request
    coming from an alloc node of NULL.
 -- Prevent partial-load of plugins which can leave certain interfaces in
    an inconsistent state.
 -- Remove stray __USE_GNU macro definitions from source.
 -- Fix loading fed state by backup on subsequent takeovers.
 -- Add missing job read lock when loading fed job state.
 -- Add missing fed_job_info jobs if fed state is lost.
 -- Do not build cgroup plugins on FreeBSD or NetBSD, and use proctrack/pgid
    by default instead.
 -- Do not build switch/cray_aries plugin on FreeBSD, NetBSD, or macOS.
 -- Fix build on FreeBSD.
 -- Fix race condition in route/topology plugin.
 -- In munge decode set the alloc_node field to the text representation of an
    IP address if the reverse lookup fails.
 -- Fix infinite loop in slurmstepd handling for nss_slurm REQUEST_GETGR RPC.
 -- Fix slurmstepd early assertion fail which prevented batch job launch or
    tasks launch on non-Linux systems.
 -- Fix regression with SLURM_STEP_GPUS env var being renamed SLURM_STEP_GRES.
 -- Fix pmix v3 linking if no rpath is allowed on build.
 -- Fix sacctmgr error handling when removing associations and users.
 -- Allow sacctmgr to add users to WCKeys without having TrackWCKey set in the
    slurm.conf.
 -- Allow sacctmgr to delete WCKeys from users.
 -- Change GRES type set by gpu/gpu_nvml plugin to be more specific - based
    on device name instead of brand name.
 -- cli_filter - fix logic error with option lookup functions.
 -- Fix bad testing of NodeFeatures debug flag in contribs/cray.
 -- Cleanup track_script code to avoid race conditions and invalid memory
    access.
 -- Fix jobs being killed after being requeued by preemption.
 -- Make register nodes verify correctly when using cons_tres.
 -- Fix srun --mem-per-cpu being ignored.
 -- Fix segfault in _update_job() under certain conditions.
 -- job_submit/lua - restore slurm.FAILURE as a synonym for slurm.ERROR.

* Changes in Slurm 19.05.1-2
============================
 -- Fix mistake in QOS time limit calculations for UsageFactor != 0 with any
    combination of flags set.

* Changes in Slurm 19.05.1
==========================
 -- accounting_storage/mysql - fix incorrect function names in error messages.
 -- accounting_storage/slurmdbd - trigger an fsync() on the dbd.messages state
    file to ensure it is committed to disk properly.
 -- Avoid JobHeldUser state reason from being updated at allocation time.
 -- Fix dump/load of rejected heterogeneous jobs.
 -- For heterogeneous jobs, do not count the each component against the QOS or
    association job limit multiple times.
 -- Comment out documentation for the incomplete and currently unusable
    burst_buffer/generic plugin.
 -- Add new error ESLURM_INVALID_TIME_MIN_LIMIT to make note when a time_min
    limit is invalid based on timelimit.
 -- Correct slurmdb cluster record pack with NULL pointer input.
 -- Clearer error message for ESLURM_INVALID_TIME_MIN_LIMIT.
 -- Fix SchedulerParameter bf_min_prio_reserve error when not the last parameter
 -- When fixing runaway jobs, change to reroll from earliest submit time, and
    never reroll from Unix epoch.
 -- Display submit time when running sacctmgr show runawayjobs and add format
    option to display eligible time.
 -- jobcomp/elasticsearch - fix minor race related to JobCompLoc setup.
 -- For HetJobs, ensure SLURM_PACK_JOB_ID is set regardless of whether
    PrologFlags=Alloc is enabled.
 -- Fix PriorityFlags regression with the mutation of FAIR_TREE to NO_FAIR_TREE.
 -- select/cons_res - fix debug flag SelectType handling in select_p_job_test.
 -- Fix sacctmgr archive dump commit confirmation.
 -- Prevent extra resources from being allocated when combining certain flags.
 -- Cray - fix template generator with update cray_aries plugin names.
 -- accounting_storage/slurmdbd - provide additional detail in several error
    messages.
 -- Backfill - If a job has a time_limit guess the end time of a job better
    if OverTimeLimit is Unlimited.
 -- Remove premature call to get system gpus before querying fake gpus that
    should override the real.
 -- Fix segfault in epilog_set_env() when gres_devices is NULL.
 -- Fix (un)supported states in sacct.
 -- Adjust build system to no longer use the AC_FUNC_MALLOC autoconf macro.
 -- srun - restore the --cpu_bind option to srun.
 -- Add UsageFactorSafe QOS flag to control applying UsageFactor at
    submission/scheduling time.
 -- Create missing reservations on DBD_MODIFY_RESV.
 -- Add error message when attempting to update association manager and object
    doesn't exist.
 -- Fix security issue in accounting_storage/mysql plugin on archive file loads
    by always escaping strings within the slurmdbd. CVE-2019-12838.

* Changes in Slurm 19.05.0
==========================
 -- Fix deprecated group by clause to use order by.
 -- NVML - Git rid of unneeded * when passing nvmlDevice_t to functions.
 -- NVML - Fix clang warning about unneeded variable initialization.
 -- NVML - remove unneeded {}.
 -- Add timers to new site_factor plugin APIs to warn of slow-running plugins,
    which can lead to issues with throughput and responsiveness.
 -- X11 forwarding - ignore screen value for local DISPLAY.
 -- Add missing locks protecting slurmctld_config.server_thread_count access.
 -- Fix jobs stuck from FedJobLock when requeueing in a federation
 -- Fix requeueing job in a federation of clusters with differing associations
 -- sacctmgr - free memory before exiting in 'sacctmgr show runaway'.
 -- Fix seff showing memory overflow when steps tres mem usage is 0.
 -- Fix memory leaks in 'sacctmgr show runawayjobs'.
 -- Fix potential deadlock in nss_slurm.
 -- Fix memory leaks due to incomplete slurmdb_cluster_cond_t destructor.
 -- Alter reservation flags column in slurmdbd to use uint64_t instead of
    uint16_t to ensure all current flags are saved correctly. Older releases
    unfortunately could not store details for newer flags (using bits 17-32)
    due to this field being silently truncated.
 -- Modify task layout with --overcommit option plus a heterogeneous job
    allocation so that a cyclic task distribution can start happening before
    all CPUs on all nodes are fully allocated. The number of tasks per node
    will be unchanged from the previous algorithm, but tasks will be distributed
    in a cyclic fashion first and then extra tasks placed on nodes with more
    CPUs. Previously all CPUs would be fully allocated in a cyclic fashion,
    then excess tasks distributed evenly across all allocated nodes.
 -- In select/cons_tres: Only allocate 1 CPU per node with the --overcommit
    option.
 -- In select/cons_res: Only allocate 1 CPU per node with the --overcommit and
    --nodelist options.
 -- Fix DefMemPer[CPU|Node] assignment on multi-partition job requests.
 -- Fix wrongly setting start_time to 0 for multi-part jobs.
 -- Upon archive file name collision, create new archive file instead of
    overwriting the old one to prevent lost records.
 -- Limit archive files to 50000 records per file so that archiving large
    databases will succeed.
 -- Remove stray newlines in SPANK plugin error messages.
 -- Fix archive loading events.
 -- In select/cons_res: Only allocate 1 CPU per node with the --overcommit and
    --nodelist options.
 -- Fix main scheduler from potentially not running through whole queue.
 -- Fix variable initiation to avoid slurmctld abort.
 -- In partition preemption, sort preemptor jobs only if they overlap a
    preemtable partition.
 -- cons_tres/dist_tasks - fix variable usage in cyclic distribution.
 -- cons_res/job_test - prevent a job from overallocating a node memory.
 -- cons_res/job_test - fix to consider a node's current allocated memory when
    testing a job's memory request.
 -- Fix issue where multi-node job steps on cloud nodes wouldn't finish cleaning
    up until the end of the job (rather than the end of the step).
 -- Fix packing pack_jobid in an sbcast.
 -- Fix GCC 9 compiler warnings.
 -- Add new job bit_flags of JOB_DEPENDENT.
 -- Make it so dependent jobs reset the AccrueTime and do not count against any
    AccrueTime limits.
 -- Fix sacctmgr --parsable2 output for reservations and tres.
 -- In multi-node systems make sure GRES are found on node when not bound to
    specific sockets.
 -- Fix gres-per-task logic for gres not bound to sockets.
 -- Fix issue when --gpus plus --cpus-per-gres was forcing socket binding
    unnecessarily.
 -- Change event table's state column to handle 32bits.
 -- Prevent slurmctld from potential segfault after job_start_data() called
    for completing job.
 -- Fix jobs getting on nodes with "scontrol reboot asap".
 -- Record node reboot events to database.
 -- Fix node reboot failure message getting to event table.
 -- Don't write "(null)" to event table when no event reason exists.
 -- Fix invalid memory read in cons_tres.
 -- Fix minor memory leak when clearing runaway jobs.
 -- Avoid flooding slurmctld and logging when prolog complete RPC errors occur.
 -- Fix slurmctld node_scheduler's feature_bitmap memory leak.
 -- Fatal when reading config if Alloc flag configured on FrontEnd mode.
 -- Modifications needed to run Federations with clusters running
    different select/switch plugins.
 -- Fix Clang errors for zero initializing struct with nested arrays.
 -- Fix minor memory leak in pmi2.
 -- MySQL - Fix minor memory leak when quering suspended jobs fails.
 -- Fix seff human readable memory string for values below a megabyte.
 -- Avoid slurmctld abort if GRES defined in gres.conf, but not in the node
    configuration of slurm.conf.
 -- Calculate task count for job with --gpus-per-task option, but no explicit
    task count.

* Changes in Slurm 19.05.0rc1
=============================
 -- Set CUDA_VISIBLE_DEVICES environment variable in Prolog and Epilog for jobs
    requesting gres/gpu.
 -- Remove '-U' argument - which was deprecated when '-A' was made the single
    character option before the Slurm 2.1 release - as an alternative to
    '--account' for salloc/sbatch/srun.
 -- Remove direct BLCR support and srun_cr.
 -- Make slurm_print_node_table only print a node's slurmd version if it is
    different to the one reported by slurm_load_ctl_conf.
 -- Call gres plugin environment setup even if gres not requested in job.
 -- Do not set CUDA_VISIBLE_DEVICES=NoDevFiles when no gres requested.
 -- If GRES configuration data is unavailable from gres.conf, then use the
    node's "Gres=" information slurm.conf. This will eliminate or minimize the
    gres.conf file in many situations.
 -- Fix checking IPMI XCC raw command response length.
 -- jobacct_gather/common - improve lightweight process identification.
 -- Cloud/PowerSave Improvements:
    - Better repsonsiveness to resuming and suspending.
    - Powering down nodes not eligible to be allocated until after
      SuspendTimeout.
    - Powering down nodes put in "Powering Down / %" state until after
      SuspendTimeout.
 -- Add idle_on_node_suspend SlurmctldParameter to make nodes idle regardless
    of state when suspended.
 -- Add PowerSave DebugFlag for Suspend/Resume debugging.
 -- Changed "scontrol reboot" to not default to ALL nodes.
 -- Changed "scontrol completing" to include two new fields - EndTime and
    CompletingTime.
 -- select/cons_tres - prevent job from overallocating a node memory.
 -- Refactor CLI option parsing for salloc/sbatch/srun into a central set of
    functions in src/common/slurm_opt.c. Note that this new option parsing can
    be stricter in a few specific situations - places that used to ignore
    invalid options and still submit/launch a job or job step may return an
    error() and refuse to proceed instead.
 -- Add preempt_send_user_signal SlurmctldParameter option to send user
    signal (e.g. --signal=<SIG_NUM>) at preemption if it hasn't already been
    sent.
 -- Add PreemptExemptTime parameter to slurm.conf and QOS to guarantee a
    minimum runtime before preemption.
 -- Set job's preempt time for non-grace time preemptions.
 -- Add sinfo format option to show used gres.
 -- Add reboot_from_controller SlurmctldParameter to allow RebootProgram to be
    run from the controller instead of the slurmds.
 -- Fix increasing of job size when extern steps exist.
 -- Reset GPU-related arguments to salloc/sbatch/srun for each separate
    heterogeneous job component.
 -- Do not set "(null)" for SLURM_JOB_CONSTRAINTS when no constraints are set
    in PrologSlurmctld/EpilogSlurmctld.
 -- Add SRUN_EXPORT_ENV as an input environment variable to srun.
 -- Return an error for invalid #SBATCH directives, and do not submit the job.
 -- Add S_JOB_ARRAY_ID and S_JOB_ARRAY_TASK_ID to spank_get_item().
 -- Change container_{g,p}_add_pid() to container_{g,p}_join() and remove the
    'pid_t pid' argument.
 -- Add new site_factor plugin type to permit sites to build plugins to set
    and modify the site priority factor value both initially on job submission,
    and periodically every PriorityCalcPeriod.
 -- Rename Cray plugins cray_aries in preperation for Cray/Shasta.
 -- Allow Het Jobs to work on a Cray.
 -- Add new cli_filter plugin type to permit sites to build plugins to log,
    modify, or reject CLI options within the salloc/sbatch/srun commands
    themselves.
 -- Allocate nodes that are booting. Previously, nodes that were being booted
    were off limits for allocation. This caused more nodes to be booted than
    needed in a cloud environment.
 -- pam_slurm_adopt - inject SLURM_JOB_ID environment variable into adopted
    processes.
 -- PMIx - use the Tree-based collective for empty fence operations.
 -- PMIx - replace use of the non-standard PMIX_VAL_SET macro with the
    standardized PMIX_VALUE_LOAD macro.
 -- slurm.spec - change --without cray option to set configure option of
    --enable-really-no-cray.
 -- slurm.spec - add new --with slurmsmwd option.
 -- pmi2: add mutex locking to all API calls to ensure thread-safety.
 -- Fix QOS usage factor to apply to TRES time limits and usage.
 -- Fix multi-cluster srun's with Select/Cray and other_cons_res.

* Changes in Slurm 19.05.0pre3
==============================
 -- Fix RPM packaging for accounting_storage/mysql.

* Changes in Slurm 19.05.0pre2
==============================
 -- Removed select/serial plugin.
 -- Remove 512-character line length limit in slurm_print_topo_record().
    (Used by "scontrol show topology".)
 -- Removed crypto/openssl plugin.
 -- Tweak the sdiag gettimeofday() line format for greater clarity.
 -- Add support for SALLOC/SBATCH/SLURM_NO_KILL environment variables.
    Add salloc/sbatch/srun support for optional "--no-kill=off" option to
    disable the environment variables.
 -- Fix salloc and missing SLURM_NTASKS.
 -- Alter the backfill scheduler behavior to prevent it from scheduling lower
    priority jobs on resources that become available during the backfill
    scheduling cycle when bf_continue is enabled. This behavior was available
    as the bf_ignore_newly_avail_nodes option in 18.08.4+, but is now enabled
    by default. (The SchedulerParameters option of bf_ignore_newly_avail_nodes
    is also now removed, although harmless if still set.)
 -- Make LaunchParameters=send_gids the default introducing the reverse option
    "disable_send_gids to go back to the original behavior.
 -- Limit pam_slurm_adopt to run only in the sshd context by default, for
    security reasons. A new module option 'service=<name>' can be used to
    allow a different PAM applications to work. The option 'service=*' can be
    used to restore the old behavior of always performing the adopt logic
    regardless of the PAM application context.
 -- pam_slurm_adopt: Use uid to determine whether root is logging.
 -- Remove sbatch --x11 option. Slurm's internal X11 forwarding is now only
    supported from salloc, or an allocating srun command.
 -- Suppressed printing of job id in sbatch when quiet flag is set.
 -- Changed sreport 'SizesByAccount' and 'SizesByAccountAndWckey' default
    behavior and added new 'AcctAsParent' option.
 -- Add ave watts to api and sview.
 -- Added printf attribute to setenvf() and corrected related warnings.
 -- Kill running/pending job is allocated GRES and that GRES has a "File"
    configuration, and the GRES count changes.
 -- Add new DebugFlag=Accrue for accrue accounting debugging purposes.
 -- Change CryptoType option to CredType, and rename crypto/munge plugin to
    cred/munge.
 -- Add slurmd -G option to print GRES configuration and exit. This is useful
    for testing and debugging.
 -- Support GRES types that include numbers (e.g. "--gres=gpu:123g:2").
 -- Remove MemLimitEnforce parameter and move functionality into
    JobAcctGatherParam=OverMemoryKill.
 -- sview - disable admin mode option (which would not work anyways) if the
    user is not an admin in SlurmDBD.
 -- Remove joules reporting from sview and scontrol.
 -- Change the default fair share algorithm to "fair tree". The new
    PriorityFlags option of NO_FAIR_TREE can be used to revert to "classic"
    fair share scheduling instead.
 -- libslurmdb has been merged into libslurm.
 -- Added -b as a short option for --begin and removed the -b option which
    was a left over artifact from the Moab compatibility work.
 -- Add ArrayTaskThrottle to "scontrol show job" output.
 -- Added SPRIO_FORMAT env variable to the sprio command.
 -- Add batch step at the beginning of a batch job so that squeue, sstat, and
    sacct will show the batch step.
 -- Deprecated 32-bit builds.
 -- Make -l and -o mutually exclusive in saccct, squeue, sinfo, and sprio
 -- Disable running job expansion by default. A new SchedulerParameter of
    permit_job_expansion has been added for sites that wish to re-enable it.
 -- Permit changing a job array's ArrayTaskThrottle value even if the job is
    terminated (for job requeue).
 -- Add scontrol requeue option of "Incomplete" which will requeue jobs only if
    they failed to complete with an exit code of zero.
 -- Modify GrpNodes limit to apply to unique nodes allocated (avoid double
    counting nodes allocated to multiple jobs in the same QOS or association).
 -- If a job submit does NOT include --cpus-per-task option, then report the
    value as "N/A" rather than always mapping the value to 1.
 -- X11 forwarding - use the raw value from gethostname() with xauth to avoid
    authentication issues when Slurm has internally stripped off the domain
    portion.
 -- Change how slurmd fills in the registration message version string from
    PACKAGE_VERSION to SLURM_VERSION_STRING, affecting how the version is
    displayed with sview, sinfo, scontrol and through the API.
 -- Remove autogen.sh script. Please use the autoreconf command instead.
 -- Disable a configuration of SelectTypeParameters=CR_ONE_TASK_PER_CORE with
    SelectType=select/cons_tres. This will be addressed later.
 -- job_submit/lua - expose more fields off the partition record.
 -- task/cgroup - prevent setting a memory.soft_limit_in_bytes higher than the
    memory.limit_in_bytes since the hard limit will take precedence anyway.
 -- If a GrpNodes limit is configurated in an association, partition QOS or
    job QOS then favor use of nodes already allocated to that entity. This
    will result in the configured node "Weight" being incremented by one for
    nodes which are not prefered. Consider adjusting configured node "Weight"
    values to achieve the desired node preferences.
 -- Add full node state debug2 output to slurmdbd node up/down update
 -- Set CUDA_VISIBLE_DEVICES and CUDA_MPS_ACTIVE_THREAD_PERCENTAGE environment
    variables in Prolog and Epilog for jobs requesting gres/mps.
 -- Added thresholds for backfill parameters.
 -- Fix for backfill sleep overflow when large values are set.
 -- Execute Epilog on nodes reliquished from job (i.e. job resized).
 -- Rename burst_buffer/cray plugin to burst_buffer/datawarp.
 -- X11 Forwarding - reimplement using new internal network forwarding RPCs.
 -- Remove slurm_jobcomp_get_errno and slurm_jobcomp_strerror from jobcomp
    plugin API.
 -- Optimize backfill for checking max jobs per assoc, partition, user, etc.

* Changes in Slurm 19.05.0pre1
==============================
 -- Run epilog and clean up allocation when a job is resized to zero and its
    resources transferred to another job (--depend=expand).
 -- If GRES are associated with specific sockets, identify those sockets in the
    output of "scontrol show node". For example if all 4 GPUs on a node are
